webpackJsonp([0],{

/***/ 116:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var Pair = __webpack_require__(1423);

var PlainCollider = {

	initiate: function initiate(scene) {
		this.objects = [];
		this.currentCollGroupId = 0;
		this.collGroups = {};
		this.pairs = [];
		this.bouncyIndex = undefined;
		this.reporting = false;
		this.objectRemoved = false;
		this.scene = scene;
	},

	addObject: function addObject(object, vertices) {
		object.collider = [];
		// create an array of segments and assign it to the object
		vertices.forEach(function (body) {
			var clockWiseVertices = this.arrangeVerticesClockwise(body),
			    segments = clockWiseVertices.map(function (vertex, index, vertArray) {
				var point = new Phaser.Math.Vector2(vertex[0], vertex[1]),
				    nextIndex = index < vertArray.length - 1 ? index + 1 : 0,
				    dirV = new Phaser.Math.Vector2(vertArray[nextIndex][0] - vertex[0], vertArray[nextIndex][1] - vertex[1]),
				    normalVec = dirV.clone();

				normalVec.normalizeRightHand();
				normalVec.normalize();
				normalVec.scale(-1);

				return { point: point, direction: dirV, normal: normalVec };
			}, this);

			object.collider.push(segments);
		}, this);

		if (this.objects.length > 1) {
			object.colliderId = 1 + this.objects.reduce(function (maxId, curr, index, arr) {
				if (curr.colliderId > maxId) return curr.colliderId;
				return maxId;
			}, this.objects[0].colliderId);
		} else {
			object.colliderId = 1;
		}
		this.objects.push(object);

		object.on('destroy', function (obj) {
			var objIndex = this.objects.indexOf(obj);
			this.objects.splice(objIndex, 1);
		}, this);
	},

	updateCollider: function updateCollider(object, vertices) {
		object.collider = [];
		// create an array of segments and assign it to the object
		vertices.forEach(function (body) {
			var clockWiseVertices = this.arrangeVerticesClockwise(body),
			    segments = clockWiseVertices.map(function (vertex, index, vertArray) {
				var point = new Phaser.Math.Vector2(vertex[0], vertex[1]),
				    nextIndex = index < vertArray.length - 1 ? index + 1 : 0,
				    dirV = new Phaser.Math.Vector2(vertArray[nextIndex][0] - vertex[0], vertArray[nextIndex][1] - vertex[1]),
				    normalVec = dirV.clone();

				normalVec.normalizeRightHand();
				normalVec.normalize();
				normalVec.scale(-1);

				return { point: point, direction: dirV, normal: normalVec };
			}, this);

			object.collider.push(segments);
		}, this);
	},

	refreshPairs: function refreshPairs() {
		this.findAllPairs();
		/*this.pairs.sort(function(a, b){
  	var aMovabilityIndex = a.object1.movability * a.object2.movability,
  		bMovabilityIndex = b.object1.movability * b.object2.movability;
  		if (aMovabilityIndex<bMovabilityIndex) return -1;
  	return 1;
  })*/

		/*console.log(this.objects);
  console.log(this.objects.map(function(obj){
  	return obj.wallNumber;
  }, this));
  console.log(this.pairs);*/
	},

	sortPairsByPriority: function sortPairsByPriority() {
		this.pairs.sort(function (a, b) {
			var aCorrectionIndex = a.object1.lastCorrPriority * a.object2.lastCorrPriority,
			    bCorrectionIndex = b.object1.lastCorrPriority * b.object2.lastCorrPriority;

			if (aCorrectionIndex < bCorrectionIndex) return -1;
			return 1;
		});
	},

	findAllPairs: function findAllPairs() {
		/*objectArray = objectArray || this.objects;
  var objectArrayCopy = objectArray.slice(),
  	firstObject = objectArrayCopy.shift();
  	if (objectArrayCopy.length > 1)
  {
  	for (var i = 0; i<objectArrayCopy.length; i++)
  	{
  		var pair = new Pair(firstObject, objectArrayCopy[i], this.pairs);
  		this.pairs.push(pair);
  	}
  	this.findAllPairs(objectArrayCopy);
  } else {
  	var pair = new Pair(firstObject, objectArrayCopy[0], this.pairs);
  	this.pairs.push(pair);
  }*/
		/*var bouncyIndex = this.objects.findIndex(function(obj){
  	return obj.movability === 2;
  }, this);
  var bouncy = this.objects.splice(bouncyIndex, 1);
  this.objects.splice(0, 0, bouncy[0]);
  console.log(this.objects);*/

		this.objects.sort(function (a, b) {
			if (a.movability > b.movability) return 1;else if (a.movability === b.movability) {
				if (a.electric || a.cold) return -1;else if (b.electric || b.cold) return 1;
			}
			return -1;
		});

		this.pairs = [];
		for (var r = 0; r < this.objects.length; r++) {
			this.pairs[r] = [];
			for (var c = 0; c < this.objects.length; c++) {
				if (c > r) {
					if (this.objects[r].collWith.indexOf(this.objects[c].collGroup) >= 0 && this.objects[c].collWith.indexOf(this.objects[r].collGroup) >= 0) this.pairs[r][c] = new Pair(this.objects[r], this.objects[c], this);else this.pairs[r][c] = false;
				} else if (c === r) {
					this.pairs[r][c] = false;
				} else {
					this.pairs[r][c] = this.pairs[c][r];
				}
			}
		}
	},

	injectObjectInPairs: function injectObjectInPairs(newObject) {
		/*this.objects.forEach(function(object, index, arr){
  	if (index < arr.length - 1)
  	{
  		var pair = new Pair(object, newObject, this.pairs);
  		this.pairs.push(pair)
  	}
  }, this);
  	this.pairs.sort(function(a, b){
  	var aMovabilityIndex = a.object1.movability * a.object2.movability,
  		bMovabilityIndex = b.object1.movability * b.object2.movability;
  		if (aMovabilityIndex<bMovabilityIndex) return -1;
  	return 1;
  })*/
		//console.log('inject object called');
		//console.log(this.objects);
		this.pairs[this.objects.length - 1] = [];
		for (var c = 0; c < this.objects.length - 1; c++) {
			this.pairs[c][this.objects.length - 1] = new Pair(this.objects[c], newObject, this);
			this.pairs[this.objects.length - 1][c] = this.pairs[c][this.objects.length - 1];
		}
		this.pairs[this.objects.length - 1][this.objects.length - 1] = false;
	},

	removeObject: function removeObject(obj) {
		//console.log(obj.colliderId);
		/*var objIndex = this.objects.findIndex(function(entity){			
  	return entity.colliderId === obj.colliderId;
  }, this);
  if (objIndex >= 0)
  {
  	this.objects.splice(objIndex, 1);
  	this.pairs.splice(objIndex, 1);
  	this.pairs.forEach(function(pairRow){
  		pairRow.splice(objIndex, 1);
  	}, this);
  	this.objectRemoved = true;	
  }*/
		if (!this.objectRemoved) {
			//console.log('object remove called');
			this.pairs.splice(obj.colliderId, 1);
			this.pairs.forEach(function (pairRow) {
				pairRow.splice(obj.colliderId, 1);
			}, this);
			this.objectRemoved = true;
		}
	},

	arrangeVerticesClockwise: function arrangeVerticesClockwise(vertices) {
		// create array of vector out of vertices with start and direction vectors
		/*var segmentArray = vertices.map(function(vertex, index, vertArray){
  	var startPoint = new Phaser.Math.Vector2(vertex[0], vertex[1]),
  		nextIndex = (index < vertArray.length - 1)? index+1: 0,
  		dirV = new Phaser.Math.Vector2(vertArray[nextIndex][0] - vertex[0], vertArray[nextIndex][1] - vertex[1]);
  		return [startPoint, dirV]
  	}, this);
  	// find non intersecting normal in initial circut
  for (var v=0; v<vertices.length; v++)
  {
  	var currentV = vertices[v],
  		nextIndex = (v<vertices.length - 1)? v+1: 0,
  		nextV = vertices[nextIndex],
  		dirV = new Phaser.Math.Vector2(nextV[0] - currentV[0], nextV[1] - currentV[1]),
  		normV = dirV.clone();
  		normV.normalizeRightHand();
  	normV.scale(1000);
  		var centerVec = new Phaser.Math.Vector2((nextV[0] + currentV[0])*0.5, (nextV[1] + currentV[1])*0.5),
  		haveIntersection = false;
  		segmentArray.forEach(function(segment, index){
  		if (index != v) {
  			haveIntersection = haveIntersection || intersectSegSeg(centerVec, normV, segment[0], segment[1]);	
  		}				
  	}, this);
  		if (!haveIntersection) break;
  }
  	if (v === vertices.length) {
  	return vertices.slice();
  } else {
  	return vertices.slice().reverse();
  }*/

		// find point inside vertices
		if (vertices.length > 3) {
			var innerPoint = new Phaser.Math.Vector2((vertices[0][0] + vertices[2][0]) * 0.5, (vertices[0][1] + vertices[2][1]) * 0.5);
		} else {
			var innerPoint = new Phaser.Math.Vector2((vertices[0][0] + vertices[1][0]) * 0.5, (vertices[0][1] + vertices[1][1]) * 0.5);
		}

		var vertCopy = vertices.slice();
		vertCopy.sort(function (a, b) {
			var aVec = new Phaser.Math.Vector2(a[0] - innerPoint.x, a[1] - innerPoint.y),
			    bVec = new Phaser.Math.Vector2(b[0] - innerPoint.x, b[1] - innerPoint.y);

			if (aVec.angle() > bVec.angle()) {
				return 1;
			}
			return -1;
		}, this);

		return vertCopy;
	},

	rotateCollider: function rotateCollider(object, angle, rotPoint) {

		var rotateMatrix = new Phaser.Math.Matrix3();

		rotateMatrix.fromArray([Math.cos(angle), Math.sin(angle), 0, -Math.sin(angle), Math.cos(angle), 0, 0, 0]);

		object.collider.forEach(function (body) {
			body.forEach(function (segment) {
				segment.normal.add(segment.point);
				segment.normal.subtract(rotPoint);
				segment.normal.transformMat3(rotateMatrix);
				segment.normal.add(rotPoint);

				segment.direction.add(segment.point);
				segment.direction.subtract(rotPoint);
				segment.direction.transformMat3(rotateMatrix);
				segment.direction.add(rotPoint);

				segment.point.subtract(rotPoint);
				segment.point.transformMat3(rotateMatrix);
				segment.point.add(rotPoint);

				segment.direction.subtract(segment.point);
				segment.normal.subtract(segment.point);
			}, this);
		}, this);
	},

	registerNewCollGroup: function registerNewCollGroup(name) {
		this.collGroups[name] = this.currentCollGroupId;

		this.currentCollGroupId++;

		return this.collGroups[name];
	},

	assignCollGroup: function assignCollGroup(object, name) {
		object.collGroup = this.collGroups[name];
	},

	getPairsWithObject: function getPairsWithObject(object) {
		var pairsWithObject = this.pairs.filter(function (pair) {
			if (pair.object1.colliderId === object.colliderId || pair.object2.colliderId === object.colliderId) {
				return true;
			}
			return false;
		}, this);

		return pairsWithObject;
	},

	checkCollisionsWithObject: function checkCollisionsWithObject(object) {
		var pairs = this.getPairsWithObject(object);

		pairs.forEach(function (pair) {
			pair.checkPairCollision(false);
		}, this);
	},

	checkCollisions: function checkCollisions(objArray) {
		/*this.pairs.forEach(function(pair){
  	pair.checkPairCollision(true);
  }, this);*/
		if (this.objectRemoved) {
			//console.log('check collision called and object removed');
		}

		var currentPairCell = [0, 1],
		    queueStop = 0,
		    rowsToCheck = [],
		    totalCalledRows = [],
		    iterationCounter = 0;

		while (queueStop < this.objects.length && iterationCounter < 1000) {
			//if (this.reporting) console.log(this.pairs[currentPairCell[0]][currentPairCell[1]]);
			//console.log(nonCheckedPairs);
			var pair = this.pairs[currentPairCell[0]][currentPairCell[1]];
			if (iterationCounter > 900) {
				console.log('current cell ' + currentPairCell);
			}
			if (pair) {
				var pairCollided = pair.checkPairCollision();
				if (iterationCounter > 900) {
					console.log('pair collided ' + pairCollided);
				}
				if (pairCollided) {
					totalCalledRows.push(currentPairCell);
					if (rowsToCheck.indexOf(currentPairCell[1]) < 0) {
						rowsToCheck.push(currentPairCell[1]);
					}
					if (iterationCounter > 900) {
						console.log('rows needed check ' + rowsToCheck);
					}
				}
			} else {
				//if (iterationCounter > 900) console.log('no pair');
			}

			if (currentPairCell[1] === this.objects.length - 1) {
				if (rowsToCheck.length === 0) {
					queueStop++;
					currentPairCell = [queueStop, 0];
				} else {
					currentPairCell = [rowsToCheck.shift(), 0];
				}
			} else {

				currentPairCell = [currentPairCell[0], currentPairCell[1] + 1];
			}
			if (pair) iterationCounter++;
		}
		if (iterationCounter >= 1000) {
			console.log('out of while with iterations_____________________');
			//console.log(this.objects[6].constraints);
			//console.log(iterationCounter);
			/*var frequencyCounter = [];
   for (var i = 0; i<totalCalledRows.length; i++)
   {
   	var freqObj = {pair: totalCalledRows[i], frequency: 0};
   	for (var j = 0; j<totalCalledRows.length; j++)
   	{
   		if (totalCalledRows[i][0] === totalCalledRows[j][0] &&
   			totalCalledRows[i][1] === totalCalledRows[j][1])
   		{
   			freqObj.frequency++;
   		}
   	}
   	frequencyCounter.push(freqObj);
   }
   frequencyCounter.sort(function(a, b){
   	if (a.frequency > b.frequency) return -1;
   	return 1;
   });
   	console.log(frequencyCounter);
   console.log(frequencyCounter[0]);
   var object1 = this.objects[frequencyCounter[0].pair[0]],
   	object2 = this.objects[frequencyCounter[0].pair[1]];
   	console.log(object1);
   console.log(object1.lastCorrection);
   console.log(object1.lastCorrPriority);
   console.log(object2);
   console.log(object2.lastCorrection);
   console.log(object2.lastCorrPriority);
   console.log(this.pairs[frequencyCounter[0].pair[0]][frequencyCounter[0].pair[1]]);	*/
		}
		//else console.log(iterationCounter);
		//if (this.reporting) console.log('end of collision check');

		// gather information for collision particles

		//this.scene.collisionPoints = [];

		for (var i = 0; i < this.objects.length; i++) {
			for (var j = 0; j < i; j++) {

				var pair = this.pairs[j][i];

				if (pair) {
					if (pair.nowCollided && !pair.previouslyCollided) {
						//this.scene.collisionPoints.push(pair.collisionPoints[0]);
						//this.scene.collisionPoints.push(pair.collisionPoints[1]);
					}
					pair.updateCollisionStatus();
				}
			}
		}
	},

	updateObjectsIds: function updateObjectsIds() {
		if (this.objectRemoved) {
			//console.log('object collID update called');
			//console.log(this.objects);
			// update collider ids
			this.objects.forEach(function (entity, index) {
				entity.colliderId = Number(index);
			}, this);
			this.objectRemoved = false;
		}
	},


	drawColliders: function drawColliders(graphics) {
		graphics.clear();

		this.objects.forEach(function (object) {
			graphics.beginPath();
			object.collider.forEach(function (body) {
				body.forEach(function (segment, index, arr) {
					if (index === 0) {
						graphics.moveTo(segment.point.x, segment.point.y);
					} else {
						graphics.lineTo(segment.point.x, segment.point.y);
						if (index === arr.length - 1) {
							graphics.closePath();
							graphics.strokePath();
						}
					}
				}, this);
			}, this);
		}, this);
	},

	moveAll: function moveAll(delta) {
		this.objects.forEach(function (object) {
			object.updateVel(delta);
			object.x += object.vel.x;
			object.y += object.vel.y;
			object.collider.forEach(function (body) {
				body.forEach(function (segment) {
					segment.point.x += object.vel.x;
					segment.point.y += object.vel.y;
				}, this);
			}, this);
		}, this);

		/*this.pairs.forEach(function(pairRow){
  	pairRow.forEach(function(pair){
  		if (pair.collisionChecked) pair.collisionChecked = false;
  	}, this);			
  }, this);*/
	}

};

module.exports = PlainCollider;

/***/ }),

/***/ 1422:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlainCollider = __webpack_require__(116);
var wallGenerator = __webpack_require__(40);
var Wall = __webpack_require__(98);
var FreeDoor = __webpack_require__(524);
var MetalBox = __webpack_require__(1425);
var WoodBox = __webpack_require__(252);
var Bouncy = __webpack_require__(526);
var Finish = __webpack_require__(1426);
var LavaWall = __webpack_require__(527);
var Floor = __webpack_require__(1427);
var FuelCan = __webpack_require__(1428);
var ElectricFollower = __webpack_require__(1429);
var IceWall = __webpack_require__(1430);
var ColdWall = __webpack_require__(1431);
var MainWall = __webpack_require__(1432);
var defineOuterVertices = __webpack_require__(158);
var RocketateTypeDict = __webpack_require__(29);

var PlayScene = exports.PlayScene = function (_Phaser$Scene) {
    _inherits(PlayScene, _Phaser$Scene);

    function PlayScene() {
        _classCallCheck(this, PlayScene);

        return _possibleConstructorReturn(this, (PlayScene.__proto__ || Object.getPrototypeOf(PlayScene)).call(this, 'PlayScene'));
    }

    _createClass(PlayScene, [{
        key: 'preload',
        value: function preload() {

            // prepare textures for wall made in graphics factory
            this.preparedTextures = {};
            this.preparedShadows = {};

            wallGenerator.clearBin();

            if (this.game.levelNumber != 0) {
                this.levelName = 'level' + this.game.levelNumber;
                this.level = this.cache.json.get(this.levelName);
            } else {
                if (this.game.tankNumber === 0) {
                    this.level = this.createMazeLevel(3, 4);
                } else if (this.game.tankNumber === 1) {
                    this.level = this.createMazeLevel(4, 6);
                } else if (this.game.tankNumber === 2) {
                    this.level = this.createMazeLevel(5, 7);
                } else {
                    this.level = this.createMazeLevel(7, 9);
                }
            }

            for (var wallI in this.level) {
                var wall = this.level[wallI];
                //console.log(wall);
                if (wall.wallType === 'wall' || wall.wallType === 'lavaWall' || wall.wallType === 'coldWall' || wall.wallType === 'freeDoor') {
                    var wallTextureData = this.prepareTexture(wall.edges, wallI, wall.wallType);
                    var shadowTextureData = this.prepareShadow(wall.edges, wallI, wall.wallType);
                    this.preparedTextures[wallI] = wallTextureData;
                    this.preparedShadows[wallI] = shadowTextureData;
                    //console.log(wallTextureData);
                }
            }
        }
    }, {
        key: 'create',
        value: function create() {

            // admob
            if (!this.game.adReady) window.prepareAd(this.game);
            console.log('time played ' + this.game.timePlayed);
            if (!this.game.replayCount) {
                this.game.replayCount = 1;
            } else {
                this.game.replayCount++;
            }

            var gameWidth = this.game.scale.width,
                gameHeight = this.game.scale.height;

            PlainCollider.initiate(this);

            this.staticWallsCollGroup = PlainCollider.registerNewCollGroup('staticWallsCollGroup');
            this.gravityWallsCollGroup = PlainCollider.registerNewCollGroup('gravityWallsCollGroup');
            this.bouncyCollGroup = PlainCollider.registerNewCollGroup('bouncyCollGroup');
            this.fuelCanCollGroup = PlainCollider.registerNewCollGroup('fuelCanCollGroup');

            this.playPortrait = this.add.image(gameWidth * 0.5 - 10000, gameHeight * 0.5 - 10000, 'playPortrait');
            this.playPortrait.setDepth(200);
            this.playPortrait.alpha = 0;

            this.maze = this.add.group();
            this.lightners = this.add.group();
            this.respawnFuelSpots = [];
            this.fuelSpawned = false;

            this.loadLevel(this.level);

            // collision particles
            /*this.collisionPoints = [];
             this.collisionParticles = this.add.particles('dustParticle');
            this.collisionParticles.setDepth(13);
             this.collisionEmitter = this.collisionParticles.createEmitter({
                lifespan: 300,
                speed: {min: 50, max: 90},
                scale: {start: 0.7, end: 1},
                alpha: {start: 1, end: 0},
                rotate: 90,
                gravityY: -200
            });
             this.collisionEmitter.stop();
            this.launchCollisionEmitter = false;
            this.time.delayedCall(1000, function(){
                this.launchCollisionEmitter = true;
            }, [], this);*/

            // camera
            //this.cameras.main.setRenderToTexture(this.customPipeline);
            var mainWall = this.maze.children.entries[0];
            this.cameras.main.startFollow(mainWall, true);
            var scale = Math.min(this.cameras.main.width / (mainWall.width + 80), this.cameras.main.height / (mainWall.height + 80));
            this.cameras.main.setZoom(scale);
            //console.log(scale);
            //console.log(this.cameras.main.scrollX);
            //console.log(this.cameras.main.scrollY);

            this.input.on('pointerdown', function (pointer) {
                //this.rotateMazeLeft();
                //console.log(this.bouncyVelocity);
                //Phaser.Actions.RotateAround(this.maze.getChildren(), {x: this.bouncy.x, y: this.bouncy.y}, Math.PI/2);

                /*this.bouncy.reporting = true;
                this.maze.children.each(function(entity){                
                    entity.reporting = true;
                }, this);*/
                //this.playing = !this.playing;

            }, this);

            this.leftKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.LEFT);
            this.rightKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.RIGHT);
            this.upKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.UP);
            this.rKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.R);
            this.nKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.N);

            this.continuousThrust = false;

            this.playing = true;

            this.noFuelUsed = true;
            if (this.game.levelNumber != 0) this.tankNumber = this.game.tankNumber;else this.tankNumber = 0;

            this.levelsWithNoFuel = this.game.levelsWithNoFuel;

            if (this.tankNumber === 0) {
                this.bouncy.currentFuel = 0;
            }

            // start drawing GUI
            this.guiContainer = this.add.container(10000, 10000);

            // fuel level indicator        

            this.fuelLevelBack = this.add.image(10000 + gameWidth * 0.87, 10000 + gameHeight * 0.08, 'fuelIndicatorBack');
            this.noFuelSignal = this.add.image(gameWidth * 0.87, gameHeight * 0.08, 'noFuelSignal');
            this.noFuelSignal.alpha = 0;
            this.fuelLevelTrack = this.add.image(10000 + gameWidth * 0.87, 10000 + gameHeight * 0.08, 'fuelIndicatorLevel');
            this.fuelLevelTrack.alpha = 0.7;
            this.fuelLevel = this.add.image(10000 + gameWidth * 0.87, 10000 + gameHeight * 0.08, 'fuelIndicatorLevel');
            this.fuelLevelLogo = this.add.image(10000 + gameWidth * 0.87, 10000 + gameHeight * 0.08, 'fuelIndicatorLogo');

            this.fuelLevelBack.setDepth(20);
            this.fuelLevelLogo.setDepth(21);

            this.noFuelTween = this.tweens.add({
                targets: this.noFuelSignal,
                props: {
                    alpha: { value: 1, ease: 'Quad.easeOut' }
                },
                yoyo: true,
                duration: 300,
                paused: true
            });

            //this.guiContainer.add(this.fuelLevelBack);
            this.guiContainer.add(this.noFuelSignal);

            /*this.fuelGraphics = this.make.graphics();
            this.fuelGraphics.setPosition(10000 + gameWidth*0.87, 10000 + gameHeight*0.08);
            this.fuelGraphics.fillStyle(0xffffff);
            this.fuelGraphics.slice(0, 0, 50, -Math.PI / 2, Math.PI * 3 / 2);
            this.fuelGraphics.fillPath();
            this.fuelLevel.mask = new Phaser.Display.Masks.GeometryMask(this, this.fuelGraphics);
             this.fuelTrackGraphics = this.make.graphics();
            this.fuelTrackGraphics.setPosition(10000 + gameWidth*0.87, 10000 + gameHeight*0.08);
            this.fuelTrackGraphics.fillStyle(0xffffff);
            this.fuelTrackGraphics.slice(0, 0, 50, -Math.PI / 2, Math.PI * 3 / 2);
            this.fuelTrackGraphics.fillPath();
            this.fuelLevelTrack.mask = new Phaser.Display.Masks.GeometryMask(this, this.fuelTrackGraphics);*/

            this.tankNumberBack = this.add.image(this.fuelLevelBack.x, this.fuelLevelBack.y + this.fuelLevelBack.displayHeight * 0.6, 'tankNumberBack');
            this.tankNumberLabel = this.add.bitmapText(this.tankNumberBack.x, this.tankNumberBack.y, 'basicFont', '' + this.tankNumber, 18);
            this.tankNumberLabel.setOrigin(0.5);
            this.tankNumberLabel.tint = 0xeeba6d;
            this.tankNumberBack.setDepth(21);
            this.tankNumberLabel.setDepth(21);

            //this.guiContainer.add(this.tankNumberBack);
            //this.guiContainer.add(this.tankNumberLabel);

            this.updateFuelLevel();

            // pause button
            this.pauseButton = this.makeButton('pauseButton', '', gameWidth * 0.13, gameHeight * 0.08, this.pauseGame);
            this.guiContainer.add(this.pauseButton);

            // level label
            this.levelLabelBack = this.add.image(gameWidth / 2, gameHeight * 0.03, 'levelLabelBack');
            this.levelLabel = this.add.bitmapText(this.levelLabelBack.x, this.levelLabelBack.y, 'peachFont', 'Level ' + this.game.levelNumber, 28);
            this.levelLabel.setOrigin(0.5);
            this.guiContainer.add(this.levelLabelBack);
            this.guiContainer.add(this.levelLabel);

            // add control buttons for mobile devices

            if (!this.game.device.os.desktop) {
                var scale = 1.3 * this.game.scale.width / 600;

                this.buttonsFrame = this.add.image(gameWidth * 0.5, gameHeight, 'buttonsFrame');
                this.buttonsFrame.setOrigin(0.5, 1);
                this.buttonsFrame.alpha = 0;
                this.rotateCClButton = this.makeButtonDown('rotateCClButton', '', gameWidth * 0.85, gameHeight * 0.94, this.rotateMazeLeftTween);
                this.rotateCClButton.setScale(scale);
                this.rotateClButton = this.makeButtonDown('rotateClButton', '', gameWidth * 0.15, gameHeight * 0.94, this.rotateMazeRightTween);
                this.rotateClButton.setScale(scale);
                this.thrustButton = this.makePressButton('thrustButton', '', gameWidth * 0.5, gameHeight * 0.94, this.switchContinuousThrust);
                this.thrustButton.setScale(scale);
                this.guiContainer.add(this.buttonsFrame);
                this.guiContainer.add(this.rotateCClButton);
                this.guiContainer.add(this.rotateClButton);
                this.guiContainer.add(this.thrustButton);

                var scale = Math.min(this.cameras.main.width / (mainWall.width + 80), this.cameras.main.height / (mainWall.height + this.buttonsFrame.displayHeight + 100));
                this.cameras.main.setZoom(scale);
            }

            if (this.game.levelNumber === 1) {

                if (this.game.device.os.desktop) {
                    this.tutRotCCl = this.add.image(gameWidth * 0.5, gameHeight * 0.98, 'tutRotCCl');
                    this.tutRotCCl.setOrigin(0.5, 1);
                    this.tutRotCl = this.add.image(gameWidth * 0.5, gameHeight * 0.98, 'tutRotCl');
                    this.tutRotCl.setOrigin(0.5, 1);

                    this.guiContainer.add(this.tutRotCl);
                    this.guiContainer.add(this.tutRotCCl);

                    this.tutRotCl.alpha = 0;
                } else {
                    this.tutRotCCl = this.add.image(this.rotateCClButton.getBottomRight().x - 10, this.rotateCClButton.getTopLeft().y + 10, 'mobTutRotCCl');
                    this.tutRotCCl.setOrigin(1, 1);
                    this.tutRotCl = this.add.image(this.rotateClButton.getTopLeft().x + 10, this.rotateClButton.getTopLeft().y + 10, 'mobTutRotCl');
                    this.tutRotCl.setOrigin(0, 1);

                    this.guiContainer.add(this.tutRotCl);
                    this.guiContainer.add(this.tutRotCCl);

                    this.tutRotCl.alpha = 0;
                }
            } else if (this.game.levelNumber === 2) {
                if (this.game.device.os.desktop) {
                    this.tutThrust = this.add.image(gameWidth * 0.5, gameHeight * 0.98, 'tutThrust');
                    this.tutThrust.setOrigin(0.5, 1);

                    this.guiContainer.add(this.tutThrust);
                } else {
                    this.tutThrust = this.add.image(gameWidth * 0.5, this.thrustButton.getTopLeft().y + 10, 'mobTutThrust');
                    this.tutThrust.setOrigin(0.5, 1);

                    this.guiContainer.add(this.tutThrust);
                }
            }

            this.HUDCamera = this.cameras.add(0, 0, gameWidth, gameHeight);
            this.HUDCamera.setScroll(10000, 10000);
            //console.log('setting HUD camera');

            this.bouncy.on('tankUp', this.tankUpBouncy, this);

            /*var fuelCan = new FuelCan(this, this.bouncy.x, this.bouncy.y - 300);
            PlainCollider.addObject(fuelCan, fuelCan.vertices);
            PlainCollider.assignCollGroup(fuelCan, 'fuelCanCollGroup');
            fuelCan.collWith = [this.bouncyCollGroup];
            this.maze.add(fuelCan);*/

            PlainCollider.refreshPairs();

            this.debugGraphics = this.add.graphics({ lineStyle: { color: 0xff0000 } });

            // create separete popup camera
            // it shouold be affected by the game cenra zoom
            this.popupCamera = this.cameras.add(0, 0, gameWidth, gameHeight);
            this.popupCamera.setScroll(-10000, -10000);
            //console.log('setting popup camera');

            // win popup
            this.winPopup = this.add.container(-10000, -10000);
            this.winPopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'winPopupBack');
            this.winPopupImage = this.add.image(gameWidth * 0.485, gameHeight * 0.4, 'winPopupImage');
            this.nextLevelButton = this.makeButton('nextLevelButton', '', gameWidth * 0.5 + 80, gameHeight * 0.4 + 200, this.launchNextLevel);
            this.replayButton = this.makeButton('replayButton', '', gameWidth * 0.5 - 80, gameHeight * 0.4 + 200, this.replayLevel);

            this.winPopup.add(this.winPopupBack);
            this.winPopup.add(this.winPopupImage);
            this.winPopup.add(this.nextLevelButton);
            this.winPopup.add(this.replayButton);

            if (this.game.device.os.desktop) {
                this.winPressN = this.add.image(this.nextLevelButton.x, this.nextLevelButton.getBottomRight().y, 'pressN');
                this.winPressN.setOrigin(0.5, 0);
                this.winPressR = this.add.image(this.replayButton.x, this.replayButton.getBottomRight().y, 'pressR');
                this.winPressR.setOrigin(0.5, 0);
                this.winPopup.add(this.winPressR);
                this.winPopup.add(this.winPressN);
            }

            this.winPopup.setDepth(20);
            this.winPopup.alpha = 0;
            this.nextLevelButton.disableInteractive();
            this.replayButton.disableInteractive();

            // bonus popup
            this.bonusPopup = this.add.container(-10000, -10000);
            this.bonusPopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'bonusPopup');
            this.bonusOkayButton = this.makeButton('okayButton', '', gameWidth * 0.5, gameHeight * 0.5 + 140, this.okayInstructions);

            this.bonusPopup.add(this.bonusPopupBack);
            this.bonusPopup.add(this.bonusOkayButton);

            if (this.game.device.os.desktop) {
                this.bonusPressN = this.add.image(this.bonusOkayButton.x, this.bonusOkayButton.getBottomRight().y, 'pressN');
                this.bonusPressN.setOrigin(0.5, 0);
                this.bonusPressN.setTint(0x999999);
                this.bonusPopup.add(this.bonusPressN);
            }

            this.bonusPopup.setDepth(21);
            this.bonusPopup.alpha = 0;
            this.bonusOkayButton.disableInteractive();

            // lose popup
            this.losePopup = this.add.container(-10000, -10000);
            this.losePopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'losePopupBack');
            this.losePopupImage = this.add.image(gameWidth * 0.5, gameHeight * 0.4, 'losePopupImage');
            this.loseReplayButton = this.makeButton('replayButton', '', gameWidth * 0.5, gameHeight * 0.4 + 190, this.replayLevel);

            this.losePopup.add(this.losePopupBack);
            this.losePopup.add(this.losePopupImage);
            this.losePopup.add(this.loseReplayButton);

            if (this.game.device.os.desktop) {
                this.losePressR = this.add.image(this.loseReplayButton.x, this.loseReplayButton.getBottomRight().y, 'pressR');
                this.losePressR.setOrigin(0.5, 0);
                this.losePopup.add(this.losePressR);
            }

            this.losePopup.setDepth(20);
            this.losePopup.alpha = 0;
            this.loseReplayButton.disableInteractive();

            // pause popup
            this.pausePopup = this.add.container(-10000, -10000);
            this.pausePopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'pausePopupBack');
            this.pausePopupImage = this.add.image(gameWidth * 0.5, gameHeight * 0.35, 'pausePopupImage');
            this.pauseMainMenuButton = this.makeButton('goLevelChoiceButton', '', gameWidth * 0.5 - 80, this.pausePopupBack.getBottomRight().y - 65, this.goLevelChoice);
            this.pauseMuteButton = this.makeMuteButton('mutePauseButton', '', gameWidth * 0.5 + 80, this.pausePopupBack.getBottomRight().y - 65);
            this.pauseReplayButton = this.makeButton('replayButton', '', gameWidth * 0.5 - 80, this.pauseMainMenuButton.getTopLeft().y - 75, this.replayLevel);
            this.pauseContinueButton = this.makeButton('nextLevelButton', '', gameWidth * 0.5 + 80, this.pauseMainMenuButton.getTopLeft().y - 75, this.continueGame);

            this.pausePopup.add(this.pausePopupBack);
            this.pausePopup.add(this.pausePopupImage);
            this.pausePopup.add(this.pauseReplayButton);
            this.pausePopup.add(this.pauseContinueButton);
            this.pausePopup.add(this.pauseMainMenuButton);
            this.pausePopup.add(this.pauseMuteButton);

            if (this.game.device.os.desktop) {
                this.pausePressR = this.add.image(this.pauseReplayButton.x, this.pauseReplayButton.getBottomRight().y, 'pressR');
                this.pausePressR.setOrigin(0.5, 0);
                this.pausePopup.add(this.pausePressR);
            }

            this.pausePopup.setDepth(20);
            this.pausePopup.alpha = 0;
            this.pauseReplayButton.disableInteractive();
            this.pauseContinueButton.disableInteractive();
            this.pauseMuteButton.disableInteractive();
            this.pauseMainMenuButton.disableInteractive();

            // tip popup
            this.tipPopup = this.add.container(-10000, -10000);
            this.tipPopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'tipPopup');
            this.tipOkayButton = this.makeButton('okayButton', '', gameWidth * 0.5, gameHeight * 0.5 + 150, this.okayInstructions);

            this.tipPopup.add(this.tipPopupBack);
            this.tipPopup.add(this.tipOkayButton);

            if (this.game.device.os.desktop) {
                this.tipPressN = this.add.image(this.tipOkayButton.x, this.tipOkayButton.getBottomRight().y, 'pressN');
                this.tipPressN.setOrigin(0.5, 0);
                this.tipPressN.setTint(0x999999);
                this.tipPopup.add(this.tipPressN);
            }

            this.tipPopup.setDepth(21);
            this.tipPopup.alpha = 0;
            this.tipOkayButton.disableInteractive();

            // maze level tip
            this.mazeLevelTipPopup = this.add.container(-10000, -10000);
            this.mazeLevelTipBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'mazeLevelInstructions');
            this.mazeTipButton = this.makeButton('goLevelChoiceButton', '', gameWidth * 0.5, gameHeight * 0.5 + 140, this.goLevelChoice);

            this.mazeLevelTipPopup.add(this.mazeLevelTipBack);
            this.mazeLevelTipPopup.add(this.mazeTipButton);

            if (this.game.device.os.desktop) {
                this.mazeLevelTipPressN = this.add.image(this.mazeTipButton.x, this.mazeTipButton.getBottomRight().y, 'pressN');
                this.mazeLevelTipPressN.setOrigin(0.5, 0);
                this.mazeLevelTipPressN.setTint(0x999999);
                this.mazeLevelTipPopup.add(this.mazeLevelTipPressN);
            }

            this.mazeLevelTipPopup.setDepth(21);
            this.mazeLevelTipPopup.alpha = 0;
            this.mazeTipButton.disableInteractive();

            // final popup
            this.finalPopup = this.add.container(-10000, -10000);
            this.finalPopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'winPopupBack');
            this.finalPopupImage = this.add.image(gameWidth * 0.5, gameHeight * 0.4, 'finalPopupImage');
            this.finalGoLevelChoiceButton = this.makeButton('goLevelChoiceButton', '', gameWidth * 0.5 - 80, gameHeight * 0.8, this.goLevelChoice);
            this.finalReplayButton = this.makeButton('replayButton', '', gameWidth * 0.5 + 80, gameHeight * 0.8, this.replayLevel);

            this.finalPopup.add(this.finalPopupBack);
            this.finalPopup.add(this.finalPopupImage);
            this.finalPopup.add(this.finalGoLevelChoiceButton);
            this.finalPopup.add(this.finalReplayButton);

            this.finalPopup.setDepth(20);
            this.finalPopup.alpha = 0;
            this.finalGoLevelChoiceButton.disableInteractive();
            this.finalReplayButton.disableInteractive();

            // maze win pop
            this.mazeWinPopup = this.add.container(-10000, -10000);
            this.mazeWinPopupBack = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'winPopupBack');
            this.mazeWinPopupImage = this.add.image(gameWidth * 0.5, gameHeight * 0.4, 'mazeLevelWinImage');
            this.mazeWinLevelChoiceButton = this.makeButton('goLevelChoiceButton', '', gameWidth * 0.5, gameHeight * 0.5 + 180, this.winMazeLevel);

            this.mazeWinPopup.add(this.mazeWinPopupBack);
            this.mazeWinPopup.add(this.mazeWinPopupImage);
            this.mazeWinPopup.add(this.mazeWinLevelChoiceButton);

            this.mazeWinPopup.setDepth(20);
            this.mazeWinPopup.alpha = 0;
            this.mazeWinLevelChoiceButton.disableInteractive();

            // rocket launch animation
            this.rocketLaunch = this.add.sprite(this.bouncy.x, this.bouncy.y, 'launch');
            this.rocketLaunch.alpha = 0;
            this.rocketLaunch.setOrigin(0.5, 1);
            var launchAnimFrames = this.anims.generateFrameNames('launch', { start: 1, end: 9 });
            /*{key: 'launch', frame: '1'},
            {key: 'launch', frame: '2'},
            {key: 'launch', frame: '3'},
            {key: 'launch', frame: '4'},
            {key: 'launch', frame: '5'},
            {key: 'launch', frame: '6'},
            {key: 'launch', frame: '7'},
            {key: 'launch', frame: '8'},
            {key: 'launch', frame: '9'}
            ];*/
            this.maze.add(this.rocketLaunch);
            this.rocketLaunchAnimation = this.anims.create({ key: 'rocketLaunch', frames: launchAnimFrames, repeat: 0, frameRate: 10 });
            this.rocketLaunch.on('animationcomplete', this.hideLaunch, this);
            this.rocketLaunch.setDepth(11);

            // check that the scene is not freezed
            if (this.freezed) {
                this.freezed = false;
            }

            this.pendingAction = false;

            // game sounds

            this.buttonSound = this.sound.add('buttonSound');
            this.loseSound = this.sound.add('loseSound');
            this.winSound = this.sound.add('winSound');
            this.jetSound = this.sound.add('jetSound');
            this.fuelSound = this.sound.add('fuelSound');
            this.rotateSound = this.sound.add('rotateSound');
            this.shockSound = this.sound.add('shockSound');

            if (this.game.backgroundMusic.isPaused) this.game.backgroundMusic.resume();

            this.time.delayedCall(800 + 300 * Math.random(), this.lightningStrike, [], this);

            //console.log(mainWall.getTopOfCollider());
            //console.log('end of create');

            // set a boolean for keyboard input delay
            this.acceptingKeyboard = true;

            // manage sound paused
            if (this.game.soundPaused) {
                this.sound.pauseAll();
            }
        }
    }, {
        key: 'definePosition',
        value: function definePosition(edges) {
            // left, right most and top, bottom points of the wall
            var leftPointWall = edges.reduce(function (leftWall, currEdge) {
                var currEdgeLeft = currEdge.reduce(function (leftEdge, currVer) {
                    if (leftEdge > currVer[0]) {
                        return currVer[0];
                    }
                    return leftEdge;
                }, currEdge[0][0]);
                if (leftWall > currEdgeLeft) {
                    return currEdgeLeft;
                }
                return leftWall;
            }, edges[0][0][0]);

            var topPointWall = edges.reduce(function (topWall, currEdge) {
                var currEdgeTop = currEdge.reduce(function (topEdge, currVer) {
                    if (topEdge > currVer[1]) {
                        return currVer[1];
                    }
                    return topEdge;
                }, currEdge[0][1]);
                if (topWall > currEdgeTop) {
                    return currEdgeTop;
                }
                return topWall;
            }, edges[0][0][1]);

            var rightPointWall = edges.reduce(function (rightWall, currEdge) {
                var currEdgeRight = currEdge.reduce(function (rightEdge, currVer) {
                    if (rightEdge < currVer[0]) {
                        return currVer[0];
                    }
                    return rightEdge;
                }, currEdge[0][0]);
                if (rightWall < currEdgeRight) {
                    return currEdgeRight;
                }
                return rightWall;
            }, edges[0][0][0]);

            var bottomPointWall = edges.reduce(function (bottomWall, currEdge) {
                var currEdgeBottom = currEdge.reduce(function (bottomEdge, currVer) {
                    if (bottomEdge < currVer[1]) {
                        return currVer[1];
                    }
                    return bottomEdge;
                }, currEdge[0][1]);
                if (bottomWall < currEdgeBottom) {
                    return currEdgeBottom;
                }
                return bottomWall;
            }, edges[0][0][1]);

            var wallWidth = rightPointWall - leftPointWall,
                wallHeight = bottomPointWall - topPointWall;

            return { leftPointWall: leftPointWall, topPointWall: topPointWall,
                wallWidth: wallWidth, wallHeight: wallHeight };
        }
    }, {
        key: 'prepareTexture',
        value: function prepareTexture(edges, wallNumber, wallType) {

            var wallPosition = this.definePosition(edges),
                leftOffset = wallPosition.leftPointWall,
                topOffset = wallPosition.topPointWall;

            var alignedEdges = edges.map(function (edge) {
                return edge.map(function (vertex) {
                    return [vertex[0] - leftOffset, vertex[1] - topOffset];
                });
            });

            // define vertices for texture
            var edgeVertices = defineOuterVertices(alignedEdges);
            //console.log(edgeVertices);

            // generate texture for sprite
            return this.drawTexture(wallNumber, wallType, edgeVertices, wallPosition.wallWidth, wallPosition.wallHeight, wallPosition.leftPointWall, wallPosition.topPointWall);
        }
    }, {
        key: 'prepareShadow',
        value: function prepareShadow(edges, wallNumber, wallType) {
            var wallPosition = this.definePosition(edges),
                leftOffset = wallPosition.leftPointWall,
                topOffset = wallPosition.topPointWall;

            var alignedEdges = edges.map(function (edge) {
                return edge.map(function (vertex) {
                    return [vertex[0] - leftOffset, vertex[1] - topOffset];
                });
            });

            // define vertices for texture
            var edgeVertices = defineOuterVertices(alignedEdges);
            //console.log(edgeVertices);

            // generate texture for sprite
            return wallGenerator.generateWallShadow(this, edgeVertices, wallPosition.wallWidth, wallPosition.wallHeight);
        }
    }, {
        key: 'drawTexture',
        value: function drawTexture(wallNumber, wallType, edgeVertices, wallWidth, wallHeight, leftPointWall, topPointWall) {
            var wallTextureData;

            switch (wallType) {
                case 'wall':
                    if (wallNumber === '0') wallTextureData = wallGenerator.generateMainWall(this, edgeVertices, wallWidth, wallHeight);else wallTextureData = wallGenerator.generateWall(this, edgeVertices, wallWidth, wallHeight);
                    break;
                case 'lavaWall':
                    wallTextureData = wallGenerator.generateLavaWall(this, edgeVertices, wallWidth, wallHeight, leftPointWall, topPointWall);
                    break;
                case 'freeDoor':
                    wallTextureData = wallGenerator.generateFreeDoor(this, edgeVertices, wallWidth, wallHeight);
                    break;
                case 'coldWall':
                    wallTextureData = wallGenerator.generateColdWall(this, edgeVertices, wallWidth, wallHeight);
                    break;
            }
            return wallTextureData;
        }
    }, {
        key: 'loadLevel',
        value: function loadLevel(level) {
            console.log(level);
            for (var wallI in level) {

                var wall = level[wallI];

                switch (wall.wallType) {
                    case 'start':
                        this.bouncy = new Bouncy(this, wall.edges[0][0], wall.edges[0][1]);

                        // set object to collider
                        PlainCollider.addObject(this.bouncy, this.bouncy.vertices);
                        PlainCollider.assignCollGroup(this.bouncy, 'bouncyCollGroup');
                        this.bouncy.collWith = [this.staticWallsCollGroup, this.gravityWallsCollGroup, this.fuelCanCollGroup];

                        this.bouncy.on('animationcomplete', this.showLosePopup, this);

                        break;
                    case 'finish':
                        this.finish = new Finish(this, wall.edges[0][0], wall.edges[0][1]);
                        this.maze.add(this.finish);
                        break;
                    case 'wall':
                        if (wallI === '0') var wallSprite = new MainWall(this, wall.edges, wallI, this.preparedTextures[wallI], this.preparedShadows[wallI]);else var wallSprite = new Wall(this, wall.edges, wallI, this.preparedTextures[wallI], this.preparedShadows[wallI]);
                        this.maze.add(wallSprite);

                        //set wall to collider
                        PlainCollider.addObject(wallSprite, wallSprite.vertices);
                        PlainCollider.assignCollGroup(wallSprite, 'staticWallsCollGroup');
                        wallSprite.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup];

                        break;
                    case 'coldWall':
                        var wallSprite = new ColdWall(this, wall.edges, wallI, this.preparedTextures[wallI], this.preparedShadows[wallI]);
                        this.maze.add(wallSprite);

                        //set wall to collider
                        PlainCollider.addObject(wallSprite, wallSprite.vertices);
                        PlainCollider.assignCollGroup(wallSprite, 'staticWallsCollGroup');
                        wallSprite.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup];

                        break;
                    case 'freeDoor':
                        var wallSprite = new FreeDoor(this, wall.edges, wallI, this.preparedTextures[wallI], this.preparedShadows[wallI]);
                        this.maze.add(wallSprite);

                        //set wall to collider
                        PlainCollider.addObject(wallSprite, wallSprite.vertices);
                        PlainCollider.assignCollGroup(wallSprite, 'gravityWallsCollGroup');
                        wallSprite.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup, this.staticWallsCollGroup];

                        break;
                    case 'metalBox':
                        var box = new MetalBox(this, wall.edges, wallI);
                        this.maze.add(box);
                        this.lightners.add(box);

                        //set box to collider
                        PlainCollider.addObject(box, box.vertices);
                        PlainCollider.assignCollGroup(box, 'gravityWallsCollGroup');
                        box.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup, this.staticWallsCollGroup];

                        break;
                    case 'woodBox':
                        var box = new WoodBox(this, wall.edges, wallI);
                        this.maze.add(box);

                        //set box to collider
                        PlainCollider.addObject(box, box.vertices);
                        PlainCollider.assignCollGroup(box, 'gravityWallsCollGroup');
                        box.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup, this.staticWallsCollGroup];

                        break;
                    case 'lavaWall':
                        var wallSprite = new LavaWall(this, wall.edges, wallI, this.preparedTextures[wallI], this.preparedShadows[wallI]);
                        this.maze.add(wallSprite);
                        this.lightners.add(wallSprite);

                        //set wall to collider
                        PlainCollider.addObject(wallSprite, wallSprite.vertices);
                        PlainCollider.assignCollGroup(wallSprite, 'staticWallsCollGroup');
                        wallSprite.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup];

                        break;
                    case 'floor':
                        this.floor = new Floor(this, wall.edges, wallI);
                        this.maze.add(this.floor);

                        break;

                    case 'respawnFuel':
                        var spot = this.add.image(wall.edges[0][0], wall.edges[0][1], 'fuelCan');
                        spot.alpha = 0;
                        this.respawnFuelSpots.push(spot);
                        this.maze.add(spot);

                        break;

                    case 'electricFollower':
                        var electricFollower = new ElectricFollower(this, wall.edges, wallI);
                        this.maze.add(electricFollower);
                        this.maze.add(electricFollower.pathSprite);
                        this.lightners.add(electricFollower);

                        //send folower to collider
                        PlainCollider.addObject(electricFollower, electricFollower.vertices);
                        PlainCollider.assignCollGroup(electricFollower, 'staticWallsCollGroup');
                        electricFollower.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup];

                        break;
                }
            }
        }
    }, {
        key: 'createMazeLevel',
        value: function createMazeLevel(columns, rows) {
            var level = {};

            // maze key scale vars
            var cellW = 100,
                holeW = 70;

            level[0] = this.constructMazeMainWall(columns, rows, cellW);

            var startX = cellW / 2 + 8,
                startY = (rows - 0.5) * cellW + (rows - 0.5) * 16,
                startObject = { 'edges': [[startX, startY]], 'wallType': 'start' };

            level[1] = startObject;

            var finishX = (columns - 0.5) * cellW + (columns - 0.5) * 16,
                finishY = cellW / 2 + 8,
                finishObject = { 'edges': [[finishX, finishY]], 'wallType': 'finish' };

            level[2] = finishObject;

            var floor = this.constructMazeFloor(columns, rows, cellW);

            level[3] = floor;

            this.mazifyChamber(columns, rows, 0, 0, level, 0, cellW, holeW);

            return level;
        }
    }, {
        key: 'constructMazeMainWall',
        value: function constructMazeMainWall(columns, rows, cellW) {
            // create main wall for maze level
            var vertex1 = [8, 0],
                vertex2 = [8, rows * cellW + (rows - 0.5) * 16],
                vertex3 = [-8, rows * cellW + (rows + 0.5) * 16],
                vertex4 = [-8, 0],
                vertex5 = [columns * cellW + (columns + 0.5) * 16, rows * cellW + (rows + 0.5) * 16],
                vertex6 = [columns * cellW + (columns - 0.5) * 16, rows * cellW + (rows - 0.5) * 16],
                vertex7 = [columns * cellW + (columns - 0.5) * 16, 8],
                vertex8 = [columns * cellW + (columns + 0.5) * 16, -8],
                vertex9 = [0, -8],
                vertex10 = [0, 8];

            return { 'edges': [[vertex4, vertex3, vertex2, vertex1], [vertex3, vertex5, vertex6, vertex2], [vertex7, vertex6, vertex5, vertex8], [vertex9, vertex10, vertex7, vertex8]],
                'wallType': 'wall' };
        }
    }, {
        key: 'constructMazeFloor',
        value: function constructMazeFloor(columns, rows, cellW) {
            // create floor for maze level
            return { 'edges': [[0, 0], [columns * (cellW + 16), 0], [columns * (cellW + 16), rows * (cellW + 16)], [0, rows * (cellW + 16)]],
                'wallType': 'floor' };
        }
    }, {
        key: 'constructMazeLavaWall',
        value: function constructMazeLavaWall(wallCoords) {
            var start = wallCoords.start,
                end = wallCoords.end;

            //console.log(wallCoords);

            if (start.x === end.x) {
                var vertex1 = [start.x + 8, start.y],
                    vertex2 = [start.x + 8, end.y],
                    vertex3 = [start.x - 8, end.y],
                    vertex4 = [start.x - 8, start.y];
            } else {
                var vertex1 = [start.x, start.y - 8],
                    vertex2 = [end.x, start.y - 8],
                    vertex3 = [end.x, start.y + 8],
                    vertex4 = [start.x, start.y + 8];
            }

            return { 'edges': [[vertex1, vertex2, vertex3, vertex4]], 'wallType': 'lavaWall' };
        }
    }, {
        key: 'mazifyChamber',
        value: function mazifyChamber(columns, rows, xPos, yPos, levelObject, depth, cellW, holeW) {
            //!!!! for debug
            if (!depth) depth = 1;

            var numOfVWalls = columns - 1,
                numOfHWalls = rows - 1,
                vWallIndex = Math.round(Math.random() * (numOfVWalls - 1)),
                hWallIndex = Math.round(Math.random() * (numOfHWalls - 1)),
                vHoleIndex1 = Math.round(Math.random() * hWallIndex),
                vHoleIndex2 = hWallIndex + 1 + Math.round(Math.random() * (rows - 1 - hWallIndex - 1)),

            /*hHoleIndex1 = Math.round(Math.random() * vWallIndex),
            hHoleIndex2 = vWallIndex + Math.round(Math.random() * (columns - 1 - vWallIndex)),*/
            hHoleIndex = Math.round(Math.random() * (columns - 1)),
                maxWallNum = Object.keys(levelObject).length - 1;

            // vertical walls

            var vWallCoords1 = {};

            vWallCoords1.start = { x: (vWallIndex + 1) * cellW + (vWallIndex + 1) * 16 + xPos,
                y: yPos };
            vWallCoords1.end = { x: vWallCoords1.start.x,
                y: vHoleIndex1 * cellW + (0.5 + vHoleIndex1) * 16 + (cellW - holeW) * 0.5 + yPos };

            //if (vWallCoords1.end.y - vWallCoords1.start.y > 50)
            //{
            var wallObject1 = this.constructMazeLavaWall(vWallCoords1);
            levelObject[maxWallNum + 1] = wallObject1;
            /*} else
            {
                console.log(vWallCoords1);
            }*/

            var vWallCoords2 = {};

            vWallCoords2.start = { x: vWallCoords1.start.x,
                y: (vHoleIndex1 + 1) * cellW + (vHoleIndex1 + 0.5) * 16 - (cellW - holeW) * 0.5 + yPos };
            vWallCoords2.end = { x: vWallCoords1.start.x,
                y: vHoleIndex2 * cellW + (0.5 + vHoleIndex2) * 16 + (cellW - holeW) * 0.5 + yPos };

            //if (vWallCoords2.end.y - vWallCoords2.start.y > 50)
            //{
            var wallObject2 = this.constructMazeLavaWall(vWallCoords2);
            levelObject[maxWallNum + 2] = wallObject2;
            /*} else
            {
                console.log(vWallCoords2);
            }*/

            var vWallCoords3 = {};

            vWallCoords3.start = { x: vWallCoords1.start.x,
                y: (vHoleIndex2 + 1) * cellW + (vHoleIndex2 + 0.5) * 16 - (cellW - holeW) * 0.5 + yPos };
            vWallCoords3.end = { x: vWallCoords1.start.x,
                y: rows * cellW + rows * 16 + yPos };

            //if (vWallCoords3.end.y - vWallCoords3.start.y > 50)
            //{

            var wallObject3 = this.constructMazeLavaWall(vWallCoords3);
            levelObject[maxWallNum + 3] = wallObject3;
            //}
            if (vWallCoords3.end.y - vWallCoords3.start.y < 50) console.log(vWallCoords3);

            // horizontal walls

            var hWallCoords1 = {};

            hWallCoords1.start = { x: xPos, y: (hWallIndex + 1) * cellW + (hWallIndex + 1) * 16 + yPos };
            hWallCoords1.end = { x: hHoleIndex * cellW + (0.5 + hHoleIndex) * 16 + (cellW - holeW) * 0.5 + xPos,
                y: hWallCoords1.start.y };

            //if (hWallCoords1.end.x - hWallCoords1.start.x > 50)
            //{
            var wallObject4 = this.constructMazeLavaWall(hWallCoords1);
            levelObject[maxWallNum + 4] = wallObject4;
            //}

            /*var hWallCoords2 = {};
            
            hWallCoords2.start = {x: (hHoleIndex1 + 1) * 80 + 
                (1.5 + hHoleIndex1) * 16 + xPos, y: hWallCoords1.start.y};
            hWallCoords2.end = {x: hHoleIndex2 * 80 + (0.5 + hHoleIndex2) * 16 + xPos,
                y: hWallCoords1.start.y};
             if (hWallCoords2.end.x - hWallCoords2.start.x > 50)
            {
                var wallObject5 = this.constructMazeLavaWall(hWallCoords2);
                levelObject[maxWallNum + 5] = wallObject5;
            }*/

            var hWallCoords3 = {};

            hWallCoords3.start = { x: (hHoleIndex + 1) * cellW + (hHoleIndex + 0.5) * 16 - (cellW - holeW) * 0.5 + xPos, y: hWallCoords1.start.y };
            hWallCoords3.end = { x: columns * cellW + columns * 16 + xPos,
                y: hWallCoords1.start.y };

            //if (hWallCoords3.end.x - hWallCoords3.start.x > 50)
            //{
            var wallObject6 = this.constructMazeLavaWall(hWallCoords3);
            levelObject[maxWallNum + 6] = wallObject6;
            //}


            // construct chambers
            var chamber1 = { xPos: xPos, yPos: yPos, rows: hWallIndex + 1,
                columns: vWallIndex + 1 };

            if (chamber1.rows > 1 && chamber1.columns > 1 && depth < 20) this.mazifyChamber(chamber1.columns, chamber1.rows, chamber1.xPos, chamber1.yPos, levelObject, depth + 1, cellW, holeW);

            var chamber2 = { xPos: vWallCoords1.start.x, yPos: yPos,
                rows: hWallIndex + 1, columns: columns - vWallIndex - 1 };

            if (chamber2.rows > 1 && chamber2.columns > 1 && depth < 20) this.mazifyChamber(chamber2.columns, chamber2.rows, chamber2.xPos, chamber2.yPos, levelObject, depth + 1, cellW, holeW);

            var chamber3 = { xPos: xPos, yPos: hWallCoords1.start.y,
                rows: rows - hWallIndex - 1, columns: vWallIndex + 1 };

            if (chamber3.rows > 1 && chamber3.columns > 1 && depth < 20) this.mazifyChamber(chamber3.columns, chamber3.rows, chamber3.xPos, chamber3.yPos, levelObject, depth + 1, cellW, holeW);

            var chamber4 = { xPos: vWallCoords1.start.x, yPos: hWallCoords1.start.y,
                rows: rows - hWallIndex - 1, columns: columns - vWallIndex - 1 };

            if (chamber4.rows > 1 && chamber4.columns > 1 && depth < 20) this.mazifyChamber(chamber4.columns, chamber4.rows, chamber4.xPos, chamber4.yPos, levelObject, depth + 1, cellW, holeW);

            /*console.log('at depth '+depth);
            console.log('wer wall index '+vWallIndex);
            console.log('hor wall index '+hWallIndex);
            console.log('v hole index 1 '+vHoleIndex1);
            console.log('v hole index 2 '+vHoleIndex2);
            console.log('h hole index '+hHoleIndex);
            console.log(chamber1);
            console.log(chamber2);
            console.log(chamber3);
            console.log(chamber4);
            console.log('__________________')*/
        }
    }, {
        key: 'lightningStrike',
        value: function lightningStrike() {
            if (this && this.lightners.getLength() > 0) {
                if (this.freezed) {
                    this.time.delayedCall(1200, this.lightningStrike, [], this);
                    //console.log('call on freezed');
                } else {
                    var lightnerNum = Math.round(Math.random() * (this.lightners.getLength() - 1)),
                        lightner = this.lightners.getChildren()[lightnerNum];
                    lightner.changeDischargeAlpha();

                    var randomDelay = 300 * Math.random();

                    this.time.delayedCall(600 + randomDelay, lightner.changeDischargeAlpha, [], lightner);
                    this.time.delayedCall(800 + randomDelay, this.lightningStrike, [], this);
                }
            }
        }
    }, {
        key: 'rotateMazeRightTween',
        value: function rotateMazeRightTween() {
            if (!this.freezed) {

                if (this.tutRotCl && this.tutRotCl.alpha > 0) {
                    this.tutRotCl.alpha = 0;
                }

                this.freezeForRotation();
                if (this.bouncy.iceProduction && (this.bouncy.thrustSmokeSprite ? this.bouncy.thrustSmokeSprite.alpha === 1 : this.bouncy.engineEmitter.on)) {
                    this.createIceWall();
                    this.bouncy.iceProduction = false;
                    this.bouncy.coldWallTop = null;
                } else if (this.bouncy.iceProduction) {
                    this.bouncy.iceProduction = false;
                    this.bouncy.coldWallTop = null;
                }
                //this.game.customPipeline.setFloat1('radius', 2.0);
                this.maze.children.each(function (wall) {

                    //console.log(newCenter);                

                    var rotTween = this.tweens.add({
                        targets: wall,
                        props: {
                            rotation: { value: wall.rotation + Math.PI / 2, ease: 'Sine.easeInOut' }
                            //x: {value: newCenter.x, ease: 'Linear'},
                            //y: {value: newCenter.y, ease: 'Linear'}
                        },
                        duration: 900
                    });

                    //console.log(rotTween.callbacks);

                    // move the center of the wall with rotation
                    var prevRotation = wall.rotation;
                    rotTween.callbacks.onUpdate = {
                        func: function func() {
                            var rotDelta = wall.rotation - prevRotation,
                                newCenter = new Phaser.Math.Vector2(wall.x - this.bouncy.x, wall.y - this.bouncy.y),
                                rotateMatrix = new Phaser.Math.Matrix3();
                            rotateMatrix.fromArray([Math.cos(rotDelta), Math.sin(rotDelta), 0, -Math.sin(rotDelta), Math.cos(rotDelta), 0, 0, 0]);
                            newCenter.transformMat3(rotateMatrix);
                            newCenter.add(new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y));
                            prevRotation = wall.rotation;
                            wall.x = newCenter.x;
                            wall.y = newCenter.y;
                            if (wall.shadow) {
                                wall.updateShadow();
                            }
                        },
                        scope: this,
                        params: [rotTween]
                    };

                    // rotate collider only for thhose who has one
                    rotTween.callbacks.onComplete = {
                        func: function func() {
                            if (wall.collider) {
                                PlainCollider.rotateCollider(wall, Math.PI / 2, new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y));
                            }

                            if (wall.rocketateType === RocketateTypeDict.lavaWall || wall.rocketateType === RocketateTypeDict.metalBox || wall.rocketateType === RocketateTypeDict.coldWall || wall.rocketateType === RocketateTypeDict.fuelCan) {
                                wall.endRotation();
                            }
                            if (wall.rocketateType === RocketateTypeDict.electricFollower) {
                                wall.rotatePath(new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y), Math.PI / 2);
                                wall.endRotation(Math.PI / 2);
                                wall.normalizePosition();
                            }
                        },
                        scope: this,
                        params: [rotTween]

                        // rotate flash paths for lava walls

                    };if (wall.rocketateType === RocketateTypeDict.lavaWall) {
                        wall.startRotation(Math.PI / 2, new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y));
                    }

                    if (wall.rocketateType === RocketateTypeDict.metalBox || wall.rocketateType === RocketateTypeDict.coldWall || wall.rocketateType === RocketateTypeDict.fuelCan || wall.rocketateType === RocketateTypeDict.electricFollower) {
                        wall.startRotation();
                    }
                }, this);

                // set zoom tween
                var mainWall = this.maze.children.entries[0];

                if (this.game.device.os.desktop) var scale = Math.min(this.cameras.main.width / Math.abs((mainWall.width + 80) * Math.cos(mainWall.rotation + Math.PI / 2) + (mainWall.height + 80) * Math.sin(mainWall.rotation + Math.PI / 2)), this.cameras.main.height / Math.abs((mainWall.width + 80) * Math.sin(mainWall.rotation + Math.PI / 2) + (mainWall.height + 80) * Math.cos(mainWall.rotation + Math.PI / 2)));else var scale = Math.min(this.cameras.main.width / Math.abs((mainWall.width + 80) * Math.cos(mainWall.rotation + Math.PI / 2) + (mainWall.height + this.buttonsFrame.displayHeight + 100) * Math.sin(mainWall.rotation + Math.PI / 2)), this.cameras.main.height / Math.abs((mainWall.width + 80) * Math.sin(mainWall.rotation + Math.PI / 2) + (mainWall.height + this.buttonsFrame.displayHeight + 100) * Math.cos(mainWall.rotation + Math.PI / 2)));

                var zoomTween = this.tweens.add({
                    targets: this.cameras.main,
                    props: {
                        zoom: { value: scale, ease: 'Linear' }
                    },
                    duration: 900
                });

                //console.log(scale);

                this.time.delayedCall(1200, this.unfreezeAfterRotation, [], this);

                if (this.jetSound.isPlaying) this.jetSound.pause();

                if (!this.game.soundPaused) this.rotateSound.play();
                this.stopBouncyThrust();
            } else {
                //console.log('set pending action');
                this.pendingAction = this.rotateMazeRightTween;
                //console.log(this.pendingAction);
            }
        }
    }, {
        key: 'rotateMazeLeftTween',
        value: function rotateMazeLeftTween() {
            if (!this.freezed) {

                if (this.tutRotCCl && this.tutRotCCl.alpha > 0) {
                    this.tutRotCCl.alpha = 0;
                    this.tutRotCl.alpha = 1;
                }

                this.freezeForRotation();
                if (this.bouncy.iceProduction && (this.bouncy.thrustSmokeSprite ? this.bouncy.thrustSmokeSprite.alpha === 1 : this.bouncy.engineEmitter.on)) {
                    this.createIceWall();
                    this.bouncy.iceProduction = false;
                    this.bouncy.coldWallTop = null;
                } else if (this.bouncy.iceProduction) {
                    this.bouncy.iceProduction = false;
                    this.bouncy.coldWallTop = null;
                }
                //this.game.customPipeline.setFloat1('radius', 2.0);
                this.maze.children.each(function (wall) {
                    //console.log(newCenter);


                    var rotTween = this.tweens.add({
                        targets: wall,
                        props: {
                            rotation: { value: wall.rotation - Math.PI / 2, ease: 'Sine.easeInOut' }
                            //x: {value: newCenter.x, ease: 'Linear'},
                            //y: {value: newCenter.y, ease: 'Linear'}
                        },
                        duration: 900
                    });

                    // move the center of the wall with rotation
                    var prevRotation = wall.rotation;
                    rotTween.callbacks.onUpdate = {
                        func: function func() {
                            var rotDelta = wall.rotation - prevRotation,
                                newCenter = new Phaser.Math.Vector2(wall.x - this.bouncy.x, wall.y - this.bouncy.y),
                                rotateMatrix = new Phaser.Math.Matrix3();
                            rotateMatrix.fromArray([Math.cos(rotDelta), Math.sin(rotDelta), 0, -Math.sin(rotDelta), Math.cos(rotDelta), 0, 0, 0]);
                            newCenter.transformMat3(rotateMatrix);
                            newCenter.add(new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y));
                            prevRotation = wall.rotation;
                            wall.x = newCenter.x;
                            wall.y = newCenter.y;
                            if (wall.shadow) {
                                wall.updateShadow();
                            }
                        },
                        scope: this,
                        params: [rotTween]

                        //console.log(rotTween.callbacks);


                    };rotTween.callbacks.onComplete = {
                        func: function func() {
                            if (wall.collider) {
                                PlainCollider.rotateCollider(wall, -Math.PI / 2, new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y));
                            }

                            if (wall.rocketateType === RocketateTypeDict.lavaWall || wall.rocketateType === RocketateTypeDict.metalBox || wall.rocketateType === RocketateTypeDict.coldWall || wall.rocketateType === RocketateTypeDict.fuelCan) {
                                wall.endRotation();
                            }
                            if (wall.rocketateType === RocketateTypeDict.electricFollower) {
                                wall.rotatePath(new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y), -Math.PI / 2);
                                wall.endRotation(-Math.PI / 2);
                                wall.normalizePosition();
                            }
                        },
                        scope: this,
                        params: [rotTween]

                        // rotate flash paths for lava walls

                    };if (wall.rocketateType === RocketateTypeDict.lavaWall) {
                        wall.startRotation(-Math.PI / 2, new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y));
                    }

                    if (wall.rocketateType === RocketateTypeDict.metalBox || wall.rocketateType === RocketateTypeDict.coldWall || wall.rocketateType === RocketateTypeDict.fuelCan || wall.rocketateType === RocketateTypeDict.electricFollower) {
                        wall.startRotation();
                    }
                }, this);

                // set zoom tween
                var mainWall = this.maze.children.entries[0];

                if (this.game.device.os.desktop) var scale = Math.min(this.cameras.main.width / Math.abs((mainWall.width + 80) * Math.cos(mainWall.rotation + Math.PI / 2) + (mainWall.height + 80) * Math.sin(mainWall.rotation + Math.PI / 2)), this.cameras.main.height / Math.abs((mainWall.width + 80) * Math.sin(mainWall.rotation + Math.PI / 2) + (mainWall.height + 80) * Math.cos(mainWall.rotation + Math.PI / 2)));else var scale = Math.min(this.cameras.main.width / Math.abs((mainWall.width + 80) * Math.cos(mainWall.rotation + Math.PI / 2) + (mainWall.height + this.buttonsFrame.displayHeight + 100) * Math.sin(mainWall.rotation + Math.PI / 2)), this.cameras.main.height / Math.abs((mainWall.width + 80) * Math.sin(mainWall.rotation + Math.PI / 2) + (mainWall.height + this.buttonsFrame.displayHeight + 100) * Math.cos(mainWall.rotation + Math.PI / 2)));

                var zoomTween = this.tweens.add({
                    targets: this.cameras.main,
                    props: {
                        zoom: { value: scale, ease: 'Linear' }
                    },
                    duration: 900
                });

                this.time.delayedCall(1200, this.unfreezeAfterRotation, [], this);

                if (this.jetSound.isPlaying) this.jetSound.pause();

                if (!this.game.soundPaused) this.rotateSound.play();
                this.stopBouncyThrust();
            } else {
                //console.log('set pending action');
                this.pendingAction = this.rotateMazeLeftTween;
                //console.log(this.pendingAction);
            }
        }
    }, {
        key: 'freezeForRotation',
        value: function freezeForRotation() {
            this.freezed = true;
        }
    }, {
        key: 'unfreezeAfterRotation',
        value: function unfreezeAfterRotation() {
            this.freezed = false;
            //this.game.customPipeline.setFloat1('radius', 0.0);

            this.bouncy.vel = new Phaser.Math.Vector2();
            //this.bouncy.acceleration = 0;
            this.maze.children.each(function (entity) {
                if (entity.rocketateType != RocketateTypeDict.electricFollower) {
                    entity.vel = new Phaser.Math.Vector2();
                    //if (entity.acceleration) entity.acceleration = 0;
                }
                if (entity.rocketateType === RocketateTypeDict.fuelCan) {
                    entity.rotation = 0;
                }
            }, this);

            if (this.pendingAction) {
                console.log('executing pending action');
                this.pendingAction.call(this);
                this.pendingAction = false;
            }

            //this.cameras.main.setZoom(scale);
        }
    }, {
        key: 'restartScene',
        value: function restartScene() {
            this.anims.remove('idle');
            this.anims.remove('fly');
            this.anims.remove('shock');
            this.anims.remove('rocketLaunch');
            this.anims.remove('dustSplash');
            this.anims.remove('flashMain');
            this.anims.remove('smokeAnimation');
            if (this.game.levelNumber > this.game.lastAvailLevel) {
                this.game.lastAvailLevel = this.game.levelNumber;
                localStorage.setItem('rocketateNextLevelNumber', this.game.lastAvailLevel);
            }

            wallGenerator.clearTextures();
            this.scene.restart();
        }
    }, {
        key: 'switchContinuousThrust',
        value: function switchContinuousThrust() {
            this.continuousThrust = !this.continuousThrust;
        }
    }, {
        key: 'thrustBouncy',
        value: function thrustBouncy(timeDelta) {
            if (this.tutThrust && this.tutThrust.alpha > 0) {
                this.tutThrust.alpha = 0;
            }

            if (this.bouncy.currentFuel > 0) {
                if (this.noFuelUsed) this.noFuelUsed = false;

                if (this.bouncy.fromGroundLaunch) {
                    this.bouncy.thrust(4);
                    this.bouncy.accelerationCount = 3;
                    //console.log('from ground');
                    this.rocketLaunch.setPosition(this.bouncy.x - this.bouncy.displayWidth * 0.3, this.bouncy.y + this.bouncy.displayHeight * 0.5);
                    this.rocketLaunch.rotation = 0;
                    this.rocketLaunch.alpha = 1;
                    this.rocketLaunch.play('rocketLaunch');
                } else if (this.bouncy.accelerationCount > 0) {
                    //console.log('on accelerationCount');
                    this.bouncy.thrust(this.bouncy.accelerationCount);
                    this.bouncy.accelerationCount--;
                } else {
                    this.bouncy.thrust(0.6);
                }
                //this.bouncy.engineEmitter.explode(10, this.bouncy.x, this.bouncy.y - this.bouncy.height *0.7/2 * Math.sign(this.bouncy.vel.y));
                if (this.bouncy.thrustSmokeSprite) {
                    if (this.bouncy.smokeAnimation.paused) {
                        this.bouncy.thrustSmokeSprite.play('smokeAnimation');
                        this.bouncy.smokeAnimation.resume();
                    }
                } else {
                    if (!this.bouncy.engineEmitter.on) {
                        this.bouncy.engineEmitter.start();
                        this.bouncy.smokeEmitter.start();
                    }
                }
                this.bouncy.currentFuel = Math.max(0, this.bouncy.currentFuel - 0.8);
                this.updateFuelLevel();

                if (!this.jetSound.isPlaying && !this.game.soundPaused) {
                    this.jetSound.play();
                }

                if (this.bouncy.onIce) {
                    this.bouncy.iceWall.melt();
                }
            } else if (this.tankNumber > 0) {
                if (this.tankNumber > 1) {
                    this.bouncy.currentFuel = this.bouncy.fuelCapacity;
                    this.updateFuelLevel();
                }

                this.tankNumber--;
                this.tankNumberLabel.text = '' + this.tankNumber;
                this.thrustBouncy(timeDelta);
            } else {
                if (!this.noFuelTween.isPlaying()) {
                    if (this.noFuelTween.countdown > 0) {
                        this.noFuelTween.play();
                    } else {
                        this.noFuelTween.restart();
                    }
                }
            }

            if (this.bouncy.currentFuel <= 50 && !this.fuelSpawned && this.respawnFuelSpots.length > 0) {
                this.spawnFuel();
                this.fuelSpawned = true;
            }
            if (this.bouncy.flyAnimation.paused && !this.bouncy.inShock) {
                //console.log('fly animation resumed on thrust');
                this.bouncy.idleAnimation.pause();
                this.bouncy.play('fly');
                this.bouncy.flyAnimation.resume();
                this.updateFuelLevelTrack();
            } /*else if (!this.bouncy.idleAnimation.paused)
              {
                console.log('idle animation paused');
                this.bouncy.idleAnimation.pause();
                this.bouncy.play('fly');
              }*/
        }
    }, {
        key: 'updateFuelLevel',
        value: function updateFuelLevel() {
            /*var startingAngle = (1 - this.bouncy.currentFuel/this.bouncy.fuelCapacity) * Math.PI*2 - Math.PI/2;
            this.fuelGraphics.clear();
            this.fuelGraphics.fillStyle(0xffffff);
            this.fuelGraphics.slice(0, 0, 50, startingAngle, Math.PI * 3 / 2);
            this.fuelGraphics.fillPath();*/

            var fuelBarHeight = this.bouncy.currentFuel / this.bouncy.fuelCapacity * 80;
            this.fuelLevel.setCrop(0, 80 - fuelBarHeight, 80, fuelBarHeight);
        }
    }, {
        key: 'updateFuelLevelTrack',
        value: function updateFuelLevelTrack() {
            /*var startingAngle = (1 - this.bouncy.currentFuel/this.bouncy.fuelCapacity) * Math.PI*2 - Math.PI/2;
            this.fuelTrackGraphics.clear();
            this.fuelTrackGraphics.fillStyle(0xffffff);
            this.fuelTrackGraphics.slice(0, 0, 50, startingAngle, Math.PI * 3 / 2);
            this.fuelTrackGraphics.fillPath();*/
            var fuelBarHeight = this.bouncy.currentFuel / this.bouncy.fuelCapacity * 80;
            this.fuelLevelTrack.setCrop(0, 80 - fuelBarHeight, 80, fuelBarHeight);
        }
    }, {
        key: 'hideLaunch',
        value: function hideLaunch() {
            this.rocketLaunch.alpha = 0;
        }
    }, {
        key: 'tankUpBouncy',
        value: function tankUpBouncy() {
            // upadte fuel level indicator
            /*var startingAngle = (1 - this.bouncy.currentFuel/this.bouncy.fuelCapacity) * Math.PI*2 - Math.PI/2;
            this.fuelGraphics.clear();
            this.fuelGraphics.fillStyle(0xffffff);
            this.fuelGraphics.slice(0, 0, 50, startingAngle, Math.PI * 3 / 2);
            this.fuelGraphics.fillPath();        */
            this.updateFuelLevel();
            this.updateFuelLevelTrack();

            this.fuelSpawned = false;
            if (!this.game.soundPaused) this.fuelSound.play();

            if (this.tankNumber === 0) this.tankNumber++;
            this.tankNumberLabel.text = '' + this.tankNumber;
        }
    }, {
        key: 'spawnFuel',
        value: function spawnFuel() {
            var bouncyPos = new Phaser.Math.Vector2(this.bouncy.x, this.bouncy.y);
            //console.log(this.respawnFuelSpots);
            var spawnSpot = this.respawnFuelSpots.reduce(function (curr, acc, arr) {
                //console.log(curr);
                //console.log(acc);
                if (bouncyPos.distance(curr) > bouncyPos.distance(acc)) return curr;
                return acc;
            }, this.respawnFuelSpots[0]);

            var fuelCan = new FuelCan(this, spawnSpot.x, spawnSpot.y);
            PlainCollider.addObject(fuelCan, fuelCan.vertices);
            PlainCollider.assignCollGroup(fuelCan, 'fuelCanCollGroup');
            fuelCan.collWith = [this.bouncyCollGroup];
            this.maze.add(fuelCan);

            PlainCollider.injectObjectInPairs(fuelCan);
        }
    }, {
        key: 'createIceWall',
        value: function createIceWall() {
            var xPos = this.bouncy.x,
                topY = this.bouncy.getBottomRight().y,
                height = Math.floor(this.bouncy.coldWallTop - topY);

            var edges = [[[xPos - 8, topY], [xPos - 8, topY + height], [xPos + 8, topY + height], [xPos + 8, topY]]];

            // define wallNumber
            var wallNumber = this.maze.getChildren().reduce(function (maxNumber, currWall) {
                //console.log(currWall.wallNumber);
                if (currWall.wallNumber) {
                    if (Number(currWall.wallNumber) > maxNumber) {
                        return Number(currWall.wallNumber);
                    }
                }

                return maxNumber;
            }, 0);

            wallNumber++;

            /*console.log('ice wall height');
            console.log(height);
            console.log(wallNumber);*/

            var iceWall = new IceWall(this, edges, '' + wallNumber);
            //set wall to collider
            PlainCollider.addObject(iceWall, iceWall.vertices);
            PlainCollider.assignCollGroup(iceWall, 'gravityWallsCollGroup');
            iceWall.collWith = [this.bouncyCollGroup, this.gravityWallsCollGroup, this.staticWallsCollGroup];

            this.maze.add(iceWall);

            PlainCollider.injectObjectInPairs(iceWall);
        }
    }, {
        key: 'stopBouncyThrust',
        value: function stopBouncyThrust() {

            // make a little delay for mobile devices

            if (!this.game.device.os.desktop && (this.bouncy.thrustSmokeSprite ? this.bouncy.thrustSmokeSprite.alpha === 1 : this.bouncy.engineEmitter.on) && this.bouncy.vel.y > -0.1) {
                this.freezed = true;
                this.time.delayedCall(500, function () {
                    this.freezed = false;
                    if (this.pendingAction) {
                        console.log('executing pending action');
                        this.pendingAction.call(this);
                        this.pendingAction = false;
                    }
                }, [], this);
            }

            if (this.bouncy.thrustSmokeSprite) {
                if (!this.bouncy.smokeAnimation.paused) {
                    this.bouncy.thrustSmokeSprite.alpha = 0;
                    this.bouncy.smokeAnimation.pause();
                }
            } else {
                if (this.bouncy.engineEmitter.on) {
                    this.bouncy.engineEmitter.stop();
                    this.bouncy.smokeEmitter.stop();
                }
            }
            if (this.bouncy.accelerationCount > 0) {
                this.bouncy.accelerationCount = 0;
            }
            if (this.bouncy.flyAnimation && !this.bouncy.flyAnimation.paused) {
                //console.log('fly animation paused');
                this.bouncy.flyAnimation.pause();
                this.bouncy.play('idle');
                this.bouncy.idleAnimation.resume();
                if (this.jetSound.isPlaying) {
                    this.jetSound.pause();
                }
                this.updateFuelLevelTrack();
            }
        }
    }, {
        key: 'makeButton',
        value: function makeButton(imageKey, text, posX, posY, callback) {
            var button = this.add.image(posX, posY, imageKey, 'out').setInteractive();
            button.setDepth(101);
            button.on('pointerdown', function () {
                if (!this.game.soundPaused) this.buttonSound.play();
                button.setFrame('down');
            }, this);
            button.on('pointerup', function () {
                button.setFrame('out');
                callback.call(this);
            }, this);
            var buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', text, 16);
            buttonLabel.setDepth(102);
            return button;
        }
    }, {
        key: 'makeButtonDown',
        value: function makeButtonDown(imageKey, text, posX, posY, callback) {
            var button = this.add.image(posX, posY, imageKey, 'out').setInteractive();
            button.setDepth(101);
            button.on('pointerdown', function () {
                if (!this.game.soundPaused) this.buttonSound.play();
                button.setFrame('down');
                callback.call(this);
            }, this);
            button.on('pointerup', function () {
                button.setFrame('out');
            }, this);
            var buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', text, 16);
            buttonLabel.setDepth(102);
            return button;
        }
    }, {
        key: 'makePressButton',
        value: function makePressButton(imageKey, text, posX, posY, callback) {
            var button = this.add.image(posX, posY, imageKey, 'out').setInteractive();

            button.setDepth(101);

            button.on('pointerdown', function () {
                if (!this.game.soundPaused) this.buttonSound.play();
                //console.log('pointer DOWN');
                button.setFrame('down');
                callback.call(this);
            }, this);

            button.on('pointerup', function () {
                if (this.continuousThrust) {
                    //console.log('pointer UP');
                    button.setFrame('out');
                    callback.call(this);
                }
            }, this);

            /*button.on('pointerout', function(){
                console.log('pointer OUT');
                if (this.continuousThrust)
                {
                    console.log('pointer OUT');
                    button.setFrame('out');
                    callback.call(this);
                }
            }, this);*/

            /*button.on('pointermove', function(pointer){
                
                if (this.continuousThrust)
                {
                    console.log('pointer x');
                    console.log(pointer.x);
                    console.log('pointer y')
                    console.log(pointer.y);
                }
                 if (this.continuousThrust && !button.getBounds().contains(pointer.worldX, pointer.worldY))
                {
                    console.log('pointer OUT');
                    button.setFrame('out');
                    callback.call(this);
                }
            }, this);*/

            var buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', text, 16);
            buttonLabel.setDepth(102);
            console.log(button.getBounds());
            return button;
        }
    }, {
        key: 'makeMuteButton',
        value: function makeMuteButton(imageKey, text, posX, posY) {
            if (this.game.soundPaused) {
                var startFrame = 'muteOffOut';
            } else {
                var startFrame = 'muteOnOut';
            }
            var button = this.add.image(posX, posY, imageKey, startFrame).setInteractive();
            button.setDepth(101);
            button.on('pointerdown', function () {
                if (this.game.soundPaused) {
                    button.setFrame('muteOffDown');
                } else {
                    button.setFrame('muteOnDown');
                    this.buttonSound.play();
                }
            }, this);
            button.on('pointerup', function () {
                if (this.game.soundPaused) {
                    this.game.soundPaused = false;
                    this.sound.resumeAll();
                    //this.sound.volume = 1;
                    button.setFrame('muteOnOut');
                } else {
                    this.game.soundPaused = true;
                    this.sound.pauseAll();
                    //this.sound.volume = 0;
                    button.setFrame('muteOffOut');
                }
            }, this);
            var buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', text, 16);
            buttonLabel.setDepth(102);
            return button;
        }
    }, {
        key: 'showWinPopup',
        value: function showWinPopup() {
            if (this.winPopup.alpha === 0) {
                if (!this.game.soundPaused) this.winSound.play();
                this.winPopup.alpha = 1;
                this.freezed = true;
                this.pauseButton.disableInteractive();

                this.nextLevelButton.setInteractive();
                this.replayButton.setInteractive();
            }
        }
    }, {
        key: 'okayInstructions',
        value: function okayInstructions() {
            if (this.bonusPopup.alpha > 0) {
                this.bonusPopup.alpha = 0;
                this.restartScene();
            } else if (this.tipPopup.alpha > 0) {
                this.tipPopup.alpha = 0;
                this.restartScene();
            }
        }
    }, {
        key: 'showFinalPopup',
        value: function showFinalPopup() {
            if (this.finalPopup.alpha === 0) {
                if (!this.game.soundPaused) this.winSound.play();
                this.finalPopup.alpha = 1;
                this.finalGoLevelChoiceButton.setInteractive();
                this.finalReplayButton.setInteractive();
                this.freezed = true;
                this.pauseButton.disableInteractive();
            }
        }
    }, {
        key: 'showMazeWinPopup',
        value: function showMazeWinPopup() {
            if (this.mazeWinPopup.alpha === 0) {
                if (!this.game.soundPaused) this.winSound.play();
                this.mazeWinPopup.alpha = 1;
                this.mazeWinLevelChoiceButton.setInteractive();
                this.freezed = true;
                this.pauseButton.disableInteractive();
            }
        }
    }, {
        key: 'goLevelChoice',
        value: function goLevelChoice() {
            this.anims.remove('idle');
            this.anims.remove('fly');
            this.anims.remove('shock');
            this.anims.remove('rocketLaunch');
            this.anims.remove('dustSplash');
            this.anims.remove('flashMain');
            this.anims.remove('smokeAnimation');

            if (this.game.levelNumber > this.game.lastAvailLevel) {
                this.game.lastAvailLevel = this.game.levelNumber;
                localStorage.setItem('rocketateNextLevelNumber', this.game.lastAvailLevel);
            }

            wallGenerator.clearTextures();
            this.time.delayedCall(200, function () {
                this.scene.start('LevelChoiceScene');
            }, [], this);
        }
    }, {
        key: 'winMazeLevel',
        value: function winMazeLevel() {
            this.game.tankNumber++;
            localStorage.setItem('rocketateNextTankNumber', this.game.tankNumber);

            this.anims.remove('idle');
            this.anims.remove('fly');
            this.anims.remove('shock');
            this.anims.remove('rocketLaunch');
            this.anims.remove('dustSplash');
            this.anims.remove('flashMain');
            this.anims.remove('smokeAnimation');

            wallGenerator.clearTextures();
            this.time.delayedCall(200, function () {
                this.scene.start('LevelChoiceScene');
            }, [], this);
        }
    }, {
        key: 'showLosePopup',
        value: function showLosePopup(animation, frame) {
            if (animation.key === 'shock' && this.losePopup.alpha === 0) {
                //if (this.game.backgroundMusic.isPlaying) this.game.backgroundMusic.pause();
                if (!this.game.soundPaused) this.loseSound.play();
                this.losePopup.alpha = 1;
                this.loseReplayButton.setInteractive();
                this.freezed = true;
                this.pauseButton.disableInteractive();
                //console.log('animation complete called');
                //console.log(animation);
                //console.log(frame);
            }
        }
    }, {
        key: 'launchNextLevel',
        value: function launchNextLevel() {
            this.winPopup.alpha = 0;
            this.nextLevelButton.disableInteractive();
            this.replayButton.disableInteractive();

            window.updateTimePlayed(this.game);

            // update fuel tanks number

            if (this.noFuelUsed && this.levelsWithNoFuel.indexOf(this.game.levelNumber) < 0) {
                if (this.bonusPopup.alpha === 0) {
                    this.bonusPopup.alpha = 1;
                    this.bonusOkayButton.setInteractive();
                }
                this.tankNumber++;
                this.levelsWithNoFuel.push(this.game.levelNumber);
                localStorage.setItem('rocketateNextLevelsWithNoFuel', JSON.stringify(this.levelsWithNoFuel.slice()));
                this.game.tankNumber = this.tankNumber;
                localStorage.setItem('rocketateNextTankNumber', this.tankNumber);
                this.game.levelNumber++;
            } else if (this.game.levelNumber === 16 && !JSON.parse(localStorage.getItem('rocketateNextMazeTipShown'))) {
                if (this.mazeLevelTipPopup.alpha === 0) {
                    this.mazeLevelTipPopup.alpha = 1;
                    this.mazeTipButton.setInteractive();
                }
                this.game.tankNumber = this.tankNumber;
                localStorage.setItem('rocketateNextTankNumber', this.tankNumber);
                this.game.levelNumber++;
            } else {
                this.game.tankNumber = this.tankNumber;
                localStorage.setItem('rocketateNextTankNumber', this.tankNumber);
                this.game.levelNumber++;
                this.restartScene();
            }
        }
    }, {
        key: 'replayLevel',
        value: function replayLevel() {
            this.winPopup.alpha = 0;
            this.losePopup.alpha = 0;
            this.pausePopup.alpha = 0;
            this.nextLevelButton.disableInteractive();
            this.replayButton.disableInteractive();
            this.loseReplayButton.disableInteractive();
            this.pauseReplayButton.disableInteractive();
            this.pauseContinueButton.disableInteractive();
            this.pauseMainMenuButton.disableInteractive();
            this.pauseMuteButton.disableInteractive();
            this.finalGoLevelChoiceButton.disableInteractive();
            this.finalReplayButton.disableInteractive();

            window.updateTimePlayed(this.game);

            if (this.game.timePlayed > 10 * 60) {
                console.log('replay at more 10 min');
                if (this.replayCount >= 5) {
                    window.showAd(this.game);
                    this.replayCount = 0;
                }
            }

            if (this.game.levelNumber > 0 && this.bouncy.currentFuel === 0 && !JSON.parse(localStorage.getItem('rocketateNextTipShown'))) {
                this.tipPopup.alpha = 1;
                this.tipOkayButton.setInteractive();

                this.pauseContinueButton.disableInteractive();
                this.pauseMuteButton.disableInteractive();
                this.pauseReplayButton.disableInteractive();
                this.pauseMainMenuButton.disableInteractive();
                this.loseReplayButton.disableInteractive();

                localStorage.setItem('rocketateNextTipShown', JSON.stringify(true));
            } else {
                this.restartScene();
            }
        }
    }, {
        key: 'pauseGame',
        value: function pauseGame() {
            //if (this.game.backgroundMusic.isPlaying) this.game.backgroundMusic.pause();
            this.pausePopup.alpha = 1;
            this.pauseButton.disableInteractive();

            this.pauseReplayButton.setInteractive();
            this.pauseContinueButton.setInteractive();
            this.pauseMainMenuButton.setInteractive();
            this.pauseMuteButton.setInteractive();
            this.freezed = true;
        }
    }, {
        key: 'continueGame',
        value: function continueGame() {
            this.pausePopup.alpha = 0;
            this.pauseButton.setInteractive();

            this.pauseReplayButton.disableInteractive();
            this.pauseContinueButton.disableInteractive();
            this.pauseMainMenuButton.disableInteractive();
            this.pauseMuteButton.disableInteractive();
            this.freezed = false;

            //if (this.game.backgroundMusic.isPaused) this.game.backgroundMusic.resume();
        }
    }, {
        key: 'respondLandscape',
        value: function respondLandscape() {
            this.playPortrait.alpha = 1;
        }
    }, {
        key: 'respondPortrait',
        value: function respondPortrait() {
            this.playPortrait.alpha = 0;
        }
    }, {
        key: 'update',
        value: function update(time, delta) {

            //console.log('upate called');

            //this.game.customPipeline.setFloat1('time', this.cTime);        

            //this.cTime += 0.005;

            if (this.playing) {

                //PlainCollider.drawColliders(this.debugGraphics);

                if (!this.freezed) {

                    PlainCollider.checkCollisions();
                    PlainCollider.moveAll(delta);

                    // launch collision particles

                    /*if (this.launchCollisionEmitter)
                    {
                         this.collisionPoints.forEach(function(colPoint){
                            var spreadAngle = colPoint.spreadVec.angle() / Math.PI * 180;
                            if (spreadAngle < 0) this.collisionEmitter.setFrame('right');
                            else this.collisionEmitter.setFrame('left');
                            this.collisionEmitter.setAngle({min: spreadAngle - 10, max: spreadAngle + 10});
                            this.collisionEmitter.explode(7, colPoint.point.x, colPoint.point.y);
                        }, this);
                    }*/

                    /*var engineDrift = 0;
                     if (this.bouncy.thrustSmokeSprite? 
                        this.bouncy.thrustSmokeSprite.alpha === 1: this.bouncy.engineEmitter.on)
                    {
                        engineDrift = Math.round(Math.random()*5);
                         if (engineDrift + this.bouncy.engineEmitter.x > this.bouncy.x)
                        {
                            engineDrift = 0;
                        } else if (engineDrift + this.bouncy.engineEmitter.x < this.bouncy - this.bouncy.displayWidth*0.5)
                        {
                            engineDrift = 0;
                        }
                        
                    }*/

                    var thrustPosX = this.bouncy.x - this.bouncy.displayWidth * 0.25,
                        thrustPosY = this.bouncy.y + this.bouncy.displayHeight * 0.5;
                    if (this.bouncy.thrustSmokeSprite) {
                        if (!this.bouncy.smokeAnimation.paused) {
                            if (this.bouncy.thrustSmokeSprite.alpha === 0) this.bouncy.thrustSmokeSprite.alpha = 1;
                            this.bouncy.thrustSmokeSprite.setPosition(thrustPosX, thrustPosY);
                        }
                    } else {
                        this.bouncy.engineEmitter.setPosition(thrustPosX, thrustPosY);
                        this.bouncy.smokeEmitter.setPosition(thrustPosX, thrustPosY);
                        this.bouncy.smokeShadowEmitter.setPosition(thrustPosX, thrustPosY);
                    }

                    if (this.leftKey.isDown) {
                        this.rotateMazeRightTween();
                    } else if (this.rightKey.isDown) {
                        this.rotateMazeLeftTween();
                    } else if (this.upKey.isDown && this.game.device.os.desktop) {
                        this.thrustBouncy(delta);
                    } /*else if (this.sKey.isDown) {
                        PlainCollider.reporting = true;
                      }*/

                    if (!this.game.device.os.desktop) {

                        if (this.continuousThrust) {
                            this.thrustBouncy(delta);
                            var pointerPos = this.input.activePointer.positionToCamera(this.HUDCamera);
                            if (!this.thrustButton.getBounds().contains(pointerPos.x, pointerPos.y)) {
                                this.continuousThrust = false;
                                this.thrustButton.setFrame('out');
                                //console.log('pointer OUT');
                            }
                        } else {
                            if (this.bouncy.iceProduction && (this.bouncy.thrustSmokeSprite ? this.bouncy.thrustSmokeSprite.alpha === 1 : this.bouncy.engineEmitter.on)) {
                                this.createIceWall();
                                this.bouncy.iceProduction = false;
                                this.bouncy.coldWallTop = null;
                            }
                            this.stopBouncyThrust();
                        }
                    }

                    // stop emitting engine particles

                    if (!this.upKey.isDown && this.game.device.os.desktop) {
                        // produce ice wall after launching from cold pad
                        if (this.bouncy.iceProduction && (this.bouncy.thrustSmokeSprite ? this.bouncy.thrustSmokeSprite.alpha === 1 : this.bouncy.engineEmitter.on)) {
                            this.createIceWall();
                            this.bouncy.iceProduction = false;
                            this.bouncy.coldWallTop = null;
                        }
                        this.stopBouncyThrust();
                    }

                    //PlainCollider.sortPairsByPriority();

                    this.bouncy.update(time, delta);
                    this.maze.children.each(function (entity) {
                        if (entity.rocketateType != RocketateTypeDict.floor) {
                            entity.update(time, delta);
                        }
                    }, this);

                    var toFinishVec = new Phaser.Math.Vector2(this.bouncy.x - this.finish.x, this.bouncy.y - this.finish.y);

                    if (this.bouncy.inLava) {
                        this.bouncy.inLava = false;
                        if (!this.bouncy.inShock) {
                            //console.log('bouncy shocked');
                            this.bouncy.play('shock');
                            if (!this.game.soundPaused) this.shockSound.play();
                            this.bouncy.inShock = true;
                        }
                    }

                    if (toFinishVec.length() < 40 && !this.bouncy.inShock) {
                        if (this.game.levelNumber < this.game.totalLevels && this.game.levelNumber > 0) {
                            //console.log(toFinishVec);
                            //console.log(this.bouncy.x);
                            //console.log(this.bouncy.y);
                            this.showWinPopup();
                        } else if (this.game.levelNumber === this.game.totalLevels) {
                            this.showFinalPopup();
                        } else if (this.game.levelNumber === 0) {
                            this.showMazeWinPopup();
                        }
                    }

                    PlainCollider.updateObjectsIds();
                }

                if (this.rKey.isDown && this.acceptingKeyboard) {

                    if (this.losePopup.alpha === 1 || this.winPopup.alpha === 1 || this.pausePopup.alpha === 1) {
                        this.replayLevel();
                    }

                    this.acceptingKeyboard = false;
                    this.time.delayedCall(1000, function () {
                        this.acceptingKeyboard = true;
                    }, [], this);
                }

                if (this.nKey.isDown && this.acceptingKeyboard) {
                    if (this.winPopup.alpha === 1) {
                        this.launchNextLevel();
                    } else if (this.tipPopup.alpha === 1 || this.bonusPopup.alpha === 1) {

                        this.okayInstructions();
                    } else if (this.mazeLevelTipPopup.alpha === 1) {
                        this.goLevelChoice();
                    }

                    this.acceptingKeyboard = false;
                    this.time.delayedCall(1000, function () {
                        this.acceptingKeyboard = true;
                    }, [], this);
                }

                // need to update the floor every frames
                // even when freezed, to rotate its alpha mask
                this.floor.update(time, delta);
                //this.cameraCenter.x = (this.bouncy.x + this.finish.x)*0.5;
                //this.cameraCenter.y = (this.bouncy.y + this.finish.y)*0.5;  
            }
        }
    }]);

    return PlayScene;
}(Phaser.Scene);

//below code is taken from https://stackoverflow.com/questions/7837456/how-to-compare-arrays-in-javascript
// Warn if overriding existing method


if (Array.prototype.equals) console.warn("Overriding existing Array.prototype.equals. Possible causes: New API defines the method, there's a framework conflict or you've got double inclusions in your code.");
// attach the .equals method to Array's prototype to call it on any array
Array.prototype.equals = function (array) {
    // if the other array is a falsy value, return
    if (!array) return false;

    // compare lengths - can save a lot of time 
    if (this.length != array.length) return false;

    for (var i = 0, l = this.length; i < l; i++) {
        // Check if we have nested arrays
        if (this[i] instanceof Array && array[i] instanceof Array) {
            // recurse into the nested arrays
            if (!this[i].equals(array[i])) return false;
        } else if (typeof this[i] === "number" && typeof array[i] === "number") {
            if (Math.abs(this[i] - array[i]) > 0.01) {
                return false;
            }
        } else if (this[i] != array[i]) {
            // Warning - two different object instances will never be equal: {x:20} != {x:20}
            return false;
        }
    }
    return true;
};
// Hide method from for-in loops
Object.defineProperty(Array.prototype, "equals", { enumerable: false });

/***/ }),

/***/ 1423:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SAT = __webpack_require__(1424);

var Pair = exports.Pair = function () {
	function Pair(object1, object2, plainCollider) {
		_classCallCheck(this, Pair);

		//console.log(object1);
		//console.log(object2);

		this.object1 = object1;
		this.object2 = object2;

		// listen to destroy events
		this.object1.on('destroy', this.remove, this);
		this.object2.on('destroy', this.remove, this);

		// give a pair array to the pair to manage pair remove
		this.plainCollider = plainCollider;
		this.collisionChecked = false;
		this.previouslyCollided = false;
		this.nowCollided = false;
		this.checksInIteration = 0;
		this.collisionPoints = [];
		//console.log(this.pairArray);
		/*if (this.object2.movability===2 && this.object1.wallNumber==='2') {
  	this.reporting = true;
  }*/
		/*if (this.object1.wallNumber==='4' && this.object2.wallNumber==='2') {
  	this.reporting = true;	
  }*/
	}

	_createClass(Pair, [{
		key: 'checkPairCollision',
		value: function checkPairCollision() {
			this.collisionChecked = true;
			this.checksInIteration++;

			if (this.object1.collWith.indexOf(this.object2.collGroup) >= 0 && this.object2.collWith.indexOf(this.object1.collGroup) >= 0) {

				for (var b1 = 0; b1 < this.object1.collider.length; b1++) {
					for (var b2 = 0; b2 < this.object2.collider.length; b2++) {

						var collision = { collided: false };

						var body1 = this.object1.collider[b1],
						    body2 = this.object2.collider[b2];

						var bounds1 = this.getBoundsOfBody(body1),
						    bounds2 = this.getBoundsOfBody(body2);

						bounds1.x += this.object1.vel.x + this.object1.lastCorrection.x;
						bounds2.x += this.object2.vel.x + this.object2.lastCorrection.x;
						bounds1.y += this.object1.vel.y + this.object1.lastCorrection.y;
						bounds2.y += this.object2.vel.y + this.object2.lastCorrection.y;

						if (Phaser.Geom.Rectangle.Overlaps(bounds1, bounds2)) {

							var intentCollider1 = body1.map(function (segment) {
								return { point: segment.point.clone(), direction: segment.direction.clone(), normal: segment.normal.clone() };
							}, this);
							intentCollider1.forEach(function (segment) {
								segment.point.add(this.object1.vel);
								segment.point.add(this.object1.lastCorrection);
							}, this);

							var intentCollider2 = body2.map(function (segment) {
								return { point: segment.point.clone(), direction: segment.direction.clone(), normal: segment.normal.clone() };
							}, this);
							intentCollider2.forEach(function (segment) {
								segment.point.add(this.object2.vel);
								segment.point.add(this.object2.lastCorrection);
							}, this);

							collision = SAT.findIntersection(intentCollider1, intentCollider2);
						}

						if (collision.collided && this.checksInIteration < 10) {
							if (collision.point1.length === 2 && collision.point2.length === 2) {
								this.nowCollided = true;
								// define collision points for coliision particles
								var length1 = collision.point1[0].distance(collision.point1[1]),
								    length2 = collision.point2[0].distance(collision.point2[1]);

								if (length1 < length2) {
									var colPoint1 = collision.point1[0],
									    colPoint2 = collision.point1[1];
								} else {
									var colPoint1 = collision.point2[0],
									    colPoint2 = collision.point2[1];
								}

								var spreadVec1 = colPoint1.clone().subtract(colPoint2).normalize(),
								    spreadVec2 = colPoint2.clone().subtract(colPoint1).normalize();

								/*spreadVec1.scale(3);
        spreadVec2.scale(3);
        	spreadVec1.subtract(collision.normal);
        spreadVec2.subtract(collision.normal);*/

								this.collisionPoints = [{ point: colPoint1, spreadVec: spreadVec1 }, { point: colPoint2, spreadVec: spreadVec2 }];
							}

							// define objects response

							if (this.object1.movability > this.object2.movability) {
								if (this.reporting) {
									console.log('case 1');
								}
								var correctionVec = collision.pushOutVec;
								var resCorrection = this.object1.velCorrection(correctionVec, collision.point1, collision.normal, this.object2, this);
								if (resCorrection.vector.length() > 0) {
									resCorrection.vector.scale(-1);
									this.object2.velCorrection(resCorrection.vector, collision.point2, collision.normal.clone().scale(-1), this.object1, this, resCorrection.ultimate);
								}
							} else if (this.object1.movability < this.object2.movability) {
								// here penetration vector goes to correction with negative sign, to show the direction of penetration
								//console.log('second typ');
								if (this.reporting) {
									console.log('case 2');
								}
								var correctionVec = collision.pushOutVec.scale(-1);
								var resCorrection = this.object2.velCorrection(correctionVec, collision.point2, collision.normal, this.object1, this);
								if (resCorrection.vector.length() > 0) {
									resCorrection.vector.scale(-1);
									this.object1.velCorrection(resCorrection.vector, collision.point1, collision.normal, this.object2, this, resCorrection.ultimate);
								}
								if (this.reporting) {
									console.log('collision object');
									console.log(collision);
									console.log(intentCollider1);
									console.log(intentCollider2);
									/*console.log('residual correction');
         console.log(resCorrection);
         console.log('correction vector');
         console.log(correctionVec);*/
								}
							} else {
								if (this.reporting) {
									console.log('########equal movability###########');
								}

								if (this.object1.lastCorrPriority > this.object2.lastCorrPriority) {
									//console.log('no push back case');
									var correctionVec = collision.pushOutVec;
									var resCorrection = this.object1.velCorrection(correctionVec, collision.point1, collision.normal, this.object2, this);
									if (resCorrection.vector.length() > 0) {
										resCorrection.vector.scale(-1);
										this.object2.velCorrection(resCorrection.vector, collision.point2, collision.normal, this.object1, this, resCorrection.ultimate);
									}
									if (this.reporting) {
										console.log('object 1');
										console.log(this.object1.vel);
										console.log(this.object1.lastCorrection);
										console.log('object 2');
										console.log(this.object2.vel);
										console.log(this.object2.lastCorrection);
									}
								} else {
									//console.log('no push back case');
									var correctionVec = collision.pushOutVec.scale(-1);
									var resCorrection = this.object2.velCorrection(correctionVec, collision.point2, collision.normal, this.object1, this);
									//console.log(resCorrection);
									if (resCorrection.vector.length() > 0) {
										resCorrection.vector.scale(-1);
										this.object1.velCorrection(resCorrection.vector, collision.point1, collision.normal, this.object2, this, resCorrection.ultimate);
									}
									if (this.reporting) {
										console.log('_________start from pair');
										console.log('no corr prioroty');
										console.log(correctionVec);
										console.log(resCorrection);
										console.log('object 1');
										console.log(this.object1.vel);
										console.log(this.object1.lastCorrection);
										console.log(this.object1.constraints);
										console.log('object 2');
										console.log(this.object2.vel);
										console.log(this.object2.lastCorrection);
										console.log(this.object1.constraints);
										console.log('_________end from pair');
									}
								}
							}
							if (this.object1.movability === 2) {
								this.object1.collidedWith(this.object2);
							} else if (this.object2.movability === 2) {
								this.object2.collidedWith(this.object1);
							}
							return true;
						} else if (this.checksInIteration >= 10) {
							this.object1.vel = new Phaser.Math.Vector2();
							this.object2.vel = new Phaser.Math.Vector2();
						}
					}
					//if (collision.collided) break;
				}
			}
			return false;
		}
	}, {
		key: 'remove',
		value: function remove(destroyedObject) {
			//console.log('remove called');
			//console.log(destroyedObject);

			this.plainCollider.removeObject(destroyedObject);
			this.object1 = undefined;
			this.object2 = undefined;
		}
	}, {
		key: 'updateCollisionStatus',
		value: function updateCollisionStatus() {
			this.previouslyCollided = this.nowCollided;
			this.nowCollided = false;
			this.collisionChecked = false;
			this.checksInIteration = 0;
		}
	}, {
		key: 'getBoundsOfBody',
		value: function getBoundsOfBody(body) {
			var leftMostX = body.reduce(function (acc, curr, arr) {
				if (acc > curr.point.x) {
					return curr.point.x;
				}
				return acc;
			}, body[0].point.x),
			    rightMostX = body.reduce(function (acc, curr, arr) {
				if (acc < curr.point.x) {
					return curr.point.x;
				}
				return acc;
			}, body[0].point.x),
			    topMostY = body.reduce(function (acc, curr, arr) {
				if (acc > curr.point.y) {
					return curr.point.y;
				}
				return acc;
			}, body[0].point.y),
			    bottomMostY = body.reduce(function (acc, curr, arr) {
				if (acc < curr.point.y) {
					return curr.point.y;
				}
				return acc;
			}, body[0].point.y);

			return new Phaser.Geom.Rectangle(leftMostX, topMostY, rightMostX - leftMostX, bottomMostY - topMostY);
		}
	}]);

	return Pair;
}();

module.exports = Pair;

/***/ }),

/***/ 1424:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var SAT = {
	findIntersection: function findIntersection(collider1, collider2, report) {

		var collision = { collided: false, point1: undefined, point2: undefined, pushOutVec: undefined, normal: undefined };

		// find minimal overlap by each axis
		var overlapByAxes = this.findMinOverlap(collider1, collider2);
		// if axis with no overlap found return non collided collision
		if (overlapByAxes.magnitude < 0.0001) return collision;else {
			collision.collided = true;

			//var pushOutPoint1 = overlapByAxes.pushPoint1.clone();
			//pushOutPoint1.add(overlapByAxes.pushOutVec);
			collision.point1 = overlapByAxes.pushPoint1.slice();

			//var pushOutPoint2 = overlapByAxes.pushPoint2.clone();
			//pushOutPoint2.subtract(overlapByAxes.pushOutVec);
			collision.point2 = overlapByAxes.pushPoint2.slice();

			collision.pushOutVec = overlapByAxes.pushOutVec;

			collision.normal = overlapByAxes.axis;
		}

		return collision;
	},

	findMinOverlapOld: function findMinOverlapOld(colliderAxes, collider, axes) {
		// here colliderAxes is collider from wich normals treated as axes
		// i.e. a candidate to be collider penetrated
		var minOverlap = { magnitude: this.projectOnAxis(colliderAxes, axes[0]).magnitude, axis: axes[0], pushOutVec: new Phaser.Math.Vector2(), pushPoint1: new Phaser.Math.Vector2(), pushPoint2: new Phaser.Math.Vector2() };
		for (var a = 0; a < axes.length; a++) {
			var projectionOfColliderAxes = this.projectOnAxis(colliderAxes, axes[a]),
			    projectionOfCollider = this.projectOnAxis(collider, axes[a]);

			var currentOverlap = this.findOverlap(projectionOfColliderAxes, projectionOfCollider);
			//console.log(axes[a]);
			//console.log(currentOverlap);
			if (currentOverlap === 0) {
				return { magnitude: 0, axis: axes[a], penetrationPoint: undefined };
			} else {
				if (currentOverlap < minOverlap.magnitude) {
					// find penetration point as if collider, providing axes, is penetrated collider
					//var penetrationPoint = this.findPenetrationPoint(projectionOfColliderAxes, projectionOfCollider);

					// find push out vector for collider providing axis and points penetrating for both
					var pushOut = this.findPushOutVec(projectionOfColliderAxes, projectionOfCollider, axes[a]),
					    minOverlap = { magnitude: currentOverlap, axis: axes[a], pushOutVec: pushOut.pushOutVec, pushPoint1: pushOut.point1, pushPoint2: pushOut.point2 };
				}
			}
		}

		return minOverlap;
	},

	findMinOverlap: function findMinOverlap(collider1, collider2) {
		var axes = [new Phaser.Math.Vector2(1, 0), new Phaser.Math.Vector2(0, 1)],
		    southEast = false,
		    northEast = false;

		for (var s = 0; s < collider1.length; s++) {
			var dir = collider1[s].direction.clone();
			if (dir.x != 0 && dir.y != 0) {
				if (dir.x * dir.y > 0 && !northEast) {
					axes.push(new Phaser.Math.Vector2(1 / Math.sqrt(2), -1 / Math.sqrt(2)));
					northEast = true;
				} else if (!southEast) {
					axes.push(new Phaser.Math.Vector2(1 / Math.sqrt(2), 1 / Math.sqrt(2)));
					southEast = true;
				}
			}
		}

		if (!northEast || !southEast) {
			for (var s = 0; s < collider2.length; s++) {
				var dir = collider2[s].direction.clone();
				if (dir.x != 0 && dir.y != 0) {
					if (dir.x * dir.y > 0 && !northEast) {
						axes.push(new Phaser.Math.Vector2(1 / Math.sqrt(2), -1 / Math.sqrt(2)));
						northEast = true;
					} else if (!southEast) {
						axes.push(new Phaser.Math.Vector2(1 / Math.sqrt(2), 1 / Math.sqrt(2)));
						southEast = true;
					}
				}
			}
		}

		var minOverlap = { magnitude: this.projectOnAxis(collider1, axes[0]).magnitude,
			axis: axes[0], pushOutVec: new Phaser.Math.Vector2(),
			pushPoint1: [],
			pushPoint2: [] };

		for (var a = 0; a < axes.length; a++) {
			var projectionOfCollider1 = this.projectOnAxis(collider1, axes[a]),
			    projectionOfCollider2 = this.projectOnAxis(collider2, axes[a]);

			var currentOverlap = this.findOverlap(projectionOfCollider1, projectionOfCollider2);
			//console.log(axes[a]);
			//console.log(currentOverlap);
			if (currentOverlap === 0) {
				return { magnitude: 0, axis: axes[a], penetrationPoint: undefined };
			} else {
				var pushOut = this.findPushOutVec(projectionOfCollider1, projectionOfCollider2, axes[a]);

				if (currentOverlap < minOverlap.magnitude) {

					minOverlap.magnitude = currentOverlap;
					minOverlap.axis = axes[a];
					minOverlap.pushPoint1 = pushOut.point1;
					minOverlap.pushPoint2 = pushOut.point2;
				}

				if (axes[a].y === 0) {
					minOverlap.pushOutVec.x = pushOut.pushOutVec.x;
				} else if (axes[a].x === 0) {
					minOverlap.pushOutVec.y = pushOut.pushOutVec.y;
				}
			}
		}

		return minOverlap;
	},

	projectOnAxis: function projectOnAxis(collider, axis) {
		var minProj = collider[0].point.dot(axis),
		    maxProj = collider[0].point.dot(axis),
		    minPoint = [collider[0].point],
		    maxPoint = [collider[0].point];

		for (var s = 1; s < collider.length; s++) {
			var currentProj = collider[s].point.dot(axis);
			if (currentProj > maxProj) {
				maxProj = currentProj;
				maxPoint[0] = collider[s].point;
			} else if (Math.abs(currentProj - maxProj) < 1) {
				maxPoint[1] = collider[s].point;
			}
			if (currentProj < minProj) {
				minProj = currentProj;
				minPoint[0] = collider[s].point;
			} else if (Math.abs(currentProj - minProj) < 1) {
				minPoint[1] = collider[s].point;
			}
		}

		return { min: minProj, max: maxProj, minPoint: minPoint, maxPoint: maxPoint, magnitude: maxProj - minProj };
	},

	findPushOutVec: function findPushOutVec(proj1, proj2, axis) {
		var pushOutVec = axis.clone();
		if (proj1.max > proj2.max) {
			if (proj1.min > proj2.min) {
				pushOutVec.scale(proj2.max - proj1.min);
				return { pushOutVec: pushOutVec, point1: proj1.minPoint, point2: proj2.maxPoint };
			} else {
				pushOutVec.scale(proj2.min - proj1.max);
				return { pushOutVec: pushOutVec, point1: proj1.maxPoint, point2: proj2.minPoint };
			}
		} else {
			if (proj1.min > proj2.min) {
				pushOutVec.scale(proj2.max - proj1.min);
				return { pushOutVec: pushOutVec, point1: proj1.minPoint, point2: proj2.maxPoint };
			} else {
				pushOutVec.scale(proj2.min - proj1.max);
				return { pushOutVec: pushOutVec, point1: proj1.maxPoint, point2: proj2.minPoint };
			}
		}
	},

	findOverlap: function findOverlap(projection1, projection2) {
		/*if (projection1.min > projection2.max || projection2.min > projection1.max) 
  {
  	return 0;
  } else if (projection1.max > projection2.max && projection1.min <= projection2.min)
  {
  	return projection2.max - projection2.min;
  } else if (projection2.max > projection1.max && projection2.min <= projection1.min)
  {
  	return projection1.max - projection1.min;
  } else
  {
  	return Math.min(projection2.max - projection1.min, projection1.max - projection2.min); 
  }*/

		if (projection1.min <= projection2.max && projection1.max > projection2.min) {
			return Math.min(projection2.max - projection1.min, projection1.max - projection2.min, projection1.max - projection1.min, projection2.max - projection1.min);
		} else {
			return 0;
		}
	}
};

module.exports = SAT;

/***/ }),

/***/ 1425:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WoodBox = __webpack_require__(252);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);

var MetalBox = exports.MetalBox = function (_WoodBox) {
	_inherits(MetalBox, _WoodBox);

	function MetalBox(scene, edges, wallNumber) {
		_classCallCheck(this, MetalBox);

		var _this = _possibleConstructorReturn(this, (MetalBox.__proto__ || Object.getPrototypeOf(MetalBox)).call(this, scene, edges, wallNumber));

		_this.lastCorrPriority = _this.movability;
		_this.electric = true;

		/*if (!scene.anims.get('metalBoxMain'))
  {
  	this.mainAnim = scene.anims.create({key: 'metalBoxMain', frames: scene.anims.generateFrameNames('metalBox', {start: 1, end: 4}), 
  		repeat: -1, frameRate: 10});	
  } else {
  	this.mainAnim = scene.anims.get('metalBoxMain');
  }
  
  this.play('metalBoxMain');*/

		_this.flashSprite = scene.add.sprite(_this.x, _this.y, 'metalBoxFlash');
		_this.flashSprite.setDepth(11);
		_this.flashSprite.setOrigin(0, 0.5);

		_this.flashShine = scene.add.sprite(_this.x, _this.y, 'flashShine');
		_this.flashShine.setDepth(10);
		//this.flashShine.setOrigin(0, 0.5);
		//this.flashShine.setBlendMode(Phaser.BlendModes.ADD);
		_this.flashShine.alpha = 0;

		if (!scene.anims.get('metalBoxFlashMain')) {
			_this.mainAnim = scene.anims.create({ key: 'metalBoxFlashMain',
				frames: scene.anims.generateFrameNames('metalBoxFlash', { start: 1, end: 6 }),
				repeat: -1, frameRate: 10 });
		} else {
			_this.mainAnim = scene.anims.get('metalBoxFlashMain');
		}

		_this.mainAnim.pause();

		//this.flashSprite.play('metalBoxFlashMain');
		_this.flashSprite.alpha = 0;

		_this.inRotation = false;

		//this.alphaEvent = this.scene.time.delayedCall(600 + 800*Math.random(), 
		//	this.changeDischargeAlpha, [], this);

		_this.rocketateType = RocketateTypeDict.metalBox;
		return _this;
	}

	_createClass(MetalBox, [{
		key: 'prepareTexture',
		value: function prepareTexture() {
			return 'metalBox';
		}
	}, {
		key: 'startRotation',
		value: function startRotation() {
			this.flashSprite.alpha = 0;
			this.flashShine.alpha = 0;
			this.inRotation = true;
			//this.alphaEvent.destroy();
		}
	}, {
		key: 'endRotation',
		value: function endRotation() {
			this.inRotation = false;
			//this.alphaEvent = this.scene.time.delayedCall(600 + 800*Math.random(), this.changeDischargeAlpha, [], this);
		}
	}, {
		key: 'changeDischargeAlpha',
		value: function changeDischargeAlpha() {
			if (this && !this.inRotation) {
				if (!this.inRotation) {
					if (this.flashSprite.alpha === 0) {
						var i = Math.round(Math.random() * 3),
						    angle1 = Math.PI / 4 + i * Math.PI / 2,
						    angle2 = angle1 + Math.PI / 2,
						    diag = Math.hypot(this.displayWidth, this.displayHeight);

						var point1 = new Phaser.Math.Vector2(this.x + Math.cos(angle1) * diag * 0.4, this.y + Math.sin(angle1) * diag * 0.4),
						    point2 = new Phaser.Math.Vector2(this.x + Math.cos(angle2) * diag * 0.4, this.y + Math.sin(angle2) * diag * 0.4);

						this.flashSprite.setPosition(point1.x, point1.y);
						var rotation = point2.subtract(point1).angle();
						this.flashSprite.setRotation(rotation);

						this.flashSprite.alpha = 1;
						this.flashSprite.play('metalBoxFlashMain');
						this.mainAnim.resume();

						// factor of 2 goes with point1 beacuse we earlier subracted it form point2

						this.flashShine.setPosition((2 * point1.x + point2.x) * 0.5, (2 * point1.y + point2.y) * 0.5);
						this.flashShine.setRotation(rotation);
						this.flashShine.alpha = 1;
					} else {
						this.flashSprite.alpha = 0;
						this.flashShine.alpha = 0;
						this.mainAnim.pause();
					}
				}

				//this.alphaEvent = this.scene.time.delayedCall(600 + 800*Math.random(), 
				//	this.changeDischargeAlpha, [], this);
			}
		}
	}, {
		key: 'updateVel',
		value: function updateVel() {
			_get(MetalBox.prototype.__proto__ || Object.getPrototypeOf(MetalBox.prototype), 'updateVel', this).call(this);

			this.flashSprite.setPosition(this.flashSprite.x + this.vel.x, this.flashSprite.y + this.vel.y);
			this.flashShine.setPosition(this.flashShine.x + this.vel.x, this.flashShine.y + this.vel.y);
		}
	}]);

	return MetalBox;
}(WoodBox);

module.exports = MetalBox;

/***/ }),

/***/ 1426:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RocketateTypeDict = __webpack_require__(29);

var Finish = exports.Finish = function (_Phaser$GameObjects$S) {
	_inherits(Finish, _Phaser$GameObjects$S);

	function Finish(scene, posX, posY) {
		_classCallCheck(this, Finish);

		var _this = _possibleConstructorReturn(this, (Finish.__proto__ || Object.getPrototypeOf(Finish)).call(this, scene, posX, posY, 'finish'));

		scene.add.existing(_this);

		_this.setDepth(9);

		_this.rocketateType = RocketateTypeDict.finish;
		return _this;
	}

	return Finish;
}(Phaser.GameObjects.Sprite);

module.exports = Finish;

/***/ }),

/***/ 1427:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RocketateTypeDict = __webpack_require__(29);

var Floor = exports.Floor = function (_Phaser$GameObjects$I) {
    _inherits(Floor, _Phaser$GameObjects$I);

    function Floor(scene, vertices, wallNumber) {
        _classCallCheck(this, Floor);

        var tint = 0xe6e5e0;

        var leftBorder = vertices.reduce(function (acc, currentVer) {
            if (acc > currentVer[0]) {
                return currentVer[0];
            }
            return acc;
        }, vertices[0][0]),
            rightBorder = vertices.reduce(function (acc, currentVer) {
            if (acc < currentVer[0]) {
                return currentVer[0];
            }
            return acc;
        }, vertices[0][0]),
            topBorder = vertices.reduce(function (acc, currentVer) {
            if (acc > currentVer[1]) {
                return currentVer[1];
            }
            return acc;
        }, vertices[0][1]),
            bottomBorder = vertices.reduce(function (acc, currentVer) {
            if (acc < currentVer[1]) {
                return currentVer[1];
            }
            return acc;
        }, vertices[0][1]),
            floorWidth = rightBorder - leftBorder,
            floorHeight = bottomBorder - topBorder;

        //console.log(floorWidth);
        //console.log(floorHeight);

        var alignedVertices = vertices.map(function (vertex) {
            return [vertex[0] - leftBorder, vertex[1] - topBorder];
        });

        if (scene.game.renderer.type === 1) {
            // for canvas renderer
            var floorGraphics = scene.make.graphics({ fillStyle: { color: 0x5e5970 } });

            floorGraphics.clear();
            floorGraphics.save();
            floorGraphics.beginPath();
            floorGraphics.moveTo(alignedVertices[0][0], alignedVertices[0][1]);

            for (var v = 1; v < alignedVertices.length; v++) {
                floorGraphics.lineTo(alignedVertices[v][0], alignedVertices[v][1]);
            }

            floorGraphics.closePath();
            floorGraphics.fillPath();
            floorGraphics.restore();

            if (scene.textures.exists('floorGraphics')) {
                scene.textures.remove('floorGraphics');
            }

            floorGraphics.generateTexture('floorGraphics', floorWidth, floorHeight);

            var _this = _possibleConstructorReturn(this, (Floor.__proto__ || Object.getPrototypeOf(Floor)).call(this, scene, leftBorder, topBorder, 'floorGraphics'));

            scene.add.existing(_this);
        } else {
            var _this = _possibleConstructorReturn(this, (Floor.__proto__ || Object.getPrototypeOf(Floor)).call(this, scene, leftBorder, topBorder, 'levelFloor'));
            // for webgl renderer

            _this.floorGraphics = scene.make.graphics({ fillStyle: { color: 0x8d86ad } });

            _this.floorGraphics.clear();
            _this.floorGraphics.save();
            _this.floorGraphics.beginPath();
            _this.floorGraphics.moveTo(alignedVertices[0][0], alignedVertices[0][1]);

            for (var v = 1; v < alignedVertices.length; v++) {
                _this.floorGraphics.lineTo(alignedVertices[v][0], alignedVertices[v][1]);
            }

            _this.floorGraphics.closePath();
            _this.floorGraphics.fillPath();
            _this.floorGraphics.restore();

            _this.mask = new Phaser.Display.Masks.GeometryMask(scene, _this.floorGraphics);

            scene.add.existing(_this);
        }
        _this.setOrigin(0);

        _this.setDepth(0);

        _this.rocketateType = RocketateTypeDict.floor;
        return _possibleConstructorReturn(_this);
    }

    _createClass(Floor, [{
        key: 'update',
        value: function update() {
            if (this.floorGraphics) {
                this.floorGraphics.x = this.x;
                this.floorGraphics.y = this.y;
                this.floorGraphics.rotation = this.rotation;
            }
        }
    }]);

    return Floor;
}(Phaser.GameObjects.Image);

module.exports = Floor;

/***/ }),

/***/ 1428:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Bouncy = __webpack_require__(526);
var RocketateTypeDict = __webpack_require__(29);

var FuelCan = exports.FuelCan = function (_Phaser$GameObjects$S) {
	_inherits(FuelCan, _Phaser$GameObjects$S);

	function FuelCan(scene, xPos, yPos) {
		_classCallCheck(this, FuelCan);

		var _this = _possibleConstructorReturn(this, (FuelCan.__proto__ || Object.getPrototypeOf(FuelCan)).call(this, scene, xPos, yPos, 'fuelCan'));

		scene.add.existing(_this);

		var topLeft = _this.getTopLeft(),
		    bottomRight = _this.getBottomRight();

		_this.vertices = [[[topLeft.x, topLeft.y], [bottomRight.x, topLeft.y], [bottomRight.x, bottomRight.y], [topLeft.x, bottomRight.y]]];

		if (_this.scene.game.renderer.type === 2) {

			_this.haloParticles = scene.add.particles('fuelCanParticle');
			_this.haloParticles.setDepth(10);

			_this.haloEmitter = _this.haloParticles.createEmitter({
				x: { min: _this.x - _this.displayWidth / 2, max: _this.x + _this.displayWidth / 2 },
				y: _this.y,
				lifespan: 800,
				speedY: { min: -100, max: -50 },
				frequency: 200,
				scale: { start: 1, end: 0.3 }
			});
		}

		_this.vel = new Phaser.Math.Vector2();
		_this.movability = 2;
		_this.velCorrected = false;
		_this.lastCorrection = new Phaser.Math.Vector2();
		_this.lastCorrPriority = _this.movability;
		_this.resolvedPairs = [];
		_this.unresolvedPairs = [];
		_this.inLava = false;
		_this.constraints = { x: { '1': _this.movability, '-1': _this.movability }, y: { '1': _this.movability, '-1': _this.movability } };

		_this.setDepth(11);

		_this.capacity = 50;
		_this.toDestroy = false;

		_this.rocketateType = RocketateTypeDict.fuelCan;
		return _this;
	}

	_createClass(FuelCan, [{
		key: 'velCorrection',
		value: function velCorrection(correction, point, normal, otherObject, pair, ultimate) {

			var ultimatePushBack = { x: false, y: false };

			if (otherObject.__proto__.constructor === Bouncy) {
				otherObject.tankUp(this.capacity);
				this.toDestroy = true;
			}
			this.lastCorrection = correction;

			return { vector: new Phaser.Math.Vector2(), ultimate: ultimatePushBack };
		}
	}, {
		key: 'startRotation',
		value: function startRotation() {
			if (this.haloEmitter) this.haloEmitter.stop();
		}
	}, {
		key: 'endRotation',
		value: function endRotation() {
			//console.log('fuel can end rotation called');
			if (this.haloEmitter) {
				this.haloEmitter.setPosition({ min: this.x - this.displayWidth / 2,
					max: this.x + this.displayWidth / 2 }, this.y);

				//console.log(this.haloEmitter.x);
				//console.log(this.haloEmitter.y);

				this.haloEmitter.start();
			}
		}
	}, {
		key: 'updateVel',
		value: function updateVel() {
			this.vel.add(this.lastCorrection);
		}
	}, {
		key: 'update',
		value: function update() {
			if (this.toDestroy) {
				if (this.haloParticles) this.haloParticles.destroy();
				this.destroy();
			}
		}
	}]);

	return FuelCan;
}(Phaser.GameObjects.Sprite);

module.exports = FuelCan;

/***/ }),

/***/ 1429:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WoodBox = __webpack_require__(252);
var wallGenerator = __webpack_require__(40);
var PlainCollider = __webpack_require__(116);
var RocketateTypeDict = __webpack_require__(29);

var ElectricFollower = exports.ElectricFollower = function (_WoodBox) {
	_inherits(ElectricFollower, _WoodBox);

	function ElectricFollower(scene, edges, wallNumber) {
		_classCallCheck(this, ElectricFollower);

		var _this = _possibleConstructorReturn(this, (ElectricFollower.__proto__ || Object.getPrototypeOf(ElectricFollower)).call(this, scene, edges, wallNumber));

		_this.electric = true;

		_this.movability = 1;
		_this.lastCorrPriority = _this.movability;
		_this.pathVertices = edges;
		_this.constraints = { x: { '1': _this.movability, '-1': _this.movability }, y: { '1': _this.movability, '-1': _this.movability } };
		_this.velToAdd = new Phaser.Math.Vector2();

		_this.setFrame('go');

		_this.flashSprite = scene.add.sprite(_this.x, _this.y, 'electricFollowerFlash');
		_this.flashSprite.setDepth(11);
		_this.flashSprite.setOrigin(0, 0.5);

		_this.flashShine = scene.add.sprite(_this.x, _this.y, 'electricFollowerFlashShine');
		_this.flashShine.setDepth(10);
		//this.flashShine.setBlendMode(Phaser.BlendModes.ADD);
		_this.flashShine.alpha = 0;

		if (!scene.anims.get('electricFollowerFlashMain')) {
			_this.mainAnim = scene.anims.create({ key: 'electricFollowerFlashMain',
				frames: scene.anims.generateFrameNames('electricFollowerFlash', { start: 1, end: 6 }),
				repeat: -1, frameRate: 10 });
		} else {
			_this.mainAnim = scene.anims.get('electricFollowerFlashMain');
		}

		//this.flashSprite.play('electricFollowerFlashMain');
		_this.mainAnim.pause();
		_this.flashSprite.alpha = 0;
		_this.flashSprite.originAngle = 0;

		_this.inRotation = false;

		//this.alphaEvent = this.scene.time.delayedCall(600 + 400*Math.random(), 
		//	this.changeDischargeAlpha, [], this);

		// prepare and draw path
		_this.definePath();

		// prepare path sprite
		_this.definePathPositions();
		var pathTexture = _this.preparePathTexture(edges);
		_this.pathSprite = scene.add.sprite(_this.leftPointPath + _this.pathWidth / 2, _this.topPointPath + _this.pathHeight / 2, pathTexture);
		_this.pathSprite.setDepth(9);

		_this.travelSpeed = 3;
		_this.travelTime = _this.path.getLength() / _this.travelSpeed;
		_this.cT = 0;
		_this.tT = 1 / _this.travelTime;
		_this.direction = 1;

		//this.pathGraphics = scene.add.graphics({lineStyle: {color: 0xffffff}});
		//this.pathGraphics.setDepth(23);

		//this.path.draw(this.pathGraphics);
		_this.rocketateType = RocketateTypeDict.electricFollower;
		return _this;
	}

	_createClass(ElectricFollower, [{
		key: 'definePosition',
		value: function definePosition(edges) {
			this.wallWidth = 40;
			this.wallHeight = 40;
			this.leftPointWall = edges[0][0] - this.wallWidth / 2;
			this.topPointWall = edges[0][1] - this.wallHeight / 2;
		}
	}, {
		key: 'preparePathTexture',
		value: function preparePathTexture(edges) {
			var leftOffset = this.leftPointPath,
			    topOffset = this.topPointPath;

			var alignedVertices = edges.map(function (vertex) {
				return [vertex[0] - leftOffset, vertex[1] - topOffset];
			});

			// generate texture for sprite
			return wallGenerator.generateFollowerPath(this.scene, alignedVertices, this.pathWidth, this.pathHeight);
		}
	}, {
		key: 'definePathPositions',
		value: function definePathPositions() {
			var edges = this.pathVertices;
			// left, right most and top, bottom points of the wall
			this.leftPointPath = edges.reduce(function (leftPoint, currPoint) {
				if (leftPoint < currPoint[0]) {
					return leftPoint;
				}
				return currPoint[0];
			}, edges[0][0]);

			this.topPointPath = edges.reduce(function (topPoint, currPoint) {
				if (topPoint < currPoint[1]) {
					return topPoint;
				}
				return currPoint[1];
			}, edges[0][1]);

			this.rightPointPath = edges.reduce(function (rightPoint, currPoint) {
				if (rightPoint > currPoint[0]) {
					return rightPoint;
				}
				return currPoint[0];
			}, edges[0][0]);

			this.bottomPointPath = edges.reduce(function (bottomPoint, currPoint) {
				if (bottomPoint > currPoint[1]) {
					return bottomPoint;
				}
				return currPoint[1];
			}, edges[0][1]);

			this.pathWidth = this.rightPointPath - this.leftPointPath;
			this.pathHeight = this.bottomPointPath - this.topPointPath;
		}
	}, {
		key: 'prepareTexture',
		value: function prepareTexture() {
			return 'electricFollower';
		}
	}, {
		key: 'prepareShadowTexture',
		value: function prepareShadowTexture() {
			var topLeft = this.getTopLeft(),
			    bottomRight = this.getBottomRight();

			this.vertices = [[[topLeft.x, topLeft.y], [bottomRight.x, topLeft.y], [bottomRight.x, bottomRight.y], [topLeft.x, bottomRight.y]]];

			// define vertices for texture
			var edgeVertices = [[0, 0], [0, 45], [45, 45], [45, 0], [0, 0]];
			// generate texture for sprite
			return wallGenerator.generateWallShadow(this.scene, edgeVertices, this.wallWidth, this.wallHeight);
		}
	}, {
		key: 'rotatePath',
		value: function rotatePath(rotPoint, angle) {
			var rotationMatrix = new Phaser.Math.Matrix3();

			rotationMatrix.fromArray([Math.cos(angle), Math.sin(angle), 0, -Math.sin(angle), Math.cos(angle), 0, 0, 0]);

			var rotatedPathVertices = this.pathVertices.map(function (vertex) {
				var vertexVec = new Phaser.Math.Vector2(vertex[0], vertex[1]);

				vertexVec.subtract(rotPoint);
				vertexVec.transformMat3(rotationMatrix);
				vertexVec.add(rotPoint);

				return [vertexVec.x, vertexVec.y];
			}, this);

			this.pathVertices = rotatedPathVertices;
			this.definePath();

			//this.pathGraphics.clear();
			//this.path.draw(this.pathGraphics);
		}
	}, {
		key: 'startRotation',
		value: function startRotation() {
			this.flashSprite.alpha = 0;
			this.flashShine.alpha = 0;
			this.inRotation = true;
			//this.alphaEvent.destroy();
		}
	}, {
		key: 'endRotation',
		value: function endRotation(angle) {
			this.inRotation = false;
			//this.alphaEvent = this.scene.time.delayedCall(600 + 800*Math.random(), this.changeDischargeAlpha, [], this);

			// rotate velocity 
			var rotateMatrix = new Phaser.Math.Matrix3();
			rotateMatrix.fromArray([Math.cos(angle), Math.sin(angle), 0, -Math.sin(angle), Math.cos(angle), 0, 0, 0]);
			this.vel.transformMat3(rotateMatrix);
		}
	}, {
		key: 'changeDischargeAlpha',
		value: function changeDischargeAlpha() {
			if (this && !this.inRotation) {
				if (!this.inRotation) {
					if (this.flashSprite.alpha === 0) {
						var i = Math.round(Math.random() * 3),
						    angle1 = Math.PI / 4 + i * Math.PI / 2,
						    angle2 = angle1 + Math.PI / 2,
						    diag = Math.hypot(this.displayWidth, this.displayHeight);

						var point1 = new Phaser.Math.Vector2(this.x + Math.cos(angle1) * diag * 0.4, this.y + Math.sin(angle1) * diag * 0.4),
						    point2 = new Phaser.Math.Vector2(this.x + Math.cos(angle2) * diag * 0.4, this.y + Math.sin(angle2) * diag * 0.4);

						this.flashSprite.setPosition(point1.x, point1.y);
						var rotation = point2.subtract(point1).angle();
						this.flashSprite.setRotation(rotation);

						// factor of 2 goes with point1 beacuse we earlier subracted it form point2

						this.flashShine.setPosition((2 * point1.x + point2.x) * 0.5, (2 * point1.y + point2.y) * 0.5);
						this.flashShine.setRotation(rotation);
						this.flashShine.alpha = 1;

						this.flashSprite.originAngle = angle1;
						this.flashSprite.alpha = 1;

						this.flashSprite.play('electricFollowerFlashMain');
						this.mainAnim.resume();
					} else {
						this.flashSprite.alpha = 0;
						this.flashShine.alpha = 0;
						this.mainAnim.pause();
					}
				}

				//this.alphaEvent = this.scene.time.delayedCall(600 + 800*Math.random(), 
				//	this.changeDischargeAlpha, [], this);
			}
		}
	}, {
		key: 'definePath',
		value: function definePath() {
			//console.log(this.pathVertices[0][0]);

			this.path = new Phaser.Curves.Path(this.pathVertices[0][0], this.pathVertices[0][1]);

			for (var i = 1; i < this.pathVertices.length; i++) {
				this.path.lineTo(this.pathVertices[i][0], this.pathVertices[i][1]);
			}
		}
	}, {
		key: 'normalizePosition',
		value: function normalizePosition() {
			//console.log('normalize position called');
			//console.log(this.cT);
			var currentPosition = this.path.getPoint(this.cT);
			this.velToAdd.x = currentPosition.x - this.x - this.vel.x;
			this.velToAdd.y = currentPosition.y - this.y - this.vel.y;
			this.vel.add(this.velToAdd);

			//console.log(this.velToAdd.length());
			/*this.setPosition(currentPosition.x, currentPosition.y);
   var topLeft = this.getTopLeft(),
   	bottomRight = this.getBottomRight();
   	this.vertices = [[[topLeft.x, topLeft.y], [bottomRight.x, topLeft.y], 
   	[bottomRight.x, bottomRight.y], [topLeft.x, bottomRight.y]]];
   PlainCollider.updateCollider(this, this.vertices);*/

			// normalize flash position
			var angle1 = this.flashSprite.originAngle,
			    angle2 = angle1 + Math.PI / 2,
			    diag = Math.hypot(this.displayWidth, this.displayHeight);

			var point1 = new Phaser.Math.Vector2(this.x + Math.cos(angle1) * diag * 0.4, this.y + Math.sin(angle1) * diag * 0.4),
			    point2 = new Phaser.Math.Vector2(this.x + Math.cos(angle2) * diag * 0.4, this.y + Math.sin(angle2) * diag * 0.4);

			this.flashSprite.setPosition(point1.x, point1.y);

			this.flashShine.setPosition((point1.x + point2.x) * 0.5, (point1.y + point2.y) * 0.5);
		}
	}, {
		key: 'updateVel',
		value: function updateVel(delta) {

			//console.log('update velocity called in follower');
			//var beforeCorrVelocity = this.vel.clone();
			// update velocity and other stuff
			if (!this.velCorrected) //this.lastCorrection.length()===0) 
				{
					//console.log('t update');
					this.setFrame('go');
					if (this.direction > 0) {
						if (this.tT < 1 - 1 / this.travelTime * delta / (1000 / 60)) {
							this.cT = this.tT;
							this.tT += 1 / this.travelTime * delta / (1000 / 60);
						} else {
							this.tT = 1 - 1 / this.travelTime * delta / (1000 / 60);
							this.cT = 1;
							this.direction = -1;
							// normalize position for end points and collider
							this.normalizePosition();
						}
					} else if (this.direction < 0) {
						if (this.tT > 1 / this.travelTime * delta / (1000 / 60)) {
							this.cT = this.tT;
							this.tT -= 1 / this.travelTime * delta / (1000 / 60);
						} else {
							this.tT = 1 / this.travelTime * delta / (1000 / 60);
							this.cT = 0;
							this.direction = 1;
							// normalize position for end points
							this.normalizePosition();
						}
					}
				} else {
				this.setFrame('stop');
			}

			this.vel.add(this.lastCorrection);

			this.flashSprite.setPosition(this.flashSprite.x + this.vel.x, this.flashSprite.y + this.vel.y);
			this.flashShine.setPosition(this.flashShine.x + this.vel.x, this.flashShine.y + this.vel.y);

			//update cT and tT

			/*if (this.lastCorrection.length() > 0)
   {
   	// correct cT and tT
   	var paramCorr = this.vel.length()/beforeCorrVelocity.length();
   	//console.log('param corr in follower ________________' + paramCorr);
   	this.cT += (1/this.travelTime)*paramCorr;
   	this.tT += (1/this.travelTime)*paramCorr;
   } else*/
		}
	}, {
		key: 'update',
		value: function update(time, delta) {

			this.updateShadow();

			var currentPos = this.path.getPoint(this.cT);
			var targetPos = this.path.getPoint(this.tT);
			this.vel = targetPos.subtract(currentPos);

			this.velToAdd = new Phaser.Math.Vector2();
			this.velCorrected = false;
			this.lastCorrection = new Phaser.Math.Vector2();
			this.lastCorrPriority = this.movability;
			this.constraints = { x: { '1': this.movability, '-1': this.movability }, y: { '1': this.movability, '-1': this.movability } };
			this.resolvedPairs = [];
			this.unresolvedPairs = [];
		}
	}]);

	return ElectricFollower;
}(WoodBox);

module.exports = ElectricFollower;

/***/ }),

/***/ 1430:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FreeDoor = __webpack_require__(524);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);

var IceWall = exports.IceWall = function (_FreeDoor) {
	_inherits(IceWall, _FreeDoor);

	function IceWall(scene, edges, wallNumber) {
		_classCallCheck(this, IceWall);

		var _this = _possibleConstructorReturn(this, (IceWall.__proto__ || Object.getPrototypeOf(IceWall)).call(this, scene, edges, wallNumber));

		_this.ice = true;
		_this.toDestroy = false;

		if (scene.game.renderer.type === 2) {

			_this.waterParticles = scene.add.particles('waterParticle');
			_this.waterParticles.setDepth(10);

			_this.waterEmitter = _this.waterParticles.createEmitter({
				x: _this.x,
				y: _this.y,
				lifespan: 800,
				gravityY: 200,
				scale: { start: 1, end: 0.3 },
				alpha: { start: 1, end: 0.5 },
				bounce: 0.1
			});
			_this.waterEmitter.stop();
		}

		_this.rocketateType = RocketateTypeDict.iceWall;
		return _this;
	}

	_createClass(IceWall, [{
		key: 'drawTexture',
		value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
			return wallGenerator.generateIceWall(scene, edgeVertices, wallWidth, wallHeight);
		}
	}, {
		key: 'melt',
		value: function melt() {
			if (!this.toDestroy) {
				if (this.waterEmitter) {
					var topLeftPoint = this.getTopLeft(),
					    bottomRightPoint = this.getBottomRight(),
					    width = Math.abs(bottomRightPoint.x - topLeftPoint.x),
					    height = Math.abs(bottomRightPoint.y - topLeftPoint.y),
					    left = this.x - width / 2,
					    right = this.x + width / 2,
					    top = this.y - height / 2,
					    bottom = this.y + height / 2;

					this.waterEmitter.setPosition({ min: this.x - width / 2, max: this.x + width / 2 }, { min: this.y - height / 2, max: this.y + height / 2 });

					this.waterEmitter.setBounds(left - 10, top - 10, width + 20, height - 10);
					this.waterEmitter.explode(30);
				} else {

					var waterGraphics = this.scene.make.graphics({ fillStyle: { color: 0x92c9f8 } }),
					    waterHeight = (this.height - 10) * Math.abs(Math.cos(this.rotation)) + (this.width - 20) * Math.abs(Math.sin(this.rotation)),
					    waterWidth = (this.height - 10) * Math.abs(Math.sin(this.rotation)) + (this.width - 20) * Math.abs(Math.cos(this.rotation));

					waterGraphics.fillRect(0, 0, Math.max(waterWidth, 0), Math.max(waterHeight, 0));

					if (this.scene.textures.exists('waterGraphics')) {
						this.scene.textures.remove('waterGraphics');
					}

					waterGraphics.generateTexture('waterGraphics', waterWidth, waterHeight);

					this.waterSprite = this.scene.add.sprite(this.x, this.y + waterHeight / 2, 'waterGraphics');

					this.waterSprite.setOrigin(0.5, 1);
					this.waterSprite.setDepth(11);

					var waterOutlineGraphics = this.scene.make.graphics({ fillStyle: { color: 0xddebf8 } }),
					    outlineHeight = this.height * Math.abs(Math.cos(this.rotation)) + (this.width - 10) * Math.abs(Math.sin(this.rotation)),
					    outlineWidth = this.height * Math.abs(Math.sin(this.rotation)) + (this.width - 10) * Math.abs(Math.cos(this.rotation));

					waterOutlineGraphics.fillRect(0, 0, Math.max(outlineWidth, 0), Math.max(outlineHeight, 0));

					if (this.scene.textures.exists('waterOutlineGraphics')) {
						this.scene.textures.remove('waterOutlineGraphics');
					}

					waterOutlineGraphics.generateTexture('waterOutlineGraphics', outlineWidth, outlineHeight);

					this.waterOutlineSprite = this.scene.add.sprite(this.x, this.y + outlineHeight / 2, 'waterOutlineGraphics');
					this.waterOutlineSprite.setOrigin(0.5, 1);
					this.waterOutlineSprite.setDepth(10);

					var waterTween = this.scene.tweens.addCounter({
						from: 0,
						to: waterHeight,
						duration: 400
					});

					waterTween.setCallback('onUpdate', function (params, target) {

						this.waterSprite.setCrop(0, target.value, waterWidth, waterHeight - target.value);
						this.waterSprite.setScale(1 + 0.5 * (target.value / waterHeight), 1);

						var outlineTarget = target.value / waterHeight * outlineHeight;

						this.waterOutlineSprite.setCrop(0, outlineTarget, outlineWidth, outlineHeight - outlineTarget);
						this.waterOutlineSprite.setScale(1 + 0.5 * (target.value / waterHeight), 1);
					}, [], this);

					waterTween.setCallback('onComplete', function (tween, target) {
						this.waterSprite.destroy();
						this.waterOutlineSprite.destroy();
					}, [], this);
				}

				this.toDestroy = true;
			}
		}
	}, {
		key: 'update',
		value: function update(time, delta) {
			_get(IceWall.prototype.__proto__ || Object.getPrototypeOf(IceWall.prototype), 'update', this).call(this, time, delta);

			if (this.toDestroy) {
				this.shadow.destroy();
				this.destroy();
			}
		}
	}]);

	return IceWall;
}(FreeDoor);

module.exports = IceWall;

/***/ }),

/***/ 1431:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wall = __webpack_require__(98);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);

var ColdWall = exports.ColdWall = function (_Wall) {
	_inherits(ColdWall, _Wall);

	function ColdWall(scene, edges, wallNumber, wallTextureData, shadowTexture) {
		_classCallCheck(this, ColdWall);

		var _this = _possibleConstructorReturn(this, (ColdWall.__proto__ || Object.getPrototypeOf(ColdWall)).call(this, scene, edges, wallNumber, wallTextureData, shadowTexture));

		_this.cold = true;

		if (scene.game.renderer.type === 1) {
			_this.snow = scene.add.sprite(_this.x, _this.y, 'snow');
			_this.snow.setOrigin(0.5, 1);
			if (_this.width > _this.height) {
				_this.snowInitialRot = 0;
			} else {
				_this.snowInitialRot = Math.PI / 2;
			}
			_this.snow.rotation = _this.snowInitialRot + _this.rotation;

			var snowAnimationNames = scene.anims.generateFrameNames('snow', { start: 1, end: 8 });
			_this.snowAnimation = scene.anims.create({ key: 'snowAnimation', frames: snowAnimationNames, repeat: -1, frameRate: 12 });
			_this.snow.play('snowAnimation');

			_this.snow.setDepth(11);
		} else {

			_this.snowParticle = scene.add.particles('snowflake');
			_this.snowParticle.setDepth(10);

			_this.snowEmitter = _this.snowParticle.createEmitter({
				x: { min: _this.x - 0.5 * (_this.displayWidth * Math.cos(_this.rotation) + _this.displayHeight * Math.sin(_this.rotation)),
					max: _this.x + 0.5 * (_this.displayWidth * Math.cos(_this.rotation) + _this.displayHeight * Math.sin(_this.rotation)) },
				y: { min: _this.y - 0.5 * (_this.displayWidth * Math.sin(_this.rotation) + _this.displayHeight * Math.cos(_this.rotation)),
					max: _this.y + 0.5 * (_this.displayWidth * Math.sin(_this.rotation) + _this.displayHeight * Math.cos(_this.rotation)) },
				speedY: { min: -90, max: -40 },
				rotate: { min: -180, max: 180 },
				lifespan: 1000,
				scale: { start: 0.3 + Math.random() * 0.3, end: 0.2 },
				alpha: { start: 1, end: 0.2 },
				frequency: 300
			});
		}

		_this.rocketateType = RocketateTypeDict.coldWall;
		return _this;
	}

	_createClass(ColdWall, [{
		key: 'drawTexture',
		value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
			return wallGenerator.generateColdWall(scene, edgeVertices, wallWidth, wallHeight);
		}
	}, {
		key: 'startRotation',
		value: function startRotation() {
			if (this.snow) {
				this.snow.alpha = 0;
			} else {
				if (this.snowEmitter.on) {
					this.snowEmitter.stop();
				}
			}
		}
	}, {
		key: 'endRotation',
		value: function endRotation() {
			if (this.snow) {
				this.updateSnowSprite();
				this.snow.alpha = 1;
			} else {
				if (!this.snowEmitter.on) {
					this.updateSnowEmitter();
					this.snowEmitter.start();
				}
			}
		}
	}, {
		key: 'updateSnowEmitter',
		value: function updateSnowEmitter() {
			this.snowEmitter.setPosition({ min: this.x - 0.5 * (this.displayWidth * Math.cos(this.rotation) + this.displayHeight * Math.sin(this.rotation)),
				max: this.x + 0.5 * (this.displayWidth * Math.cos(this.rotation) + this.displayHeight * Math.sin(this.rotation)) }, { min: this.y - 0.5 * (this.displayWidth * Math.sin(this.rotation) + this.displayHeight * Math.cos(this.rotation)),
				max: this.y + 0.5 * (this.displayWidth * Math.sin(this.rotation) + this.displayHeight * Math.cos(this.rotation)) });
		}
	}, {
		key: 'updateSnowSprite',
		value: function updateSnowSprite() {
			this.snow.setPosition(this.x, this.y);
			this.snow.rotation = this.snowInitialRot + this.rotation;
		}
	}]);

	return ColdWall;
}(Wall);

module.exports = ColdWall;

/***/ }),

/***/ 1432:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlainCollider = __webpack_require__(116);
var defineOuterVertices = __webpack_require__(158);
var wallGenerator = __webpack_require__(40);
var Wall = __webpack_require__(98);
var RocketateTypeDict = __webpack_require__(29);

var MainWall = exports.MainWall = function (_Wall) {
    _inherits(MainWall, _Wall);

    function MainWall(scene, edges, wallNumber, wallTextureData) {
        _classCallCheck(this, MainWall);

        var _this = _possibleConstructorReturn(this, (MainWall.__proto__ || Object.getPrototypeOf(MainWall)).call(this, scene, edges, wallNumber, wallTextureData));

        _this.rocketateType = RocketateTypeDict.mainWall;

        _this.shadow.destroy();

        return _this;
    }

    _createClass(MainWall, [{
        key: 'drawTexture',
        value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
            return wallGenerator.generateMainWall(scene, edgeVertices, wallWidth, wallHeight);
        }
    }]);

    return MainWall;
}(Wall);

module.exports = MainWall;

/***/ }),

/***/ 1433:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomPipeline = __webpack_require__(528);

var PreloaderScene = exports.PreloaderScene = function (_Phaser$Scene) {
    _inherits(PreloaderScene, _Phaser$Scene);

    function PreloaderScene() {
        _classCallCheck(this, PreloaderScene);

        return _possibleConstructorReturn(this, (PreloaderScene.__proto__ || Object.getPrototypeOf(PreloaderScene)).call(this, 'PreloaderScene'));
    }

    _createClass(PreloaderScene, [{
        key: 'preload',
        value: function preload() {
            var gameWidth = this.game.config.width,
                gameHeight = this.game.config.height;

            this.add.image(gameWidth / 2 - 148, 480, 'preloaderBack').setOrigin(0, 0.5);

            this.playPortrait = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'playPortrait');
            this.playPortrait.setDepth(200);
            this.playPortrait.alpha = 0;

            this.preloaderBar = this.add.image(gameWidth / 2 - 143, 480, 'preloaderBar').setOrigin(0, 0.5);
            this.preloaderBar.setCrop(0, 0, 0, 39);

            this.load.on('progress', function (value) {
                this.preloaderBar.setCrop(0, 0, 287 * value, 39);
            }, this);

            this.load.atlas('bouncy', 'assets/bouncy.png', 'assets/bouncy.json');
            this.load.atlas('dustSplash', 'assets/dustSplash.png', 'assets/dustSplash.json');
            this.load.atlas('startButton', 'assets/startButton.png', 'assets/startButton.json');
            this.load.atlas('levelButton', 'assets/levelButton.png', 'assets/levelButton.json');
            this.load.atlas('flash', 'assets/flash.png', 'assets/flash.json');
            this.load.atlas('replayButton', 'assets/replayButton.png', 'assets/replayButton.json');
            this.load.atlas('nextLevelButton', 'assets/nextLevelButton.png', 'assets/nextLevelButton.json');
            this.load.atlas('pauseButton', 'assets/pauseButton.png', 'assets/pauseButton.json');
            this.load.atlas('launch', 'assets/launch.png', 'assets/launch.json');
            this.load.atlas('creditsButton', 'assets/creditsButton.png', 'assets/creditsButton.json');
            this.load.atlas('muteButton', 'assets/muteButton.png', 'assets/muteButton.json');
            this.load.atlas('rotateCClButton', 'assets/rotateCClButton.png', 'assets/rotateCClButton.json');
            this.load.atlas('rotateClButton', 'assets/rotateClButton.png', 'assets/rotateClButton.json');
            this.load.atlas('thrustButton', 'assets/thrustButton.png', 'assets/thrustButton.json');
            this.load.atlas('fullscreenButton', 'assets/fullscreenButton.png', 'assets/fullscreenButton.json');
            this.load.atlas('goLevelChoiceButton', 'assets/goLevelChoiceButton.png', 'assets/goLevelChoiceButton.json');
            this.load.atlas('metalBoxFlash', 'assets/metalBoxFlash.png', 'assets/metalBoxFlash.json');
            this.load.atlas('electricFollower', 'assets/electricFollower.png', 'assets/electricFollower.json');
            this.load.atlas('electricFollowerFlash', 'assets/electricFollowerFlash.png', 'assets/electricFollowerFlash.json');
            this.load.atlas('upButton', 'assets/upButton.png', 'assets/upButton.json');
            this.load.atlas('downButton', 'assets/downButton.png', 'assets/downButton.json');
            this.load.atlas('mutePauseButton', 'assets/mutePauseButton.png', 'assets/mutePauseButton.json');
            this.load.atlas('okayButton', 'assets/okayButton.png', 'assets/okayButton.json');
            this.load.atlas('mazeLevelButton', 'assets/mazeLevelButton.png', 'assets/mazeLevelButton.json');
            this.load.atlas('engineSmoke', 'assets/engineSmoke.png', 'assets/engineSmoke.json');
            this.load.atlas('snow', 'assets/snow.png', 'assets/snow.json');
            this.load.image('metalBox', 'assets/metalBox.png');
            this.load.image('woodBox', 'assets/woodBox.png');
            this.load.image('finish', 'assets/finish.png');
            this.load.image('levelFloor', 'assets/levelFloor.png');
            this.load.image('mainMenuBack', 'assets/mainMenuBack.png');
            this.load.image('lockImage', 'assets/lock.png');
            this.load.image('winPopupBack', 'assets/winPopupBack.png');
            this.load.image('winPopupImage', 'assets/winPopupImage.png');
            this.load.image('losePopupBack', 'assets/losePopupBack.png');
            this.load.image('losePopupImage', 'assets/losePopupImage.png');
            this.load.image('fuelIndicatorBack', 'assets/fuelIndicatorBack.png');
            this.load.image('fuelIndicatorLevel', 'assets/fuelIndicatorLevel.png');
            this.load.image('fuelIndicatorLogo', 'assets/fuelIndicatorLogo.png');
            this.load.image('mainMenuImage', 'assets/mainMenuImage.png');
            this.load.image('mainMenuLabel', 'assets/mainMenuLabel.png');
            this.load.image('pausePopupBack', 'assets/pausePopupBack.png');
            this.load.image('pausePopupImage', 'assets/pausePopupImage.png');
            this.load.image('finalPopupImage', 'assets/finalPopupImage.png');
            this.load.image('levelLabelBack', 'assets/levelLabelBack.png');
            this.load.image('credits', 'assets/credits.png');
            this.load.image('engineParticle', 'assets/engineTrail.png');
            this.load.image('smokeParticle', 'assets/smokeParticle.png');
            this.load.image('fuelCan', 'assets/fuelCan.png');
            this.load.image('tankNumberBack', 'assets/tankNumberBack.png');
            this.load.image('noFuelSignal', 'assets/noFuelSignal.png');
            this.load.image('bonusPopup', 'assets/bonusPopup.png');
            this.load.image('snowflake', 'assets/snowflake.png');
            this.load.image('fuelCanParticle', 'assets/fuelCanParticle.png');
            this.load.image('waterParticle', 'assets/waterParticle.png');
            this.load.image('tipPopup', 'assets/tipPopup.png');
            this.load.image('flashShine', 'assets/flashShine.png');
            this.load.image('electricFollowerFlashShine', 'assets/electricFollowerFlashShine.png');
            this.load.image('wallFlashShine', 'assets/wallFlashShine.png');
            this.load.image('signParticle', 'assets/signParticle.png');
            this.load.image('levelChoiceMenuBack', 'assets/levelChoiceMenuBack.png');
            this.load.image('levelNoFuel', 'assets/levelNoFuel.png');
            this.load.image('tutRotCCl', 'assets/tutRotCCl.png');
            this.load.image('tutRotCl', 'assets/tutRotCl.png');
            this.load.image('tutThrust', 'assets/tutThrust.png');
            this.load.image('mobTutRotCCl', 'assets/mobTutRotCCl.png');
            this.load.image('mobTutRotCl', 'assets/mobTutRotCl.png');
            this.load.image('mobTutThrust', 'assets/mobTutThrust.png');
            this.load.image('mazeLevelWinImage', 'assets/mazeLevelWinImage.png');
            this.load.image('mazeLevelInstructions', 'assets/mazeLevelInstructions.png');
            this.load.image('pressN', 'assets/pressN.png');
            this.load.image('pressR', 'assets/pressR.png');
            this.load.bitmapFont('basicFont', 'assets/fonts/font.png', 'assets/fonts/font.fnt');
            this.load.bitmapFont('peachFont', 'assets/fonts/fontPeach.png', 'assets/fonts/fontPeach.fnt');

            this.load.audio('backgroundMusic', 'assets/music/background.mp3');
            this.load.audio('bumpSound', 'assets/music/bump.mp3');
            this.load.audio('buttonSound', 'assets/music/button.mp3');
            this.load.audio('jetSound', 'assets/music/jet.mp3');
            this.load.audio('loseSound', 'assets/music/lose.mp3');
            this.load.audio('winSound', 'assets/music/win.mp3');
            this.load.audio('fuelSound', 'assets/music/fuel.mp3');
            this.load.audio('rotateSound', ['assets/music/rotate.wav', 'assets/music/rotate.mp3']);
            this.load.audio('shockSound', 'assets/music/shock.mp3');

            for (var i = 1; i <= 60; i++) {
                var levelName = 'level' + i,
                    fileName = 'assets/levels/rbLevel' + i + '.json';

                this.load.json(levelName, fileName);
            }

            /*this.game.customPipeline.setFloat1('resolution', this.game.config.height);
            this.game.customPipeline.setFloat1('radius', 2.0);
            this.game.customPipeline.setFloat2('dir', 1.0, 1.0);*/
            //this.game.customPipeline.setFloat2('resolution', this.game.config.width, this.game.config.height);
        }
    }, {
        key: 'respondLandscape',
        value: function respondLandscape() {
            this.playPortrait.alpha = 1;
        }
    }, {
        key: 'respondPortrait',
        value: function respondPortrait() {
            this.playPortrait.alpha = 0;
        }
    }, {
        key: 'create',
        value: function create() {
            this.scene.start('MainMenuScene');
            // to go directly to game
            /*this.game.levelNumber = 40;
            this.game.totalLevels = 40;
            this.scene.start('PlayScene');
            this.buttonSound = this.sound.add('buttonSound');
            this.game.backgroundMusic = this.sound.add('backgroundMusic');
            this.game.backgroundMusic.play('', {loop: true});*/
        }
    }]);

    return PreloaderScene;
}(Phaser.Scene);

/***/ }),

/***/ 1434:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CustomPipeline = __webpack_require__(528);

var MainMenuScene = exports.MainMenuScene = function (_Phaser$Scene) {
    _inherits(MainMenuScene, _Phaser$Scene);

    function MainMenuScene() {
        _classCallCheck(this, MainMenuScene);

        return _possibleConstructorReturn(this, (MainMenuScene.__proto__ || Object.getPrototypeOf(MainMenuScene)).call(this, 'MainMenuScene'));
    }

    _createClass(MainMenuScene, [{
        key: 'preload',
        value: function preload() {
            //this.customPipeline = this.game.renderer.addPipeline('Custom1', new CustomPipeline(this.game));
        }
    }, {
        key: 'create',
        value: function create() {
            //console.log('main menu launched');
            var gameWidth = this.game.scale.width,
                gameHeight = this.game.scale.height;

            /*console.log('at main menu');
            console.log(gameWidth);
            console.log(gameHeight);*/

            this.backgroundImage = this.add.tileSprite(0, 0, gameHeight, gameHeight * 2, 'mainMenuBack');
            this.backgroundImage.setOrigin(0);

            this.titleLabel = this.add.image(gameWidth * 0.5, gameHeight * 0.6, 'mainMenuLabel');
            this.titleImage = this.add.sprite(gameWidth * 0.5, gameHeight * 0.31, 'mainMenuImage');

            this.creditsButton = this.makeButton('creditsButton', '', gameWidth * 0.13, gameHeight * 0.9, this.showCredits);

            this.credits = this.add.image(gameWidth * 0.5, gameHeight * 0.45, 'credits');
            this.credits.alpha = 0;
            this.credits.setDepth(110);

            this.muteButton = this.makeMuteButton('muteButton', '', gameWidth * 0.87, gameHeight * 0.9);

            this.playPortrait = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'playPortrait');
            this.playPortrait.setDepth(200);
            //this.playPortrait.setScale(gameWidth/gameHeight, 1);
            this.playPortrait.alpha = 0;

            if (isNaN(localStorage.getItem('rocketateNextLevelNumber')) || localStorage.getItem('rocketateNextLevelNumber') === null) {
                this.game.lastAvailLevel = 62;
                localStorage.setItem('rocketateNextLevelNumber', this.game.lastAvailLevel);
            } else {
                this.game.lastAvailLevel = Number(localStorage.getItem('rocketateNextLevelNumber'));
            }

            if (isNaN(localStorage.getItem('rocketateNextTankNumber')) || localStorage.getItem('rocketateNextTankNumber') === null) {
                //!!!!!!!!! put it back to 0
                this.game.tankNumber = 1;
                localStorage.setItem('rocketateNextTankNumber', this.game.tankNumber);
                this.game.levelsWithNoFuel = [];
                localStorage.setItem('rocketateNextLevelsWithNoFuel', JSON.stringify(this.game.levelsWithNoFuel.slice()));
            } else {
                this.game.tankNumber = Number(localStorage.getItem('rocketateNextTankNumber'));
                this.game.levelsWithNoFuel = JSON.parse(localStorage.getItem('rocketateNextLevelsWithNoFuel'));
            }

            if (isNaN(JSON.parse(localStorage.getItem('rocketateNextTipShown'))) || localStorage.getItem('rocketateNextTipShown') === null) {
                localStorage.setItem('rocketateNextTipShown', JSON.stringify(false));
            }

            if (isNaN(JSON.parse(localStorage.getItem('rocketateNextMazeTipShown'))) || localStorage.getItem('rocketateNextMazeTipShown') === null) {
                localStorage.setItem('rocketateNextMazeTipShown', JSON.stringify(false));
            }

            console.log(localStorage.getItem('rocketateNextTimePlayed'));

            if (isNaN(JSON.parse(localStorage.getItem('rocketateNextTimePlayed'))) || localStorage.getItem('rocketateNextTimePlayed') === null) {
                localStorage.setItem('rocketateNextTimePlayed', 0);
                this.game.timePlayed = 0;
            } else {
                console.log('setting time played from local storafge');
                this.game.timePlayed = Number(localStorage.getItem('rocketateNextTimePlayed'));
            }
            this.game.lastUpdateCallSeconds = 0;

            this.buttonSound = this.sound.add('buttonSound', { volume: 0.5 });
            this.game.backgroundMusic = this.sound.add('backgroundMusic', { volume: 0.5 });

            this.game.backgroundMusic.play('', { loop: true });

            this.input.on('pointerup', function (pointer, gameObjects) {

                if (gameObjects.length > 0) {
                    for (var i = 0; i < gameObjects.length; i++) {
                        if (gameObjects[i].texture.key === 'credits') {
                            this.credits.alpha = 0;
                            this.credits.disableInteractive();
                            this.startButton.setInteractive();
                            this.creditsButton.setInteractive();
                        }
                    }
                } else {
                    this.credits.alpha = 0;
                    this.credits.disableInteractive();
                    this.startButton.setInteractive();
                    this.creditsButton.setInteractive();
                }
            }, this);

            this.startButton = this.makeButton('startButton', '', gameWidth * 0.5, gameHeight * 0.85, this.startGame);

            /*if (!this.game.device.os.desktop)
            {
                // fullscreen button stuff
                this.fullscreenListeners = [];        
                 var fullscreenButtonKey = (document.fullscreenElement)? 'fullscreenOffOut': 'fullscreenOnOut';
                 this.fullscreenButton = this.add.image(gameWidth*0.98, gameHeight*0.05, 'fullscreenButton', fullscreenButtonKey);
                this.fullscreenButton.setOrigin(1, 0);
                this.fullscreenButton.setInteractive();
                this.fullscreenButton.on('pointerup', this.processFullscreeen, this);
            } */

            // process resize event
            this.events.on('resize', function () {
                this.positionButtons();
            }, this);

            if (!this.game.device.os.desktop && document.documentElement.clientWidth > document.documentElement.clientHeight) {
                this.respondLandscape();
            }

            if (gameWidth > window.innerWidth) {
                console.log('special resize');
                window.windowResized();
            }

            this.scaleButtons();

            this.game.soundPaused = false;
        }
    }, {
        key: 'positionButtons',
        value: function positionButtons() {
            console.log('position buttons called');
            var gameWidth = this.game.scale.width,
                gameHeight = this.game.scale.height;

            this.backgroundImage.setPosition(0, 0);

            this.titleLabel.setPosition(gameWidth * 0.5, gameHeight * 0.6);
            this.titleImage.setPosition(gameWidth * 0.5, gameHeight * 0.31);

            this.creditsButton.setPosition(gameWidth * 0.13, gameHeight * 0.9);
            this.credits.setPosition(gameWidth * 0.5, gameHeight * 0.45);
            this.muteButton.setPosition(gameWidth * 0.87, gameHeight * 0.9);
            this.startButton.setPosition(gameWidth * 0.5, gameHeight * 0.85);

            /*if (!this.game.device.os.desktop)
            {
                this.fullscreenButton.setPosition(gameWidth*0.98, gameHeight*0.05);*/

            /*if (this.fullscreenListeners.legnth > 0)
            {
                var canvas = this.game.canvas;
                 var clickEventName = this.game.device.os.desktop ? 'click':'touchend';
                canvas.removeEventListener(clickEventName, this.fullscreenListeners[0], false);
                canvas.removeEventListener('touchstart', this.fullscreenListeners[1], false);
                this.fullscreenListeners = [];
            }
             this.assignFullscreenEvent();*/
            //}
        }
    }, {
        key: 'scaleButtons',
        value: function scaleButtons() {
            if (this.game.scale.height < 680) {
                var scale = this.game.scale.height / 680;
                //this.backgroundImage.setScale(this.game.scale.height/600);
                this.titleImage.setScale(scale);
                this.titleLabel.setScale(scale);
                this.startButton.setScale(scale);
                this.creditsButton.setScale(scale);
                this.credits.setScale(scale);
                this.muteButton.setScale(scale);
                /*if (!this.game.device.os.desktop)
                {
                    this.fullscreenButton.setScale(scale);
                }*/
            }
        }
    }, {
        key: 'assignFullscreenEvent',
        value: function assignFullscreenEvent() {
            var canvas = this.game.canvas;
            var fullscreen = this.game.device.fullscreen;
            var context = this.game.canvas.getContext('2d');
            var desktop = this.game.device.os.desktop;
            var fullscButton = this.fullscreenButton;

            //Function to get the mouse position
            function getMousePos(canvas, event) {

                //console.log(event);

                if (desktop) var clientPos = { x: event.screenX, y: event.screenY };else var clientPos = { x: event.changedTouches[0].pageX, y: event.changedTouches[0].pageY };

                var rect = canvas.getBoundingClientRect();
                //console.log(rect);
                return {
                    x: clientPos.x - rect.left,
                    y: clientPos.y - rect.top
                };
            }

            //Function to check whether a point is inside a rectangle
            function isInside(pos, rect) {
                //console.log(pos.x - rect.x);
                //console.log(pos.y - rect.y);
                return pos.x > rect.x && pos.x < rect.x + rect.width && pos.y < rect.y + rect.height && pos.y > rect.y;
            }

            //The rectangle should have x,y,width,height properties
            var fullscreenButtonRect = {
                x: this.fullscreenButton.getTopLeft().x,
                y: this.fullscreenButton.getTopLeft().y,
                width: this.fullscreenButton.displayWidth,
                height: this.fullscreenButton.displayHeight
            };
            //console.log(this.fullscreenButton.x);
            //console.log(this.fullscreenButton.y);
            console.log(fullscreenButtonRect);

            function processClick(evt) {
                var mousePos = getMousePos(canvas, evt);

                //console.log(fullscreenButtonRect);

                if (isInside(mousePos, fullscreenButtonRect)) {
                    //console.log('clicked inside rect');
                    //console.log(mousePos);
                    if (document.fullscreenElement) {
                        document[fullscreen.cancel]();
                        fullscButton.setFrame('fullscreenOnOut');
                    } else {
                        canvas[fullscreen.request]();
                        fullscButton.setFrame('fullscreenOffOut');
                    }
                } else {
                    //console.log('clicked outside rect');
                    //console.log(mousePos);
                }
            };

            function tapDown(evt) {
                var mousePos = getMousePos(canvas, evt);

                if (isInside(mousePos, fullscreenButtonRect)) {
                    //console.log('tap inside rect');
                    //console.log(mousePos);
                    if (document.fullscreenElement) {
                        document[fullscreen.cancel]();
                        fullscButton.setFrame('fullscreenOnOut');
                    } else {
                        canvas[fullscreen.request]();
                        fullscButton.setFrame('fullscreenOffOut');
                    }
                } else {
                    //console.log('tap outside rect');
                    //console.log(mousePos);
                }
            }

            if (this.fullscreenListeners.length === 0) {
                //Binding the click event on the canvas
                var clickEventName = this.game.device.os.desktop ? 'click' : 'touchend';
                //canvas.addEventListener(clickEventName, processClick, false); 
                canvas.addEventListener('touchstart', tapDown, false);

                //this.fullscreenListeners.push(processClick);
                this.fullscreenListeners.push(tapDown);
            }
        }
    }, {
        key: 'makeButton',
        value: function makeButton(imageKey, text, posX, posY, callback, deListen) {
            var button = this.add.image(posX, posY, imageKey, 'out').setInteractive().setScrollFactor(0);
            button.setDepth(101);
            button.on('pointerdown', function () {

                button.setFrame('down');
                if (!this.game.soundPaused) this.buttonSound.play();
            }, this);
            button.on('pointerup', function () {
                callback.call(this, deListen);
                button.setFrame('out');
            }, this);
            var buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', text, 16).setScrollFactor(0);
            buttonLabel.setDepth(102);
            return button;
        }
    }, {
        key: 'makeMuteButton',
        value: function makeMuteButton(imageKey, text, posX, posY) {
            if (this.sound.mute) {
                var startFrame = 'muteOffOut';
            } else {
                var startFrame = 'muteOnOut';
            }
            var button = this.add.image(posX, posY, imageKey, startFrame).setInteractive().setScrollFactor(0);
            button.setDepth(101);
            button.on('pointerdown', function () {

                console.log('pointer down called');

                if (this.game.soundPaused) {
                    button.setFrame('muteOffDown');
                } else {
                    button.setFrame('muteOnDown');
                    this.buttonSound.play();
                }
            }, this);
            button.on('pointerup', function () {

                console.log('pointer up called');
                console.log(this.game.soundPaused);

                if (this.game.soundPaused) {
                    console.log('setting mute to false');
                    this.game.soundPaused = false;
                    this.sound.resumeAll();
                    //this.sound.volume = 1;
                    button.setFrame('muteOnOut');
                } else {
                    console.log('setting mute to true');
                    this.game.soundPaused = true;
                    this.sound.pauseAll();
                    //this.sound.volume = 0;
                    button.setFrame('muteOffOut');
                }
            }, this);
            var buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', text, 16).setScrollFactor(0);
            buttonLabel.setDepth(102);
            return button;
        }
    }, {
        key: 'showCredits',
        value: function showCredits() {
            if (this.credits.alpha === 0) {
                this.credits.alpha = 1;
                this.credits.setInteractive();
                this.startButton.disableInteractive();
                this.creditsButton.disableInteractive();
            }
        }
    }, {
        key: 'shutdown',
        value: function shutdown() {
            console.log('shut down called');
            var canvas = this.game.canvas;

            canvas.parentNode.removeChild(this.startBtn);
            canvas.parentNode.removeChild(this.stopBtn);
        }
    }, {
        key: 'respondLandscape',
        value: function respondLandscape() {
            this.playPortrait.alpha = 1;
        }
    }, {
        key: 'respondPortrait',
        value: function respondPortrait() {
            //console.log(this);
            this.positionButtons();
            this.scaleButtons();
            this.playPortrait.alpha = 0;
        }
    }, {
        key: 'processFullscreeen',
        value: function processFullscreeen() {

            if (this.scale.isFullscreen) {
                this.fullscreenButton.setFrame('fullscreenOnOut');
                this.scale.stopFullscreen();
                this.scaleButtons();
            } else {
                this.fullscreenButton.setFrame('fullscreenOffOut');
                this.scale.startFullscreen();
                this.scaleButtons();
            }
        }
    }, {
        key: 'startGame',
        value: function startGame() {
            //console.log(this);
            /*if (!this.game.device.os.desktop)
            {
                if (this.fullscreenListeners.length > 0)
                {
                    console.log('removing listeners');
                    console.log(this.fullscreenListeners);
                     var canvas = this.game.canvas;
                     var clickEventName = this.game.device.os.desktop ? 'click':'touchend';
                    canvas.removeEventListener(clickEventName, this.fullscreenListeners[0], false);
                    canvas.removeEventListener('touchstart', this.fullscreenListeners[1], false);
                }
            }*/
            this.scene.start('LevelChoiceScene');
        }
    }]);

    return MainMenuScene;
}(Phaser.Scene);

/***/ }),

/***/ 1435:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LevelChoiceScene = exports.LevelChoiceScene = function (_Phaser$Scene) {
    _inherits(LevelChoiceScene, _Phaser$Scene);

    function LevelChoiceScene() {
        _classCallCheck(this, LevelChoiceScene);

        return _possibleConstructorReturn(this, (LevelChoiceScene.__proto__ || Object.getPrototypeOf(LevelChoiceScene)).call(this, 'LevelChoiceScene'));
    }

    _createClass(LevelChoiceScene, [{
        key: 'create',
        value: function create() {
            var gameWidth = this.scale.width,
                gameHeight = this.scale.height;

            var showMazeLevel = this.game.lastAvailLevel > 16 && !JSON.parse(localStorage.getItem('rocketateNextMazeTipShown'));

            if (showMazeLevel) localStorage.setItem('rocketateNextMazeTipShown', JSON.stringify(true));

            this.backgroundImage = this.add.tileSprite(0, 0, gameWidth, gameHeight, 'levelChoiceMenuBack');
            this.backgroundImage.setOrigin(0);

            this.playPortrait = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'playPortrait');
            this.playPortrait.setDepth(200);
            this.playPortrait.alpha = 0;

            this.game.totalLevels = 60;
            // here get from local storage
            //this.game.lastAvailLevel = 28;

            this.buttonsGroup = this.add.group();
            this.buttonsSignesGroup = this.add.group();
            //console.log(this.game.config.width);

            var noFuelLevels = [0, 1, 5, 10, 15, 22, 31, 34, 41, 47, 53, 57];

            var numOfButtonsInRow = 4,
                betweenButtonsDistanceH = gameWidth / (numOfButtonsInRow + 0.5),
                betweenButtonsDistanceV = gameHeight * 0.1; //this.game.config.width/(numOfButtonsInRow + 1);

            for (var i = 0; i <= this.game.totalLevels; i++) {
                var posX = (i % 4 + 0.75) * betweenButtonsDistanceH,
                    posY = (Math.floor(i / 4) + 0.5) * betweenButtonsDistanceV + gameHeight * 0.05;

                var button = this.makeButton('levelButton', i, posX, posY, this.launchLevel);
                this.buttonsGroup.add(button);

                if (noFuelLevels.indexOf(i) >= 0) {
                    var noFuelSign = this.add.image(button.getBottomRight().x - 8, button.getTopLeft().y + 5, 'levelNoFuel');
                    noFuelSign.setOrigin(1, 0);

                    if (i === 0 || this.game.levelsWithNoFuel.indexOf(i) < 0) noFuelSign.alpha = 0.3;

                    noFuelSign.setDepth(102);

                    this.buttonsSignesGroup.add(noFuelSign);
                }

                if (i > this.game.lastAvailLevel || i === 0 && this.game.lastAvailLevel < 17) {
                    button.disableInteractive();
                    var lockImage = this.add.image(posX, posY, 'lockImage');
                    lockImage.setDepth(103);
                    this.buttonsSignesGroup.add(lockImage);
                }
            }

            // scroll buttons to last available

            var lastAvailLevelNum = Math.min(this.game.lastAvailLevel, this.game.totalLevels);
            //console.log(lastAvailLevelNum);

            var distanceToLastAvilable = Math.max((Math.floor(lastAvailLevelNum / 4) + 0.5) * betweenButtonsDistanceV + gameHeight * 0.05 - 0.8 * gameHeight, 0);

            if (!showMazeLevel) {

                this.buttonsGroup.children.each(function (button) {
                    button.y -= distanceToLastAvilable;

                    if (button.buttonLabel) button.buttonLabel.y -= distanceToLastAvilable;
                }, this);

                this.buttonsSignesGroup.getChildren().forEach(function (sign) {
                    sign.y -= distanceToLastAvilable;
                }, this);
            }

            if (betweenButtonsDistanceV < this.buttonsGroup.getChildren()[0].height * 1.1) {
                var scale = betweenButtonsDistanceV / (this.buttonsGroup.getChildren()[0].height * 1.1);

                this.buttonsGroup.getChildren().forEach(function (button) {
                    button.setScale(scale);
                }, this);

                this.buttonsSignesGroup.getChildren().forEach(function (sign) {
                    button.setScale(scale);
                }, this);
            }

            this.downKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.DOWN);
            this.upKey = this.input.keyboard.addKey(Phaser.Input.Keyboard.KeyCodes.UP);

            this.buttonSound = this.sound.add('buttonSound');

            this.input.on('pointerdown', function (pointer) {
                //console.log(pointer.x);
                //console.log(pointer.y);

            }, this);

            this.scrollDownButton = this.makePressButton('downButton', '', gameWidth * 0.23, gameHeight * 0.94, this.scrollDownChangeStatus);
            this.scrollDownButton.setDepth(104);

            this.scrollUpButton = this.makePressButton('upButton', '', gameWidth * 0.77, gameHeight * 0.94, this.scrollUpChangeStatus);
            this.scrollUpButton.setDepth(104);

            if (this.scale.height < 680) {
                this.scrollDownButton.setScale(this.scale.height / 680);
                this.scrollUpButton.setScale(this.scale.height / 680);
            }

            /*this.mazeLevelButton = this.makeButton('mazeLevelButton', '', gameWidth * 0.5, gameHeight*0.94, this.launchMazeLevel);
            this.mazeLevelButton.setDepth(104);*/

            var buttonsFrameGraphics = this.make.graphics();
            buttonsFrameGraphics.fillStyle(0x4b4366);
            buttonsFrameGraphics.fillRect(0, 0, gameWidth, gameHeight - this.scrollDownButton.getTopLeft().y * 0.97);
            buttonsFrameGraphics.generateTexture('buttonsFrame', gameWidth, gameHeight - this.scrollDownButton.getTopLeft().y * 0.97);

            this.buttonsFrame = this.add.image(0, this.scrollDownButton.getTopLeft().y * 0.98, 'buttonsFrame');
            this.buttonsFrame.setOrigin(0);
            //this.buttonsFrame = this.add.image(gameWidth*0.5, gameHeight, 'buttonsFrame');
            //this.buttonsFrame.setOrigin(0.5, 1);
            this.buttonsFrame.setDepth(103);

            this.scrollingDown = false;
            this.scrollingUp = false;

            if (showMazeLevel) {
                this.showMazeParticles = this.add.particles('fuelCanParticle');
                this.showMazeParticles.setDepth(102);

                var rect = this.buttonsGroup.getChildren()[0].getBounds();

                this.showMazeEmitter = this.showMazeParticles.createEmitter({
                    lifespan: 1000,
                    speed: 30,
                    scale: { start: 1, end: 0.1 },
                    emitZone: { type: 'edge', source: rect, quantity: 45 }
                });

                this.showMazeEmitter.explode(45);
            }

            // manage sound paused
            if (this.game.soundPaused) {
                this.sound.pauseAll();
            }
        }
    }, {
        key: 'makeButton',
        value: function makeButton(imageKey, text, posX, posY, callback) {
            // case for maze level
            if (text === 0) {
                imageKey = 'mazeLevelButton';
                callback = this.launchMazeLevel;
                text = '';
            }
            var button = this.add.image(posX, posY, imageKey, 'out').setInteractive().setScrollFactor(0);
            button.setDepth(101);
            button.levelNumber = text;
            button.on('pointerdown', function () {

                button.setFrame('down');
                if (!this.game.soundPaused) this.buttonSound.play();
            }, this);
            button.on('pointerup', function () {
                button.setFrame('out');
                callback.call(this, button.levelNumber);
            }, this);
            button.buttonLabel = this.add.bitmapText(button.x, button.y, 'basicFont', '' + text, 32).setScrollFactor(0);
            button.buttonLabel.setDepth(102);
            button.buttonLabel.setOrigin(0.5, 0.5);
            button.buttonLabel.tint = 0xf5ecdf;
            //console.log(button.input.hitArea);
            return button;
        }
    }, {
        key: 'makePressButton',
        value: function makePressButton(imageKey, text, posX, posY, callback) {
            var button = this.add.image(posX, posY, imageKey, 'out').setInteractive();

            button.setDepth(103);

            button.on('pointerdown', function () {
                if (!this.game.soundPaused) this.buttonSound.play();
                button.setFrame('down');
                callback.call(this);
            }, this);

            button.on('pointerup', function () {
                button.setFrame('out');
                callback.call(this);
            }, this);

            return button;
        }
    }, {
        key: 'scrollDownChangeStatus',
        value: function scrollDownChangeStatus() {
            this.scrollingDown = !this.scrollingDown;
        }
    }, {
        key: 'scrollUpChangeStatus',
        value: function scrollUpChangeStatus() {
            this.scrollingUp = !this.scrollingUp;
        }
    }, {
        key: 'launchLevel',
        value: function launchLevel(levelNumber) {
            this.game.levelNumber = levelNumber;
            this.scene.start('PlayScene');
        }
    }, {
        key: 'launchMazeLevel',
        value: function launchMazeLevel() {
            this.game.levelNumber = 0;
            this.scene.start('PlayScene');
        }
    }, {
        key: 'respondLandscape',
        value: function respondLandscape() {
            this.playPortrait.alpha = 1;
        }
    }, {
        key: 'respondPortrait',
        value: function respondPortrait() {
            this.playPortrait.alpha = 0;
        }
    }, {
        key: 'update',
        value: function update(time, delta) {
            if (this.upKey.isDown || this.scrollingUp) {
                if (this.buttonsGroup.getChildren()[0].y <= this.game.config.height * 0.1) {
                    this.buttonsGroup.children.each(function (button) {
                        button.y += 4;
                        if (button.buttonLabel) button.buttonLabel.y += 4;
                    }, this);

                    this.buttonsSignesGroup.getChildren().forEach(function (sign) {
                        sign.y += 4;
                    }, this);
                }
            }

            if (this.downKey.isDown || this.scrollingDown) {
                //var lastAvailLevelNum = Math.min(this.game.lastAvailLevel, this.game.totalLevels) - 1;

                if (this.buttonsGroup.getChildren()[this.game.totalLevels].y > 0.8 * this.game.config.height) {
                    this.buttonsGroup.children.each(function (button) {
                        button.y -= 4;
                        if (button.buttonLabel) button.buttonLabel.y -= 4;
                    }, this);

                    this.buttonsSignesGroup.getChildren().forEach(function (sign) {
                        sign.y -= 4;
                    }, this);
                }
            }

            var pointerPos = this.input.activePointer.position;

            if (this.scrollingDown && !this.scrollDownButton.getBounds().contains(pointerPos.x, pointerPos.y)) {
                this.scrollingDown = false;
                this.scrollDownButton.setFrame('out');
            }

            if (this.scrollingUp && !this.scrollUpButton.getBounds().contains(pointerPos.x, pointerPos.y)) {
                this.scrollingUp = false;
                this.scrollUpButton.setFrame('out');
            }
        }
    }]);

    return LevelChoiceScene;
}(Phaser.Scene);

/***/ }),

/***/ 1436:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BootScene = exports.BootScene = function (_Phaser$Scene) {
    _inherits(BootScene, _Phaser$Scene);

    function BootScene() {
        _classCallCheck(this, BootScene);

        return _possibleConstructorReturn(this, (BootScene.__proto__ || Object.getPrototypeOf(BootScene)).call(this, 'BootScene'));
    }

    _createClass(BootScene, [{
        key: 'preload',
        value: function preload() {

            this.load.image('preloaderBack', 'assets/preloaderBack.png');
            this.load.image('preloaderBar', 'assets/preloaderBar.png');
            this.load.image('playPortrait', 'assets/playInPortrait.png');
        }
    }, {
        key: 'create',
        value: function create() {
            var gameWidth = this.game.config.width,
                gameHeight = this.game.config.height;

            this.playPortrait = this.add.image(gameWidth * 0.5, gameHeight * 0.5, 'playPortrait');
            this.playPortrait.setDepth(200);

            if (document.documentElement.clientWidth < document.documentElement.clientHeight || this.game.device.os.desktop) this.playPortrait.alpha = 0;

            //this.game.levelNumber = 32;
            //this.scene.start('PlayScene');
        }
    }, {
        key: 'respondLandscape',
        value: function respondLandscape() {
            this.playPortrait.alpha = 1;
        }
    }, {
        key: 'respondPortrait',
        value: function respondPortrait() {
            this.playPortrait.alpha = 0;
        }
    }, {
        key: 'update',
        value: function update() {
            if (this.playPortrait.alpha === 0) this.scene.start('PreloaderScene');
        }
    }]);

    return BootScene;
}(Phaser.Scene);

/***/ }),

/***/ 158:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var defineOuterVertices = function defineOuterVertices(wallEdges) {
    var outerSegments = defineOuterSegments(wallEdges);

    // get all non duplicated vertes of segments in correct order
    var vertexArray = [],
        idleRun = 0;
    vertexArray = vertexArray.concat([outerSegments[0][0], outerSegments[0][1]]);
    outerSegments.splice(0, 1);

    while (outerSegments.length > 0 && idleRun < 3) {
        var lastVertex = vertexArray[vertexArray.length - 1],
            nextSegment = [],
            nextSegmentIndex = -1,
            nextVertexIndex = -1;

        outerSegments.forEach(function (segment, index, arr) {

            if (lastVertex.equals(segment[0])) {
                nextSegment = segment;
                nextSegmentIndex = index;
                nextVertexIndex = 1;
            } else if (lastVertex.equals(segment[1])) {
                nextSegment = segment;
                nextSegmentIndex = index;
                nextVertexIndex = 0;
            }
        }, this);

        if (nextSegmentIndex >= 0) {
            vertexArray.push(nextSegment[nextVertexIndex]);
            outerSegments.splice(nextSegmentIndex, 1);
        } else {
            idleRun++;
        }
    }

    return vertexArray;
};

var defineOuterSegments = function defineOuterSegments(edges) {
    var segments = [];

    for (var e in edges) {
        for (var v in edges[e]) {
            if (Number(v) < 4) {

                var nextV = Number(v) < 3 ? Number(v) + 1 : 0;
                segments.push([edges[e][v], edges[e][nextV]]);
            }
        }
    }

    var innerSegments = [];
    segments.forEach(function (seg1, index1, segArr1) {
        segArr1.forEach(function (seg2, index2, segArr2) {

            if (index2 > index1) {
                if (seg1[0].equals(seg2[0]) && seg1[1].equals(seg2[1]) || seg1[0].equals(seg2[1]) && seg1[1].equals(seg2[0])) {
                    innerSegments.push(seg1);
                }
            }
        }, this);
    }, this);

    var candidateOuterSegments = segments.filter(function (segment) {
        var inner = false;
        innerSegments.forEach(function (innerSegment) {
            if (!inner) {
                if (innerSegment[0].equals(segment[0]) && innerSegment[1].equals(segment[1]) || innerSegment[1].equals(segment[0]) && innerSegment[0].equals(segment[1])) {
                    inner = true;
                }
            }
        }, this);
        return !inner;
    }, this);

    // crate points array
    var points = [];
    candidateOuterSegments.forEach(function (segment) {
        points = points.concat(segment);
    }, this);

    // find points that appears 4 times

    var points4T = [];

    points.forEach(function (point1, index1, pointsArr1) {
        var occurance = 0;
        pointsArr1.forEach(function (point2, index2, pointsArr2) {
            if (index2 >= index1) {
                if (point1.equals(point2)) occurance++;
            }
        }, this);
        if (occurance >= 4) points4T.push(point1);
    }, this);

    // find segments starting and finishing in point appering 4 times
    // mark them for deletion if they are shorter than certain amount -32 pixels, walls width in maze and lab levels

    var innerSegments = [];

    points4T.forEach(function (point) {
        candidateOuterSegments.forEach(function (segment) {
            if (segment[0].equals(point)) {
                points4T.forEach(function (otherPoint) {
                    if (segment[1].equals(otherPoint) && Math.sqrt(Math.pow(segment[1][0] - segment[0][0], 2) + Math.pow(segment[1][1] - segment[0][1], 2)) < 32) {
                        innerSegments.push(segment);
                    }
                }, this);
            }
        }, this);
    }, this);

    //console.log(innerSegments);

    var outerSegmentsArray = candidateOuterSegments.filter(function (segment) {
        for (var iSeg in innerSegments) {
            if (innerSegments[iSeg].equals(segment)) return false;
        }
        return true;
    }, this);

    return outerSegmentsArray;
};

module.exports = defineOuterVertices;

/***/ }),

/***/ 252:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GWall = __webpack_require__(525);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);
var defineOuterVertices = __webpack_require__(158);

var WoodBox = exports.WoodBox = function (_GWall) {
	_inherits(WoodBox, _GWall);

	function WoodBox(scene, edges, wallNumber) {
		_classCallCheck(this, WoodBox);

		//this.movability = 0;

		var _this = _possibleConstructorReturn(this, (WoodBox.__proto__ || Object.getPrototypeOf(WoodBox)).call(this, scene, edges, wallNumber));

		_this.rocketateType = RocketateTypeDict.woodBox;
		return _this;
	}

	_createClass(WoodBox, [{
		key: 'definePosition',
		value: function definePosition(edges) {
			this.wallWidth = 100;
			this.wallHeight = 100;
			this.leftPointWall = edges[0][0] - this.wallWidth / 2;
			this.topPointWall = edges[0][1] - this.wallHeight / 2;
		}
	}, {
		key: 'prepareTexture',
		value: function prepareTexture() {
			return 'woodBox';
		}
	}, {
		key: 'prepareShadowTexture',
		value: function prepareShadowTexture() {
			var topLeft = this.getTopLeft(),
			    bottomRight = this.getBottomRight();

			this.vertices = [[[topLeft.x, topLeft.y], [bottomRight.x, topLeft.y], [bottomRight.x, bottomRight.y], [topLeft.x, bottomRight.y]]];

			// define vertices for texture
			var edgeVertices = [[0, 0], [0, 100], [100, 100], [100, 0], [0, 0]];
			// generate texture for sprite
			return wallGenerator.generateWallShadow(this.scene, edgeVertices, this.wallWidth, this.wallHeight);
		}
	}]);

	return WoodBox;
}(GWall);

module.exports = WoodBox;

/***/ }),

/***/ 29:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var RocketateTypeDict = Object.freeze({
	bouncy: 1,
	coldWall: 2,
	electricFollower: 3,
	finish: 4,
	floor: 5,
	freeDoor: 6,
	fuelCan: 7,
	iceWall: 8,
	lavaWall: 9,
	mainWall: 10,
	metalBox: 11,
	wall: 12,
	woodBox: 13
});

module.exports = RocketateTypeDict;

/***/ }),

/***/ 40:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var paper = __webpack_require__(250);

var wallGenerator = {

	textureNameArray: [],
	textureArray: [],
	texturesBin: [],

	generateWall: function generateWall(state, vertices, width, height) {
		this.state = state;
		var maxOffset = 10;

		var textureCanvas = document.createElement('canvas');

		textureCanvas.width = (width + 2 * maxOffset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * maxOffset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + maxOffset, vertex[1] + maxOffset);
		}, this);

		segments.pop();

		var outerPath = new paper.Path(segments);
		outerPath.closed = true;
		outerPath.fillColor = '#433475';
		outerPath.strokeColor = 'black';
		outerPath.strokeWidth = 3;

		var middlePath = outerPath.clone();
		extrude(middlePath, 5);
		middlePath.fillColor = '#563eb2';
		middlePath.strokeWidth = 0;

		placeEndSquares(outerPath, 16);

		putShines(outerPath);

		function drawShine(point, direction, width) {

			if (direction.equals(new paper.Point(1, 0))) {
				var aboveVec = direction.rotate(45).multiply(5 * Math.pow(2, 0.5)),
				    middleVec = direction.rotate(45).multiply(6 * Math.pow(2, 0.5)),
				    shiftVec = direction.rotate(-90).multiply(width);
			} else if (direction.equals(new paper.Point(-1, 0))) {

				var aboveVec = direction.rotate(45).multiply(5 * Math.pow(2, 0.5)),
				    middleVec = direction.rotate(45).multiply(6 * Math.pow(2, 0.5)),
				    shiftVec = direction.rotate(90).multiply(width);
			} else if (direction.equals(new paper.Point(-1, 0))) {
				var aboveVec = direction.rotate(-45).multiply(5 * Math.pow(2, 0.5)),
				    middleVec = direction.rotate(-45).multiply(6 * Math.pow(2, 0.5)),
				    shiftVec = direction.rotate(90).multiply(width);
			} else {
				var aboveVec = direction.rotate(-45).multiply(5 * Math.pow(2, 0.5)),
				    middleVec = direction.rotate(-45).multiply(6 * Math.pow(2, 0.5)),
				    shiftVec = direction.rotate(-90).multiply(width);
			}

			var point1 = point.add(aboveVec),
			    point2 = point1.add(shiftVec.multiply(0.4)),
			    point3 = point2.add(middleVec),
			    point4 = point3.add(shiftVec.multiply(-0.4)),
			    point5 = point4.add(aboveVec),
			    point6 = point5.add(shiftVec),
			    point7 = point6.add(aboveVec.multiply(-1)),
			    point8 = point7.add(shiftVec.multiply(0.4)),
			    point9 = point8.add(middleVec.multiply(-1)),
			    point10 = point9.add(shiftVec.multiply(-0.4)),
			    point11 = point10.add(aboveVec.multiply(-1));

			var shinePath = new paper.Path([point, point1, point2, point3, point4, point5, point6, point7, point8, point9, point10, point11]);

			shinePath.closed = true;
			shinePath.fillColor = 'white';
			shinePath.opacity = 0.2;
		}

		function putShines(path) {
			var startRivets = false;

			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    currentDistance = 0;
				if (startRivets) {
					var distance = Math.round(Math.random() * 50) + 100;
					currentDistance += distance;
					while (currentDistance + 20 < toNextVec.length) {

						var localNormal = segment.curve.getNormalAt(currentDistance / toNextVec.length);

						var tangentPos = segment.point.add(toNextVec.multiply(currentDistance / toNextVec.length));

						var shineWidth = Math.round(Math.random() * 20) + 10;

						drawShine(tangentPos, localNormal, shineWidth);

						distance = Math.round(Math.random() * 50) + 100;
						currentDistance += distance + shineWidth;
					}
					/*var numberOfRivets = Math.floor(toNextVec.length/distance);
     for (var r = 1; r<numberOfRivets; r++)
     {
         var localNormal = segment.curve.getNormalAt(r/numberOfRivets);
         
         var tangentPos = segment.point.add(toNextVec.multiply(r/numberOfRivets));
         
         drawShine(tangentPos, localNormal);
     }*/
				}

				if (toNextVec.length <= 17) {
					//console.log('change start rivet');
					startRivets = !startRivets;
				}
			}, this);
		}

		function putRivets(path) {
			var startRivets = false,
			    distance = 70;

			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point);
				if (startRivets) {
					var numberOfRivets = Math.floor(toNextVec.length / distance);
					for (var r = 1; r < numberOfRivets; r++) {
						var localNormal = segment.curve.getNormalAt(r / numberOfRivets);

						var tangentPos = segment.point.add(toNextVec.multiply(r / numberOfRivets)),
						    rivetPos = tangentPos.add(localNormal.multiply(8));

						drawRivet(rivetPos);
					}
				}

				if (toNextVec.length <= 17) {
					startRivets = !startRivets;
				}
			}, this);
		}

		function drawRivet(point) {
			var outerRivet = new paper.Path.Circle(point, 8);
			outerRivet.fillColor = '#3f706b';

			var fromPoint = point.add(new paper.Point(0, -8)),
			    toPoint = point.add(new paper.Point(-8, 0)),
			    throughPoint = point.add(new paper.Point(-8 * Math.cos(Math.PI / 4)), new paper.Point(-8 * Math.sin(Math.PI / 4))),
			    shine = new paper.Path.Arc(fromPoint, throughPoint, toPoint);

			shine.fillColor = '#ffffff';
			shine.opacity = 0.7;

			var middleRivet = new paper.Path.Circle(point, 5);
			middleRivet.fillColor = '#273833';
		}

		function extrude(path, depth) {
			var bisecs = [];
			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				if (toNextVec.length <= 17) {
					var bisec = toNextVec.normalize(depth);
				} else if (toPrevVec.length <= 17) {
					var bisec = toPrevVec.normalize(depth);
				} else {
					toNextVec = toNextVec.normalize(depth);
					toPrevVec = toPrevVec.normalize(depth);
					var bisec = toNextVec.add(toPrevVec);
				}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (path.contains(newPoint)) {
					path.segments[s].point = path.segments[s].point.add(bisecs[s]);
				} else {
					path.segments[s].point = path.segments[s].point.subtract(bisecs[s]);
				}
			}
		}

		function placeEndSquares(path, squareSide) {

			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				if (toNextVec.length <= 17) {

					toNextVec = toNextVec.normalize(squareSide);
					toPrevVec = toPrevVec.normalize(squareSide);

					var toVec = segment.point.add(toNextVec).add(toPrevVec);

					var squarePath = new paper.Path.Rectangle(segment.point, toVec);
					squarePath.fillColor = '#2f659f';
					squarePath.strokeColor = 'black';
					squarePath.strokeWidth = 2;

					var smallSquarePath = new paper.Path.Rectangle(segment.point, toVec);
					smallSquarePath.scale(0.8);
					smallSquarePath.fillColor = '#5790cd';

					// add triangle

					var trianglePath = new paper.Path([segment.point.add(toPrevVec), segment.point, segment.point.add(toNextVec)]);
					trianglePath.closed = true;
					trianglePath.fillColor = '#ffffff';
					trianglePath.opacity = 0.3;

					var trianglePath1 = new paper.Path([segment.point, segment.point.add(toNextVec), segment.point.add(toNextVec).add(toPrevVec)]);
					trianglePath1.closed = true;
					trianglePath1.fillColor = '#ffffff';
					trianglePath1.opacity = 0.3;
				}
			}, this);
		}

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;
	},

	generateLavaWall: function generateLavaWall(state, vertices, width, height) {
		this.state = state;

		var maxOffset = 10;

		var textureCanvas = document.createElement('canvas');

		textureCanvas.width = (width + 2 * maxOffset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * maxOffset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + maxOffset, vertex[1] + maxOffset);
		}, this);

		segments.pop();

		var outerPath = new paper.Path(segments);
		outerPath.closed = true;
		outerPath.fillColor = '#5e8cf0';

		var leftPath = outerPath.clone();
		extrude(leftPath, 2, 9);
		leftPath.fillColor = '#b5dbf8';

		var rightPath = outerPath.clone();
		extrude(rightPath, 10, 2);
		rightPath.fillColor = '#b5dbf8';

		outerPath.strokeColor = 'black';
		outerPath.strokeWidth = 3;
		placeEndBolts(outerPath, 16);

		function extrude(path, otherSideDepth, thisSideDepth) {
			var bisecs = [],
			    otherSide = false;
			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				var localDepth = otherSide ? otherSideDepth : thisSideDepth;

				if (toNextVec.length <= 17) {
					var bisec = toNextVec.normalize(localDepth);
					otherSide = !otherSide;
				} else if (toPrevVec.length <= 17) {
					var bisec = toPrevVec.normalize(localDepth);
				} else {
					toNextVec = toNextVec.normalize(localDepth);
					toPrevVec = toPrevVec.normalize(localDepth);
					var bisec = toNextVec.add(toPrevVec);
				}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (path.contains(newPoint)) {
					path.segments[s].point = path.segments[s].point.add(bisecs[s]);
				} else {
					path.segments[s].point = path.segments[s].point.subtract(bisecs[s]);
				}
			}
		}

		function placeEndBolts(path, squareSide) {

			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				if (toNextVec.length <= 17) {

					toNextVec = toNextVec.normalize(squareSide);
					toPrevVec = toPrevVec.normalize(squareSide);

					var toVec = segment.point.add(toNextVec).add(toPrevVec);

					var squarePath = new paper.Path.Rectangle(segment.point, toVec);
					squarePath.fillColor = '#30487e';
					squarePath.strokeColor = 'black';
					squarePath.strokeWidth = 2;

					drawFlash(squarePath.position, 14, 16);
				}
			}, this);
		}

		function drawFlash(center, width, height) {
			var point1 = new paper.Point(center.x - width / 3, center.y + height / 2),
			    point2 = new paper.Point(center.x + width / 2, center.y - height / 6),
			    point3 = new paper.Point(center.x + width / 12, center.y - height / 6),
			    point4 = new paper.Point(center.x + width / 3, center.y - height / 2),
			    point5 = new paper.Point(center.x - width / 6, center.y - height / 2),
			    point6 = new paper.Point(center.x - width / 2, center.y + height / 12),
			    point7 = new paper.Point(center.x - width / 6, center.y + height / 12);

			var pointArray = [point1, point2, point3, point4, point5, point6, point7];

			var flashPath = new paper.Path(pointArray);
			flashPath.closed = true;
			flashPath.fillColor = '#b5dbf8';
		}

		function findFramePoints(path) {
			var framePoints = [],
			    bisecs = [],
			    startIndex = undefined,
			    endIndex = undefined,
			    localDepth = 8;

			path.segments.forEach(function (segment, index) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				if (toNextVec.length <= 17) {
					var bisec = toNextVec.normalize(localDepth);
					if (!startIndex) {
						startIndex = index;
					} else if (!endIndex) {
						endIndex = index;
					}
				} else if (toPrevVec.length <= 17) {
					var bisec = toPrevVec.normalize(localDepth);
				} else {
					toNextVec = toNextVec.normalize(localDepth);
					toPrevVec = toPrevVec.normalize(localDepth);
					var bisec = toNextVec.add(toPrevVec);
				}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (Number(s) >= startIndex && Number(s) <= endIndex) {
					if (path.contains(newPoint)) {
						framePoints.push(newPoint);
					} else {
						framePoints.push(path.segments[s].point.subtract(bisecs[s]));
					}
				}
			}

			return framePoints;
		}

		var alignedFramePoints = findFramePoints(outerPath),
		    noOffsetFramePoints = alignedFramePoints.map(function (point) {
			return point.add(new paper.Point(-maxOffset, -maxOffset));
		}, this);

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return { textureName: textureName, framePoints: noOffsetFramePoints };
	},

	generateGWall: function generateGWall(state, vertices, width, height) {
		this.state = state;

		var textureCanvas = document.createElement('canvas');

		textureCanvas.width = width / window.devicePixelRatio;
		textureCanvas.height = height / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0], vertex[1]);
		}, this);

		segments.pop();

		var outerPath = new paper.Path(segments);
		outerPath.closed = true;
		outerPath.fillColor = 'red';

		var middlePath = outerPath.clone();
		extrude(middlePath, 5);
		middlePath.fillColor = '#97b4c3';

		insetEnds(outerPath, 7);

		var subtractedPath = outerPath.subtract(middlePath);
		subtractedPath.fillColor = '#623e2a';

		middlePath.opacity = 0.7;
		outerPath.opacity = 0;

		insetEnds(outerPath, 10);

		function insetEnds(path, depth) {
			var moves = [];

			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				if (toNextVec.length <= 17) {
					var move = toPrevVec.normalize(depth);
				} else if (toPrevVec.length <= 17) {
					var move = toNextVec.normalize(depth);
				} else {
					var move = new paper.Point(0, 0);
				}
				moves.push(move);
			}, this);

			for (var s in path.segments) {
				path.segments[s].point = path.segments[s].point.add(moves[s]);
			}
		}

		function extrude(path, depth) {
			var bisecs = [];
			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				if (toNextVec.length <= 17) {
					var bisec = toNextVec.normalize(depth);
				} else if (toPrevVec.length <= 17) {
					var bisec = toPrevVec.normalize(depth);
				} else {
					toNextVec = toNextVec.normalize(depth);
					toPrevVec = toPrevVec.normalize(depth);
					var bisec = toNextVec.add(toPrevVec);
				}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (path.contains(newPoint)) {
					path.segments[s].point = path.segments[s].point.add(bisecs[s]);
				} else {
					path.segments[s].point = path.segments[s].point.subtract(bisecs[s]);
				}
			}
		}

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;
	},

	generateColdWall: function generateColdWall(state, vertices, width, height) {
		console.log('generate cold wall called');
		this.state = state;
		var maxOffset = 10;

		var textureCanvas = document.createElement('canvas');

		textureCanvas.width = (width + 2 * maxOffset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * maxOffset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + maxOffset, vertex[1] + maxOffset);
		}, this);

		segments.pop();

		var basePath = new paper.Path(segments);
		basePath.closed = true;
		basePath.fillColor = '#cef2fc';

		var innerPath = basePath.clone();
		extrude(innerPath, 3);
		innerPath.fillColor = 'white';

		var curvesCopy = basePath.curves.slice();
		curvesCopy.forEach(fractionCurve, this);

		basePath.segments.forEach(assignHandles, this);
		basePath.segments.forEach(initialShake, this);

		basePath.strokeColor = 'black';
		basePath.strokeWidth = 3;

		function fractionCurve(curve) {
			if (curve && curve.length > 20) {
				var newCurve = curve.divideAt(13);
				fractionCurve(newCurve);
				newCurve.segment1.point.data = { shake: true };
			} else if (curve) {
				curve.segment1.point.data = { shake: false };
			}
		}

		function assignHandles(segment) {
			segment.handleIn = segment.previous.point.subtract(segment.point).normalize(10);
			segment.handleOut = segment.next.point.subtract(segment.point).normalize(10);
			if (!segment.point.data) {
				segment.point.data = {};
			}
		}

		function initialShake(segment) {
			if (segment.point.data.shake && segment.curve.length > 10) {
				segment.point.data.initialHandleInAngle = segment.handleIn.angle;
				var segmentAngleIn = -40,
				    segmentAngleOut = 40;

				segment.handleIn = segment.handleIn.rotate(segmentAngleIn, new paper.Point());
				segment.handleOut = segment.handleOut.rotate(segmentAngleOut, new paper.Point());

				segment.point.data.phase = 0;
				segment.point.data.angleDelta = 3;
			}
		}

		function extrude(path, depth) {
			var bisecs = [];
			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				/*if (toNextVec.length <= 17) {
        var bisec = toNextVec.normalize(depth);
    } else if (toPrevVec.length <= 17) {
        var bisec = toPrevVec.normalize(depth);
    } else {*/
				toNextVec = toNextVec.normalize(depth);
				toPrevVec = toPrevVec.normalize(depth);
				var bisec = toNextVec.add(toPrevVec);
				//}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (path.contains(newPoint)) {
					path.segments[s].point = path.segments[s].point.add(bisecs[s]);
				} else {
					path.segments[s].point = path.segments[s].point.subtract(bisecs[s]);
				}
			}
		}

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;
	},

	generateIceWall: function generateIceWall(state, vertices, width, height) {
		this.state = state;
		var maxOffset = 10;

		var textureCanvas = document.createElement('canvas');

		textureCanvas.width = (width + 2 * maxOffset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * maxOffset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + maxOffset, vertex[1] + maxOffset);
		}, this);

		segments.pop();

		var smoothedSegments = [];

		segments.forEach(function (segment, index, arr) {
			var prevIndex = index > 0 ? index - 1 : arr.length - 1,
			    nextIndex = index < arr.length - 1 ? index + 1 : 0,
			    toNextVec = arr[nextIndex].subtract(segment).normalize(5),
			    toPrevVec = arr[prevIndex].subtract(segment).normalize(5),
			    smoothedNext = segment.add(toNextVec),
			    smoothedPrev = segment.add(toPrevVec);

			smoothedSegments.push(smoothedPrev);
			smoothedSegments.push(smoothedNext);
		}, this);

		var basePath = new paper.Path(smoothedSegments);
		basePath.closed = true;
		basePath.fillColor = '#cef2fc';

		segments.forEach(function (segment, index) {
			var outSegment = basePath.segments[index * 2],
			    inSegment = basePath.segments[index * 2 + 1];

			outSegment.handleOut = segment.subtract(outSegment.point).normalize(2);
			inSegment.handleIn = segment.subtract(inSegment.point).normalize(2);
		}, this);

		addShines(basePath);
		drawHighlights(basePath, 1);
		drawHighlights(basePath, -1);

		basePath.strokeColor = 'white';
		basePath.strokeWidth = 2;

		function addShines(path) {
			var height = path.bounds.height,
			    top = path.bounds.top,
			    left = path.bounds.left;

			if (height > 86) {
				var shinePoint = new paper.Point(left, top + 66);
				drawShine(shinePoint, 20, 16);

				if (height > 142) {
					var secondShinePoint = new paper.Point(left, top + 112);
					drawShine(secondShinePoint, 30, 16);
				}
			}
		}

		function drawHighlights(path, direction) {
			var baseX = direction > 0 ? path.bounds.left : path.bounds.right,
			    baseY = direction > 0 ? path.bounds.top : path.bounds.bottom;
			var hOffset = 2 * direction,
			    vOffset = 6 * direction,
			    wOffset = 8 * direction;

			var point1 = new paper.Point(baseX + hOffset, baseY + vOffset),
			    point2 = new paper.Point(baseX + vOffset, baseY + hOffset),
			    point3 = point2.add(new paper.Point(wOffset, 0)),
			    point4 = point3.add(new paper.Point(-hOffset, vOffset)),
			    point5 = point4.add(new paper.Point(-0.5 * wOffset, 0)),
			    point6 = point5.add(new paper.Point(0, wOffset * 1.2)),
			    point7 = point6.add(new paper.Point(-3 * hOffset, 0));

			var highlight = new paper.Path([point1, point2, point3, point4, point5, point6, point7]);

			highlight.closed = true;
			highlight.fillColor = 'white';

			var squareHighlight = new paper.Path.Rectangle(point7.add(new paper.Point(0, vOffset)), new paper.Size(2 * hOffset, vOffset));

			squareHighlight.fillColor = 'white';
		}

		function drawShine(point, shift, width) {
			var shiftVec = new paper.Point(0, shift),
			    widthVec = new paper.Point(width, -width);

			var shinePath = new paper.Path([point, point.add(shiftVec), point.add(widthVec), point.add(widthVec).subtract(shiftVec)]);

			shinePath.closed = true;
			shinePath.fillColor = '#eafbfe';
		}

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;
	},

	generateFreeDoor: function generateFreeDoor(state, vertices, width, height) {
		this.state = state;

		var textureCanvas = document.createElement('canvas'),
		    offset = 5;

		textureCanvas.width = (width + 2 * offset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * offset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		/*var segments = vertices.map(function(vertex){
      return new paper.Point(vertex[0] + offset, vertex[1] + offset);
  }, this);
  	segments.pop();
  	var roundSegments = []
  	segments.forEach(function(segment, index, arr){
  	var nextPoint = (index < arr.length - 1) ? arr[Number(index) + 1]:arr[0],
  		prevPoint = (index > 0)? arr[Number(index) - 1]: arr[arr.length - 1];
  		var toNextVec = nextPoint.subtract(segment),
  		toPrevVec = prevPoint.subtract(segment);
  		toNextVec = toNextVec.normalize(6);
  	toPrevVec = toPrevVec.normalize(6);
  		roundSegments.push(segment.add(toPrevVec));
  	roundSegments.push(segment.add(toNextVec));
  }, this);
  	var wallPath = new paper.Path(roundSegments);
  wallPath.closed = true;
  	wallPath.segments.forEach(function(segment){
  	segment.handleIn = segment.previous.point.subtract(segment.point);
  	segment.handleOut = segment.next.point.subtract(segment.point);
  }, this);
  	wallPath.fillColor = '#ffcc5c';
  wallPath.strokeColor = '#b8974f';
  wallPath.strokeWidth = 2;*/

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + offset, vertex[1] + offset);
		}, this);

		segments.pop();

		var outerPath = new paper.Path(segments);
		outerPath.closed = true;
		outerPath.fillColor = '#ffbd5c';
		outerPath.strokeColor = 'black';
		outerPath.strokeWidth = 3;

		var middlePath = outerPath.clone();
		extrude(middlePath, 5);
		middlePath.fillColor = '#cc8f5d';
		middlePath.strokeWidth = 0;

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;

		function extrude(path, depth) {
			var bisecs = [];
			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				/*if (toNextVec.length <= 17) {
        var bisec = toNextVec.normalize(depth);
    } else if (toPrevVec.length <= 17) {
        var bisec = toPrevVec.normalize(depth);
    } else {*/
				toNextVec = toNextVec.normalize(depth);
				toPrevVec = toPrevVec.normalize(depth);
				var bisec = toNextVec.add(toPrevVec);
				//}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (path.contains(newPoint)) {
					path.segments[s].point = path.segments[s].point.add(bisecs[s]);
				} else {
					path.segments[s].point = path.segments[s].point.subtract(bisecs[s]);
				}
			}
		}
	},

	generateFollowerPath: function generateFollowerPath(state, vertices, width, height) {
		this.state = state;

		var textureCanvas = document.createElement('canvas'),
		    offset = 20;

		textureCanvas.width = (width + 2 * offset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * offset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + offset, vertex[1] + offset);
		}, this);

		/*var strokePath = new paper.Path(segments);
  strokePath.strokeColor = 'black';
  strokePath.strokeWidth = 15;*/

		var rawPath = new paper.Path(segments);
		rawPath.strokeColor = '#2f659f';
		rawPath.strokeWidth = 15;

		var basisPath = new paper.Path(segments);
		basisPath.strokeWidth = 8;
		basisPath.strokeColor = '#7fc5d6';
		basisPath.opacity = 0.7;

		var notchPath = new paper.Path(segments);
		notchPath.strokeWidth = 3;
		notchPath.strokeColor = '#20456c';

		for (var i = 10; i < basisPath.length; i += 30) {
			var centerPoint = basisPath.getPointAt(i),
			    tangentVec = basisPath.getTangentAt(i).normalize(),
			    normalVec = basisPath.getNormalAt(i).normalize();

			addSleeper(centerPoint, normalVec, tangentVec);
		}

		segments.forEach(function (segment) {
			addCornerCircles(segment);
		}, this);

		function addSleeper(center, normal, tangent) {
			var widthVec = tangent.normalize(4).multiply(tangent.normalize(-1)),
			    heightVec = normal.normalize(11).multiply(normal.normalize(-1));

			var topLeftVec = widthVec.add(heightVec),
			    sleeperSize = new paper.Size(topLeftVec.multiply(-2));

			var sleeperPath = new paper.Path.Rectangle(center.add(topLeftVec), sleeperSize);
			sleeperPath.fillColor = '#5790cd';
			sleeperPath.insertBelow(basisPath);
			var largerSleeperPath = sleeperPath.clone();
			largerSleeperPath.scale(1.2);
			largerSleeperPath.fillColor = '#2f659f';
			largerSleeperPath.insertBelow(rawPath);
		}

		function addCornerCircles(point) {
			var bottomCircle = new paper.Path.Circle(point, 10);
			bottomCircle.fillColor = '#2f659f';
			bottomCircle.insertBelow(basisPath);

			var topCircle = new paper.Path.Circle(point, 8);
			topCircle.fillColor = '#7fc5d6';
			topCircle.insertBelow(notchPath);

			var notchCircle = new paper.Path.Circle(point, 4);
			notchCircle.fillColor = '#20456c';
		}

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;
	},

	generateMainWall: function generateMainWall(state, vertices, width, height) {
		//console.log('main wall called');
		//console.log(vertices);
		this.state = state;

		var textureCanvas = document.createElement('canvas'),
		    offset = 20;

		textureCanvas.width = (width + 2 * offset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * offset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + offset, vertex[1] + offset);
		}, this);

		segments.pop();

		var paths = [];

		var wallPath = new paper.Path(segments);
		wallPath.fillColor = '#6438a2';
		wallPath.strokeColor = 'black'; //'#735fc0';
		wallPath.strokeWidth = 3;
		wallPath.closed = true;

		var wallClone = wallPath.clone();
		wallClone.strokeWidth = 0;
		wallClone.fillColor = '#000000';
		wallClone.opacity = 0.4;
		extrude(wallClone, 2, 9);

		var longestSides = [];

		var currentLongest = false;
		var startIndex, endIndex;

		wallPath.segments.forEach(function (segment, index) {
			var toPrevVec = segment.previous.point.subtract(segment.point),
			    toNextVec = segment.next.point.subtract(segment.point);

			if (toPrevVec.length < 17) startIndex = index;
			if (toNextVec.length < 17) endIndex = index;
		}, this);

		if (startIndex > endIndex) {
			var temp = endIndex;
			endIndex = startIndex;
			startIndex = temp;
		}

		wallPath.segments.forEach(function (segment, index) {

			if (!(index >= startIndex && index <= endIndex)) longestSides.push(segment.point);
		}, this);

		var sidePath = new paper.Path(longestSides);
		sidePath.strokeColor = '#735fc0';
		sidePath.strokeWidth = 4;

		addHatch(sidePath);

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;

		function addHatch(path) {
			var length = path.length,
			    hatchDistance = 15,
			    hatchNumber = Math.floor(length / hatchDistance);

			for (var i = 0; i < hatchNumber; i++) {
				var hatchStart = path.getPointAt(i * hatchDistance),
				    hatchLength = Math.random() * 24 + 3,
				    tang = path.getTangentAt(i * hatchDistance).normalize(hatchLength),
				    norm = path.getNormalAt(i * hatchDistance).normalize(-hatchLength),
				    hatchVec = tang.add(norm);

				if (hatchVec.x > 0 && hatchVec.y > 0) {
					hatchVec.x = -hatchVec.x;
				}
				if (hatchVec.y < 0 && hatchVec.x < 0) {
					hatchVec.x = -hatchVec.x;
				}

				var hatchEnd = hatchStart.add(hatchVec);

				var hatch = new paper.Path([hatchStart, hatchEnd]);
				hatch.strokeColor = '#735fc0';
				hatch.strokeWidth = 2;
				hatch.opacity = 0.7;
			}
		}

		function extrude(path, otherSideDepth, thisSideDepth) {
			var bisecs = [],
			    otherSide = false;
			path.segments.forEach(function (segment) {
				var toNextVec = segment.next.point.subtract(segment.point),
				    toPrevVec = segment.previous.point.subtract(segment.point);

				var localDepth = otherSide ? otherSideDepth : thisSideDepth;

				if (toNextVec.length <= 17) {
					var bisec = toNextVec.normalize(localDepth);
					otherSide = !otherSide;
				} else if (toPrevVec.length <= 17) {
					var bisec = toPrevVec.normalize(localDepth);
				} else {
					toNextVec = toNextVec.normalize(localDepth);
					toPrevVec = toPrevVec.normalize(localDepth);
					var bisec = toNextVec.add(toPrevVec);
				}

				bisecs.push(bisec);
			}, this);

			for (var s in path.segments) {
				var newPoint = path.segments[s].point.add(bisecs[s]);
				if (path.contains(newPoint)) {
					path.segments[s].point = path.segments[s].point.add(bisecs[s]);
				} else {
					path.segments[s].point = path.segments[s].point.subtract(bisecs[s]);
				}
			}
		}
	},

	generateWallShadow: function generateWallShadow(state, vertices, width, height) {
		this.state = state;

		var textureCanvas = document.createElement('canvas'),
		    offset = 20;

		textureCanvas.width = (width + 2 * offset) / window.devicePixelRatio;
		textureCanvas.height = (height + 2 * offset) / window.devicePixelRatio;

		var textureName = 'wallTexture' + this.textureNameArray.length;

		//var textureCanvas = this.state.textures.createCanvas(textureName, width, height);

		paper.setup(textureCanvas);

		var segments = vertices.map(function (vertex) {
			return new paper.Point(vertex[0] + offset, vertex[1] + offset);
		}, this);

		segments.pop();

		var paths = [];

		var wallPath = new paper.Path(segments);
		wallPath.fillColor = 'black';
		wallPath.closed = true;
		wallPath.opacity = 0.3;

		paper.view.scale(1 / window.devicePixelRatio, new paper.Point(0, 0));

		paper.view.draw();

		this.state.textures.addCanvas(textureName, textureCanvas);

		//var spriteSheetName = 'wallTexture'+this.textureNameArray.length;

		this.textureArray.push(textureCanvas);
		this.textureNameArray.push(textureName);

		paper.project.remove();

		return textureName;
	},

	clearTextures: function clearTextures() {
		//console.log('clear textures called');
		this.texturesBin = this.textureNameArray.slice();
		this.textureArray = [];
		this.textureNameArray = [];
	},

	clearBin: function clearBin() {
		//console.log('clear bin called');
		//console.log(this.texturesBin);
		this.texturesBin.forEach(function (textureName) {
			//console.log(textureName);
			this.state.textures.remove(textureName);
		}, this);
		this.texturesBin = [];
	}

};

module.exports = wallGenerator;

/***/ }),

/***/ 524:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GWall = __webpack_require__(525);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);

var FreeDoor = exports.FreeDoor = function (_GWall) {
	_inherits(FreeDoor, _GWall);

	function FreeDoor(scene, edges, wallNumber, wallTextureData) {
		_classCallCheck(this, FreeDoor);

		var _this = _possibleConstructorReturn(this, (FreeDoor.__proto__ || Object.getPrototypeOf(FreeDoor)).call(this, scene, edges, wallNumber, wallTextureData));

		_this.rocketateType = RocketateTypeDict.freeDoor;
		return _this;
	}

	_createClass(FreeDoor, [{
		key: 'drawTexture',
		value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
			return wallGenerator.generateFreeDoor(scene, edgeVertices, wallWidth, wallHeight);
		}
	}]);

	return FreeDoor;
}(GWall);

module.exports = FreeDoor;

/***/ }),

/***/ 525:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wall = __webpack_require__(98);
var wallGenerator = __webpack_require__(40);

var GWall = exports.GWall = function (_Wall) {
	_inherits(GWall, _Wall);

	function GWall(scene, edges, wallNumber, wallTextureData) {
		_classCallCheck(this, GWall);

		var _this = _possibleConstructorReturn(this, (GWall.__proto__ || Object.getPrototypeOf(GWall)).call(this, scene, edges, wallNumber, wallTextureData));

		_this.movability = 3;
		_this.lastCorrPriority = _this.movability;
		_this.constraints = { x: { '1': _this.movability, '-1': _this.movability }, y: { '1': _this.movability, '-1': _this.movability } };
		_this.acceleration = 0.4;
		return _this;
	}

	_createClass(GWall, [{
		key: 'drawTexture',
		value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
			return wallGenerator.generateGWall(scene, edgeVertices, wallWidth, wallHeight);
		}
	}, {
		key: 'update',
		value: function update(time, delta) {
			/*if (this.wallNumber === '4') {
             //console.log(this.lastCorrection);
             console.log('update______________');
         }*/
			this.updateShadow();
			this.vel.x = 0;
			this.vel.y = Math.min(8, this.vel.y + this.acceleration * delta / (1000 / 60));
			//if (this.acceleration === 0) console.log('zero acceleration wall');
			//this.acceleration = Math.min(this.acceleration + 0.1, 0.5);		
			this.velCorrected = false;
			this.lastCorrection = new Phaser.Math.Vector2();
			this.constraints = { x: { '1': this.movability, '-1': this.movability }, y: { '1': this.movability, '-1': this.movability } };
			this.lastCorrPriority = this.movability;
			this.resolvedPairs = [];
			this.unresolvedPairs = [];
		}
	}]);

	return GWall;
}(Wall);

module.exports = GWall;

/***/ }),

/***/ 526:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlainCollider = __webpack_require__(116);
var Wall = __webpack_require__(98);
var LavaWall = __webpack_require__(527);
var RocketateTypeDict = __webpack_require__(29);

var Bouncy = exports.Bouncy = function (_Phaser$GameObjects$S) {
    _inherits(Bouncy, _Phaser$GameObjects$S);

    function Bouncy(scene, xPos, yPos) {
        _classCallCheck(this, Bouncy);

        var _this = _possibleConstructorReturn(this, (Bouncy.__proto__ || Object.getPrototypeOf(Bouncy)).call(this, scene, xPos, yPos, 'bouncy', 'blink0'));

        scene.add.existing(_this);
        var frameNamesIdle = [{ key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink1' }, { key: 'bouncy', frame: 'blink2' }, { key: 'bouncy', frame: 'blink3' }, { key: 'bouncy', frame: 'blink2' }, { key: 'bouncy', frame: 'blink1' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'blink0' }, { key: 'bouncy', frame: 'turn0' }, { key: 'bouncy', frame: 'turn1' }, { key: 'bouncy', frame: 'turn2' }, { key: 'bouncy', frame: 'turn3' }, { key: 'bouncy', frame: 'turn3' }, { key: 'bouncy', frame: 'turn3' }, { key: 'bouncy', frame: 'turn3' }, { key: 'bouncy', frame: 'turn3' }, { key: 'bouncy', frame: 'turn2' }, { key: 'bouncy', frame: 'turn1' }, { key: 'bouncy', frame: 'turn0' }];
        var frameNamesFly = scene.anims.generateFrameNames('bouncy', { prefix: 'fly', start: 0, end: 5 });
        /*[
        {key: 'bouncy', frame: 'fly0'},
        {key: 'bouncy', frame: 'fly1'},
        ];*/

        var frameNamesShock = scene.anims.generateFrameNames('bouncy', { prefix: 'shock', start: 0, end: 3 });
        //console.log(frameNamesShock);
        _this.idleAnimation = scene.anims.create({ key: 'idle', frames: frameNamesIdle, repeat: -1, frameRate: 8 });
        _this.idleAnimation.repeatDelay = 4000;
        _this.flyAnimation = scene.anims.create({ key: 'fly', frames: frameNamesFly, repeat: -1, frameRate: 8 });
        _this.shockAnimation = scene.anims.create({ key: 'shock', frames: frameNamesShock, repeat: 1, frameRate: 12 });
        _this.play('idle');

        var topLeft = _this.getTopLeft(),
            bottomRight = _this.getBottomRight();

        _this.vertices = [[[topLeft.x, topLeft.y], [bottomRight.x, topLeft.y], [bottomRight.x, bottomRight.y], [topLeft.x, bottomRight.y]]];

        _this.vel = new Phaser.Math.Vector2();
        _this.movability = 2;
        _this.velCorrected = false;
        _this.lastCorrection = new Phaser.Math.Vector2();
        _this.correctionDirection = new Phaser.Math.Vector2();
        _this.lastCorrPriority = _this.movability;
        _this.inLava = false;
        _this.constraints = { x: { '1': _this.movability, '-1': _this.movability }, y: { '1': _this.movability, '-1': _this.movability } };
        _this.acceleration = 0.4;

        _this.setDepth(10);

        if (scene.game.renderer.type === 1) {
            _this.thrustSmokeSprite = scene.add.sprite(_this.x - _this.displayWidth * 0.25, _this.y + _this.displayHeight * 0.5, 'engineSmoke');
            var smokeAnimationNames = scene.anims.generateFrameNames('engineSmoke', { start: 1, end: 6 });
            _this.smokeAnimation = scene.anims.create({ key: 'smokeAnimation', frames: smokeAnimationNames,
                repeat: -1, frameRate: 12 });
            _this.thrustSmokeSprite.setOrigin(0.6, 0.05);
            _this.thrustSmokeSprite.alpha = 0;
            _this.thrustSmokeSprite.setDepth(10);
        } else {

            _this.engineParticles = scene.add.particles('engineParticle');
            _this.engineParticles.setDepth(13);

            _this.engineEmitter = _this.engineParticles.createEmitter({
                x: _this.x,
                y: _this.y,
                lifespan: 100,
                frequency: 10,
                speed: 5, //{max: 50, min: 10},
                angle: 90,
                scale: { start: 1, end: 0.5 },
                alpha: { start: 1, end: 0 }
                //tint: {start: 0xff6016, end: 0xffffff}
                //blendMode: 'ADD'
            });
            _this.engineEmitter.stop();

            _this.smokeParticles = scene.add.particles('smokeParticle');
            _this.smokeParticles.setDepth(12);

            _this.smokeEmitter = _this.smokeParticles.createEmitter({
                x: _this.x,
                y: _this.y,
                lifespan: 500,
                frequency: 30,
                speed: { min: 100, max: 200 },
                angle: { min: 135, max: 180 },
                scale: { end: 0.4 * Math.random(), start: 0.7 + Math.random() * 0.3 },
                alpha: 1,
                accelerationX: 150,
                //alpha: {start: 1, end: 0.2},
                blendMode: 'ADD'
            });
            _this.smokeEmitter.stop();
            _this.smokeEmitter.onParticleEmit(_this.launchParticleShadow, _this);

            _this.smokeShadowParticles = scene.add.particles('smokeParticle');
            _this.smokeShadowParticles.setDepth(11);

            _this.smokeShadowEmitter = _this.smokeShadowParticles.createEmitter({
                x: _this.x,
                y: _this.y,
                lifespan: 500,
                alpha: 1,
                accelerationX: 150,
                tint: 0x4e4f59
            });
            _this.smokeShadowEmitter.stop();
        }

        _this.fuelCapacity = 100;
        _this.currentFuel = 100;
        _this.currentThrust = 0;

        _this.fromGroundLaunch = false;
        _this.accelerationCount = 0;

        _this.dustSplashRight = scene.add.sprite(bottomRight.x, bottomRight.y, 'dustSplash');
        _this.dustSplashRight.alpha = 0;
        _this.dustSplashRight.setOrigin(0, 1);
        _this.dustSplashRight.setDepth(10);

        _this.dustSplashLeft = scene.add.sprite(topLeft.x, bottomRight.y, 'dustSplash');
        _this.dustSplashLeft.alpha = 0;
        _this.dustSplashLeft.setOrigin(1, 1);
        _this.dustSplashLeft.setDepth(10);
        _this.dustSplashLeft.setFlipX(true);

        //console.log(scene.anims.generateFrameNames('dustSplash', {start: 1, end: 16}));
        var dustFrames = [{ key: 'dustSplash', frame: '1' }, { key: 'dustSplash', frame: '2' }, { key: 'dustSplash', frame: '3' }, { key: 'dustSplash', frame: '4' }, { key: 'dustSplash', frame: '5' }, { key: 'dustSplash', frame: '6' }, { key: 'dustSplash', frame: '7' }, { key: 'dustSplash', frame: '8' }, { key: 'dustSplash', frame: '9' }, { key: 'dustSplash', frame: '10' }, { key: 'dustSplash', frame: '11' }, { key: 'dustSplash', frame: '12' }, { key: 'dustSplash', frame: '13' }, { key: 'dustSplash', frame: '14' }, { key: 'dustSplash', frame: '15' }, { key: 'dustSplash', frame: '16' }];

        _this.dustSplashAnimation = scene.anims.create({ key: 'dustSplash', frames: dustFrames, repeat: 0, frameRate: 32 });
        _this.dustSplashRight.on('animationcomplete', _this.hideDust, _this);
        //console.log(scene.anims.generateFrameNames('dustSplash', {start: 1, end: 16}));

        _this.inGroundContact = false;
        _this.inShock = false;

        // sounds 
        _this.bumpSound = scene.sound.add('bumpSound');
        // cold and ice walls
        _this.iceProduction = false;
        _this.coldWallTop = null;
        _this.onIce = false;
        _this.iceWall = null;

        _this.rocketateType = RocketateTypeDict.bouncy;

        return _this;
    }

    _createClass(Bouncy, [{
        key: 'launchParticleShadow',
        value: function launchParticleShadow(particle) {
            var scale = particle.scaleX,
                velX = particle.velocityX,
                velY = particle.velocityY;

            //console.log(particle);

            this.smokeShadowEmitter.setSpeedX(velX);
            this.smokeShadowEmitter.setSpeedY(velY);
            this.smokeShadowEmitter.setScale({ start: scale * 1.2, end: 0.4 });

            this.smokeShadowEmitter.emitParticle();
        }
    }, {
        key: 'velCorrection',
        value: function velCorrection(origCorrection, point, normal, otherObject, pair) {
            if (!ultimate) var ultimate = { x: false, y: false };

            var priority = otherObject.constraints,
                pushBack = new Phaser.Math.Vector2(),
                ultimatePushBack = { x: false, y: false };

            if (!this.velCorrected) this.velCorrected = true;

            var correction = origCorrection.clone();
            correction.multiply(normal);

            /*console.log('correction in bouncy');
            console.log(correction);
            console.log('comes from');
            console.log(otherObject);*/

            for (var axis in this.constraints) {

                if (correction[axis] != 0) {

                    var corrSign = Math.abs(correction[axis]) / correction[axis],
                        cSign = -corrSign;

                    if (this.constraints[axis][cSign] != 0 || this.constraints[axis][corrSign] != 0) {

                        if (this.constraints[axis][cSign] > priority[axis][corrSign] || ultimate[axis]) {

                            this.lastCorrection[axis] += correction[axis];
                        } else if (this.constraints[axis][cSign] < priority[axis][corrSign]) {
                            pushBack[axis] = correction[axis];
                        } else if (this.constraints[axis][cSign] == priority[axis][corrSign]) {
                            // get share of correction this object is responsible
                            if (Math.abs(otherObject.vel[axis] + otherObject.lastCorrection[axis]) + Math.abs(this.vel[axis] + this.lastCorrection[axis]) > 0) {
                                var objectShare = Math.abs(this.vel[axis] + this.lastCorrection[axis]) / (Math.abs(otherObject.vel[axis] + otherObject.lastCorrection[axis]) + Math.abs(this.vel[axis] + this.lastCorrection[axis]));

                                this.lastCorrection[axis] += correction[axis] * objectShare;
                                pushBack[axis] = correction[axis] * (1 - objectShare);

                                ultimatePushBack[axis] = true;
                            } else {
                                this.lastCorrection[axis] += correction[axis];
                            }
                        }
                    } else {
                        //console.log('alt in bouncy');

                        var currentVel = new Phaser.Math.Vector2();
                        currentVel.add(this.vel);
                        currentVel.add(this.lastCorrection);

                        if (Math.abs(currentVel.dot(correction)) < 0.001 && currentVel.length() > 0.001) {
                            var altNormal = new Phaser.Math.Vector2(1, 1);
                            altNormal.subtract(normal);

                            this.velCorrection(origCorrection, point, altNormal, otherObject, pair, ultimate);
                        } else {
                            pushBack[axis] = correction[axis];
                        }
                    }

                    this.constraints[axis][corrSign] = Math.min(priority[axis][corrSign], this.constraints[axis][corrSign]);
                }
            }

            if (otherObject.electric && !this.inLava) {
                this.inLava = true;
            }

            if (!this.fromGroundLaunch && Math.abs(normal.y) - 1 < 0.1 && point[0].y > this.y) {
                this.fromGroundLaunch = true;
                if (otherObject.cold) {
                    this.iceProduction = true;
                    this.coldWallTop = this.getBottomRight().y;
                }

                if (otherObject.ice) {
                    this.onIce = true;
                    this.iceWall = otherObject;
                }
            }

            return { vector: pushBack, ultimate: ultimatePushBack };
        }
    }, {
        key: 'collidedWith',
        value: function collidedWith(otherObject) {
            if (otherObject.electric && !this.inLava) {
                this.inLava = true;
            }
        }
    }, {
        key: 'updateVel',
        value: function updateVel() {
            /*if (this.reporting)
            {
            	console.log('updtae vel bopuncy');
            	console.log(this.lastCorrection);
            	console.log(this.vel);
            }*/
            this.vel.add(this.lastCorrection);
        }
    }, {
        key: 'thrust',
        value: function thrust(thrustVal) {
            this.currentThrust = thrustVal;
        }
    }, {
        key: 'update',
        value: function update(time, delta) {
            this.vel.x = 0;
            //if (this.currentThrust > 0) this.acceleration = 0.5;
            this.vel.y = Math.max(Math.min(8, this.vel.y + (this.acceleration - this.currentThrust) * delta / (1000 / 60)), -9);
            //if (this.acceleration === 0) console.log('zero acceleration bouncy');
            //this.acceleration = Math.min(this.acceleration + 0.1, 0.5);
            this.velCorrected = false;
            this.currentThrust = 0;
            this.lastCorrection = new Phaser.Math.Vector2();
            this.lastCorrPriority = this.movability;
            this.constraints = { x: { '1': this.movability, '-1': this.movability }, y: { '1': this.movability, '-1': this.movability } };
            this.resolvedPairs = [];
            this.unresolvedPairs = [];
            if (this.fromGroundLaunch && !this.inGroundContact) {
                this.launchDust();
                this.inGroundContact = true;
            } else if (!this.fromGroundLaunch) {
                this.inGroundContact = false;
            }
            this.fromGroundLaunch = false;
            // cold and ice walls
            this.onIce = false;
            this.iceWall = null;
        }
    }, {
        key: 'tankUp',
        value: function tankUp(fuelAmount) {
            this.currentFuel = Math.min(this.fuelCapacity, this.currentFuel + fuelAmount);
            this.emit('tankUp');
        }
    }, {
        key: 'launchDust',
        value: function launchDust() {
            //console.log('launch dust called');
            var bottomRight = this.getBottomRight(),
                topLeft = this.getTopLeft();

            this.dustSplashRight.x = bottomRight.x;
            this.dustSplashRight.y = bottomRight.y;

            this.dustSplashLeft.x = topLeft.x;
            this.dustSplashLeft.y = bottomRight.y;

            this.dustSplashRight.alpha = 1;
            this.dustSplashLeft.alpha = 1;

            this.dustSplashAnimation.resume();

            this.dustSplashRight.play('dustSplash');
            this.dustSplashLeft.play('dustSplash');

            if (!this.scene.game.soundPaused) this.bumpSound.play();
        }
    }, {
        key: 'hideDust',
        value: function hideDust() {
            this.dustSplashRight.alpha = 0;
            this.dustSplashLeft.alpha = 0;
        }
    }]);

    return Bouncy;
}(Phaser.GameObjects.Sprite);

module.exports = Bouncy;

/***/ }),

/***/ 527:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Wall = __webpack_require__(98);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);

var LavaWall = exports.LavaWall = function (_Wall) {
	_inherits(LavaWall, _Wall);

	function LavaWall(scene, edges, wallNumber, wallTextureData) {
		_classCallCheck(this, LavaWall);

		var _this = _possibleConstructorReturn(this, (LavaWall.__proto__ || Object.getPrototypeOf(LavaWall)).call(this, scene, edges, wallNumber, wallTextureData.textureName));

		_this.electric = true;

		if (wallTextureData.framePoints) {
			_this.definePosition(edges);
			_this.createFlashPaths(wallTextureData.framePoints);
		}

		_this.rocketateType = RocketateTypeDict.lavaWall;
		return _this;
	}

	_createClass(LavaWall, [{
		key: 'drawTexture',
		value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
			var wallTextureData = wallGenerator.generateLavaWall(scene, edgeVertices, wallWidth, wallHeight),
			    alignedFramePoints = wallTextureData.framePoints;

			this.createFlashPaths(alignedFramePoints, this.leftPointWall, this.topPointWall);

			return wallTextureData.textureName;
		}
	}, {
		key: 'createFlashPaths',
		value: function createFlashPaths(alignedFramePoints) {
			// at graphics factory points are built aligned to (0, 0)
			// so need to add top left corner back
			this.framePoints = alignedFramePoints.map(function (point) {
				return new Phaser.Math.Vector2(point.x + this.leftPointWall, point.y + this.topPointWall);
			}, this);

			this.updatePaths();

			this.follower = { t: 0, vec: new Phaser.Math.Vector2(), angleVec: new Phaser.Math.Vector2() };

			this.flashTween = this.scene.tweens.add({
				targets: this.follower,
				t: 1,
				ease: 'Linear',
				duration: this.distance * 3,
				yoyo: true,
				repeat: -1
			});

			this.step = 108 / this.distance;

			this.flashSprite = this.scene.add.sprite(this.framePoints[0].x, this.framePoints[0].y, 'flash');
			this.flashSprite.setDepth(11);
			//this.flashSprite.setScale(0.7);
			this.flashSprite.setOrigin(0, 0.5);

			this.flashShine = this.scene.add.sprite(this.x, this.y, 'wallFlashShine');
			this.flashShine.setDepth(10);
			//this.flashShine.setBlendMode(Phaser.BlendModes.ADD);
			this.flashShine.alpha = 0;

			if (this.step >= 1) {
				this.flashSprite.setScale(1 / this.step, 1);
				this.flashShine.setScale(1 / this.step, 1);
			}

			if (!this.scene.anims.get('flashMain')) {
				this.mainAnim = this.scene.anims.create({ key: 'flashMain', frames: this.scene.anims.generateFrameNames('flash', { start: 1, end: 6 }),
					repeat: -1, frameRate: 10 });
			} else {
				this.mainAnim = this.scene.anims.get('flashMain');
			}

			this.mainAnim.pause();

			//this.flashSprite.play('flashMain');
			this.flashSprite.alpha = 0;

			this.inRotation = false;

			//this.alphaEvent = this.scene.time.delayedCall(600 + 400*Math.random(), this.changeDischargeAlpha, [], this);
		}
	}, {
		key: 'updatePaths',
		value: function updatePaths() {
			var currentDistance = 0;

			if (this.flashPath) {
				this.flashPath.destroy();
			}

			this.flashPath = this.scene.add.path();

			/*if (this.anglePath)
   {
   	this.anglePath.destroy();			
   }*/

			//this.anglePath = this.scene.add.path();

			for (var p = 0; p < this.framePoints.length - 1; p++) {
				var line = new Phaser.Curves.Line([this.framePoints[p].x, this.framePoints[p].y, this.framePoints[p + 1].x, this.framePoints[p + 1].y]);
				this.flashPath.add(line);

				var toNextVec = new Phaser.Math.Vector2(this.framePoints[p + 1].x - this.framePoints[p].x, this.framePoints[p + 1].y - this.framePoints[p].y),

				//toNextAngle = toNextVec.angle(),
				toNextDistance = toNextVec.length();

				/*var angleLine = new Phaser.Curves.Line([currentDistance, toNextAngle,
    	currentDistance+toNextDistance, toNextAngle]);
    this.anglePath.add(angleLine);*/

				currentDistance += toNextDistance;
			}

			this.distance = currentDistance;
		}
	}, {
		key: 'rotateFramePoints',
		value: function rotateFramePoints(angle, center) {
			this.framePoints.forEach(function (point) {
				var newPoint = new Phaser.Math.Vector2(point.x - center.x, point.y - center.y),
				    rotateMatrix = new Phaser.Math.Matrix3();

				rotateMatrix.fromArray([Math.cos(angle), Math.sin(angle), 0, -Math.sin(angle), Math.cos(angle), 0, 0, 0]);
				newPoint.transformMat3(rotateMatrix);
				newPoint.add(new Phaser.Math.Vector2(center.x, center.y));

				point.copy(newPoint);
			}, this);
		}
	}, {
		key: 'rotateFlash',
		value: function rotateFlash(angle, center) {
			this.flashSprite.setRotation(this.flashSprite.rotation + angle);

			var newPoint = new Phaser.Math.Vector2(this.flashSprite.x - center.x, this.flashSprite.y - center.y),
			    rotateMatrix = new Phaser.Math.Matrix3();

			rotateMatrix.fromArray([Math.cos(angle), Math.sin(angle), 0, -Math.sin(angle), Math.cos(angle), 0, 0, 0]);
			newPoint.transformMat3(rotateMatrix);
			newPoint.add(new Phaser.Math.Vector2(center.x, center.y));

			this.flashSprite.setPosition(newPoint.x, newPoint.y);
		}
	}, {
		key: 'startRotation',
		value: function startRotation(angle, center) {
			this.flashSprite.alpha = 0;
			this.flashShine.alpha = 0;
			this.rotateFramePoints(angle, center);
			this.rotateFlash(angle, center);
			this.flashTween.pause();
			this.inRotation = true;
			//this.alphaEvent.destroy();
		}
	}, {
		key: 'endRotation',
		value: function endRotation() {
			/*this.flashSprite.alpha = 1;
   this.flashShine.alpha = 1;
   	this.flashShine.setPosition(this.flashSprite.x + this.flashSprite.displayWidth/2, 
   	this.flashSprite.y);
   this.flashShine.setRotation(this.flashSprite.rotation);
   this.flashShine.alpha = 1;*/

			this.flashTween.resume();
			this.updatePaths();
			this.inRotation = false;
			//this.alphaEvent = this.scene.time.delayedCall(600 + 400*Math.random(), this.changeDischargeAlpha, [], this);
		}
	}, {
		key: 'changeDischargeAlpha',
		value: function changeDischargeAlpha() {
			if (this && !this.inRotation) {
				if (this.flashSprite.alpha === 0) {
					this.flashSprite.alpha = 1;
					this.flashSprite.play('flashMain');
					this.mainAnim.resume();
					if (!this.inRotation) {

						var point1 = this.flashPath.getPoint(this.follower.t);

						if (this.follower.t + this.step <= 1) var point2 = this.flashPath.getPoint(this.follower.t + this.step);else if (this.follower.t - this.step >= 0) var point2 = this.flashPath.getPoint(this.follower.t - this.step);else {
							point1 = this.flashPath.getPoint(0);

							var point2 = this.flashPath.getPoint(1);
						}

						this.flashSprite.setPosition(point1.x, point1.y);
						var rotation = point2.subtract(point1).angle();
						this.flashSprite.setRotation(rotation);

						this.flashShine.setPosition((2 * point1.x + point2.x) * 0.5, (2 * point1.y + point2.y) * 0.5);
						this.flashShine.setRotation(rotation);
						this.flashShine.alpha = 1;

						/*this.flashPath.getPoint(this.follower.t, this.follower.vec);
      this.flashSprite.setPosition(this.follower.vec.x, this.follower.vec.y);
      	this.anglePath.getPoint(this.follower.t, this.follower.angleVec);
      this.flashSprite.setRotation(this.follower.angleVec.y);*/
					}
				} else {
					this.flashSprite.alpha = 0;
					this.flashShine.alpha = 0;
					this.mainAnim.pause();
				}
				//this.alphaEvent = this.scene.time.delayedCall(600 + 400*Math.random(), this.changeDischargeAlpha, [], this);
			}
		}

		/*update(time, delta)
  {
  	super.update(time, delta);
  		if (!this.inRotation)
  	{
  			this.flashPath.getPoint(this.follower.t, this.follower.vec);
  		this.flashSprite.setPosition(this.follower.vec.x, this.follower.vec.y);
  			this.anglePath.getPoint(this.follower.t, this.follower.angleVec);
  		//console.log(this.follower.angleVec.x);
  		this.flashSprite.setRotation(this.follower.angleVec.y);
  	}
  }*/

	}]);

	return LavaWall;
}(Wall);

module.exports = LavaWall;

/***/ }),

/***/ 528:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var CustomPipeline = new Phaser.Class({

    Extends: Phaser.Renderer.WebGL.Pipelines.TextureTintPipeline,

    initialize: function CustomPipeline(game) {
        Phaser.Renderer.WebGL.Pipelines.TextureTintPipeline.call(this, {
            game: game,
            renderer: game.renderer,
            fragShader: "\n                precision mediump float;\n                uniform sampler2D uMainSampler;\n                varying vec2 outTexCoord;\n                void main(void) {\n                vec4 color = texture2D(uMainSampler, outTexCoord);\n                float gray = dot(color.rgb, vec3(0.299, 0.587, 0.114));\n                gl_FragColor = vec4(vec3(gray), 1.0);\n                }"
        });
    }
});

module.exports = CustomPipeline;

/***/ }),

/***/ 529:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__(253);

__webpack_require__(250);

__webpack_require__(251);

var _PlayScene = __webpack_require__(1422);

var _PreloaderScene = __webpack_require__(1433);

var _MainMenuScene = __webpack_require__(1434);

var _LevelChoiceScene = __webpack_require__(1435);

var _BootScene = __webpack_require__(1436);

function detectMob() {
    if (navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/webOS/i) || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/BlackBerry/i) || navigator.userAgent.match(/Windows Phone/i) || window.innerWidth <= 800 && window.innerHeight <= 600) {
        return true;
    } else {
        return false;
    }
}

var gameanalytics = __webpack_require__(251);
//gameanalytics.GameAnalytics.setEnabledInfoLog(true);
gameanalytics.GameAnalytics.configureBuild('html1.0.0');
gameanalytics.GameAnalytics.initialize("5fcd52b042666cc1a781d4846d2fc837", "48b42ac65a670e5df16502270d3d520e877aed64");

// detect mobile

var isMobile = detectMob();

// detect mobile safari

var ua = window.navigator.userAgent;
var iOS = !!ua.match(/iPad/i) || !!ua.match(/iPhone/i);
var webkit = !!ua.match(/WebKit/i);
var iOSSafari = iOS && webkit && !ua.match(/CriOS/i);

var defaultWidth;
var defaultHeight;

if (isMobile) {
    console.log('is mobile');
    defaultWidth = window.innerWidth; //Math.min(document.documentElement.clientWidth, document.documentElement.clientHeight);
    defaultHeight = window.innerHeight; //Math.max(document.documentElement.clientWidth, document.documentElement.clientHeight);    
    var config = {
        type: iOSSafari ? Phaser.CANVAS : Phaser.AUTO,
        scale: {
            mode: Phaser.Scale.NONE,
            parent: 'gameContainer',
            //autoCenter: Phaser.Scale.CENTER_BOTH,
            width: defaultWidth,
            height: defaultHeight
        },
        backgroundColor: '#3d3752',
        scene: [_BootScene.BootScene, _PreloaderScene.PreloaderScene, _MainMenuScene.MainMenuScene, _LevelChoiceScene.LevelChoiceScene, _PlayScene.PlayScene]
    };
} else {
    console.log('is desktop');
    defaultWidth = 600;
    defaultHeight = 600;
    var config = {
        type: Phaser.AUTO,
        scale: {
            mode: Phaser.Scale.NONE,
            parent: 'gameContainer',
            //autoCenter: Phaser.Scale.CENTER_BOTH,
            width: defaultWidth,
            height: defaultHeight
        },
        backgroundColor: '#3d3752',
        scene: [_BootScene.BootScene, _PreloaderScene.PreloaderScene, _MainMenuScene.MainMenuScene, _LevelChoiceScene.LevelChoiceScene, _PlayScene.PlayScene]
    };
}

//console.log(gameanalytics.GameAnalytics);

var game = new Phaser.Game(config);
window.game = game;

document.addEventListener("pause", handlePause, false);

document.addEventListener("resume", handleResume, false);

document.addEventListener("backbutton", handlePause, false);

function handlePause() {
    console.log('handele pause called');
    game.scene.scenes.forEach(function (scene) {
        if (scene.sys.isActive()) {
            console.log(scene);
            scene.sys.pause();
        }
    }, this);
    game.sound.pauseAll();
}

function handleResume() {
    console.log('handele resume called');
    game.scene.scenes.forEach(function (scene) {
        if (scene.sys.isPaused()) {
            console.log(scene);
            scene.sys.resume();
        }
    }, this);
    if (!game.soundPaused) game.sound.resumeAll();
}

window.addEventListener('resize', windowResized);

//if (game.isBooted) windowResized();else game.events.once('ready', windowResized);

window.onload = function () {
    window.windowResized();
};

function windowResized() {
    console.log('resized called');
    if (game.device.os.desktop) {
        console.log(game.scene.getScenes(true));
        //console.log('window resized');
        var w = window.innerWidth,
            h = window.innerHeight;

        var scaleW = Math.min(w / defaultWidth, 1),
            scaleH = Math.min(h / defaultHeight, 1),
            scale = Math.min(scaleW, scaleH);

        game.canvas.setAttribute('style', ' -ms-transform: scale(' + scale + '); -webkit-transform: scale3d(' + scale + ', 1);' + ' -moz-transform: scale(' + scale + '); -o-transform: scale(' + scale + '); transform: scale(' + scale + ');' + ' transform-origin: center center;');

        if (scale < 1) {

            if (scaleH < 1) {
                var gameHeight = h / scaleH;
            } else {
                var gameHeight = defaultHeight;
            }

            if (scaleW < 1) {
                var gameWidth = w / scaleW;
            } else {
                var gameWidth = defaultWidth;
            }

            game.scale.resize(gameWidth, gameHeight);

            /*game.scene.scenes.forEach(function(scene){
            	if (scene.cameras.main) scene.cameras.main.setViewport(0, 0, gameWidth, gameHeight);
            }, this);*/
        }
    } else {
        console.log('resize on non desktop device');
        if (window.innerWidth < window.innerHeight) {
            //console.log('on portrait resize');

            //var portraitDiv = document.getElementById('wrapper');
            //portraitDiv.setAttribute('style', 'z-index: 0; opacity: 0;');

            window.setTimeout(function () {
                var w = document.documentElement.clientWidth,
                    h = document.documentElement.clientHeight;
                //var w = window.innerWidth,
                //    h = window.innerHeight;

                var scaleW = w / defaultWidth,
                    scaleH = h / defaultHeight,
                    scale = Math.min(scaleW, scaleH);

                //game.canvas.setAttribute('style', ' -ms-transform: scale(' + scale + '); -webkit-transform: scale3d(' + scale + ', 1);' + ' -moz-transform: scale(' + scale + '); -o-transform: scale(' + scale + '); transform: scale(' + scale + ');' + ' transform-origin: center center;');

                var gameWidth = w,
                    // scale,
                gameHeight = h; // scale;

                game.scale.resize(gameWidth, gameHeight);

                /*console.log(window.screen.availWidth);
                console.log(window.screen.availHeight);*/
                /*console.log(window.innerWidth);
                console.log(window.innerHeight);
                console.log(document.documentElement.clientWidth);
                console.log(document.documentElement.clientHeight);*/
                //console.log(gameWidth);
                //console.log(gameHeight);

                game.scene.scenes.forEach(function (scene) {
                    if (scene.cameras.main) scene.cameras.main.setViewport(0, 0, gameWidth, gameHeight);
                    if (scene.playPortrait && scene.sys.isActive()) {
                        scene.respondPortrait();
                    }
                }, this);
            }, 600);
        } else {
            //console.log('on landscape resize');
            //var portraitDiv = document.getElementById('wrapper');
            //portraitDiv.setAttribute('style', 'z-index: 2; opacity: 1;');
            game.scene.scenes.forEach(function (scene) {

                /*console.log(scene);
                console.log(scene.sys.isActive());*/

                if (scene.playPortrait && scene.sys.isActive()) {
                    //console.log(scene);
                    scene.respondLandscape();
                }
            }, this);
        }
    }
}

window.windowResized = windowResized;

/***/ }),

/***/ 98:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//var Bouncy = require('./Bouncy.js');
//var WoodBox = require('./WoodBox.js');
var PlainCollider = __webpack_require__(116);
var defineOuterVertices = __webpack_require__(158);
var wallGenerator = __webpack_require__(40);
var RocketateTypeDict = __webpack_require__(29);

var Wall = exports.Wall = function (_Phaser$GameObjects$S) {
    _inherits(Wall, _Phaser$GameObjects$S);

    function Wall(scene, edges, wallNumber, preparedTexture, shadowTexture) {
        _classCallCheck(this, Wall);

        var _this = _possibleConstructorReturn(this, (Wall.__proto__ || Object.getPrototypeOf(Wall)).call(this, scene));

        _this.definePosition(edges);
        _this.setPosition(_this.leftPointWall + _this.wallWidth / 2, _this.topPointWall + _this.wallHeight / 2);

        var textureName = preparedTexture ? preparedTexture : _this.prepareTexture(edges);
        _this.setTexture(textureName);

        scene.add.existing(_this);

        _this.vel = new Phaser.Math.Vector2();
        _this.movability = 0;
        _this.velCorrected = false;
        _this.lastCorrection = new Phaser.Math.Vector2();
        _this.correctionDirection = new Phaser.Math.Vector2();
        _this.lastCorrPriority = _this.movability;
        _this.constraints = { x: { '1': _this.movability, '-1': _this.movability }, y: { '1': _this.movability, '-1': _this.movability } };
        _this.wallNumber = wallNumber;
        _this.reporting = false;

        _this.setDepth(10);
        _this.vertices = edges;

        _this.scene = scene;

        //!!!! change here to not destroy shadow in main wall

        var shadowTextureName = shadowTexture ? shadowTexture : _this.prepareShadowTexture(edges);

        _this.shadowOffset = new Phaser.Math.Vector2(5, 5);
        _this.shadow = scene.add.image(_this.x + _this.shadowOffset.x, _this.y + _this.shadowOffset.y, shadowTextureName);
        //this.shadow.alpha = 0.3;
        //this.shadow.tint = 0x000000;
        _this.shadow.setDepth(9);

        _this.rocketateType = RocketateTypeDict.wall;

        return _this;
    }

    _createClass(Wall, [{
        key: 'definePosition',
        value: function definePosition(edges) {
            // left, right most and top, bottom points of the wall
            this.leftPointWall = edges.reduce(function (leftWall, currEdge) {
                var currEdgeLeft = currEdge.reduce(function (leftEdge, currVer) {
                    if (leftEdge > currVer[0]) {
                        return currVer[0];
                    }
                    return leftEdge;
                }, currEdge[0][0]);
                if (leftWall > currEdgeLeft) {
                    return currEdgeLeft;
                }
                return leftWall;
            }, edges[0][0][0]);

            this.topPointWall = edges.reduce(function (topWall, currEdge) {
                var currEdgeTop = currEdge.reduce(function (topEdge, currVer) {
                    if (topEdge > currVer[1]) {
                        return currVer[1];
                    }
                    return topEdge;
                }, currEdge[0][1]);
                if (topWall > currEdgeTop) {
                    return currEdgeTop;
                }
                return topWall;
            }, edges[0][0][1]);

            this.rightPointWall = edges.reduce(function (rightWall, currEdge) {
                var currEdgeRight = currEdge.reduce(function (rightEdge, currVer) {
                    if (rightEdge < currVer[0]) {
                        return currVer[0];
                    }
                    return rightEdge;
                }, currEdge[0][0]);
                if (rightWall < currEdgeRight) {
                    return currEdgeRight;
                }
                return rightWall;
            }, edges[0][0][0]);

            this.bottomPointWall = edges.reduce(function (bottomWall, currEdge) {
                var currEdgeBottom = currEdge.reduce(function (bottomEdge, currVer) {
                    if (bottomEdge < currVer[1]) {
                        return currVer[1];
                    }
                    return bottomEdge;
                }, currEdge[0][1]);
                if (bottomWall < currEdgeBottom) {
                    return currEdgeBottom;
                }
                return bottomWall;
            }, edges[0][0][1]);

            this.wallWidth = this.rightPointWall - this.leftPointWall, this.wallHeight = this.bottomPointWall - this.topPointWall;
        }
    }, {
        key: 'prepareTexture',
        value: function prepareTexture(edges) {
            var leftOffset = this.leftPointWall,
                topOffset = this.topPointWall;

            var alignedEdges = edges.map(function (edge) {
                return edge.map(function (vertex) {
                    return [vertex[0] - leftOffset, vertex[1] - topOffset];
                });
            });

            // define vertices for texture
            var edgeVertices = defineOuterVertices(alignedEdges);
            //console.log(edgeVertices);

            // generate texture for sprite
            return this.drawTexture(this.scene, edgeVertices, this.wallWidth, this.wallHeight);
        }
    }, {
        key: 'prepareShadowTexture',
        value: function prepareShadowTexture(edges) {
            var leftOffset = this.leftPointWall,
                topOffset = this.topPointWall;

            var alignedEdges = edges.map(function (edge) {
                return edge.map(function (vertex) {
                    return [vertex[0] - leftOffset, vertex[1] - topOffset];
                });
            });

            // define vertices for texture
            var edgeVertices = defineOuterVertices(alignedEdges);
            //console.log(edgeVertices);

            // generate texture for sprite
            return wallGenerator.generateWallShadow(this.scene, edgeVertices, this.wallWidth, this.wallHeight);
        }
    }, {
        key: 'drawTexture',
        value: function drawTexture(scene, edgeVertices, wallWidth, wallHeight) {
            return wallGenerator.generateWall(scene, edgeVertices, wallWidth, wallHeight);
        }
    }, {
        key: 'getTopOfCollider',
        value: function getTopOfCollider() {
            var topColliderPoint = this.collider.reduce(function (topWallPoint, currEdge) {
                var currEdgeTop = currEdge.reduce(function (topEdgePoint, currSeg) {
                    if (topEdgePoint > currSeg.point.y) {
                        return currSeg.point.y;
                    }
                    return topEdgePoint;
                }, currEdge[0].point);
                if (topWallPoint > currEdgeTop) {
                    return currEdgeTop;
                }
                return topWallPoint;
            }, this.collider[0][0].point.y);

            return topColliderPoint;
        }
    }, {
        key: 'hideShadow',
        value: function hideShadow() {
            this.shadow.alpha = 0;
        }
    }, {
        key: 'updateShadow',
        value: function updateShadow() {
            this.shadow.setPosition(this.x + this.shadowOffset.x, this.y + this.shadowOffset.y);
            this.shadow.rotation = this.rotation;
            if (this.shadow.alpha === 0) {
                this.shadow.alpha = 0.3;
            }
        }
    }, {
        key: 'velCorrection',
        value: function velCorrection(origCorrection, point, normal, otherObject, pair, ultimate) {
            if (!ultimate) var ultimate = { x: false, y: false };

            var priority = otherObject.constraints,
                pushBack = new Phaser.Math.Vector2(),
                ultimatePushBack = { x: false, y: false };

            if (!this.velCorrected) this.velCorrected = true;

            /*if (this.wallNumber === '25' && otherObject.wallNumber === '4')
            {
                 //console.log(otherObject);
                console.log(origCorrection);
                //console.log(normal);
                /*console.log(priority);
                console.log('object collider');
                console.log(this.collider[0][0].point.x);
                console.log(this.collider[0][0].point.y);
                console.log(this.collider[0][1].point.x);
                console.log(this.collider[0][1].point.y);
                console.log('other obj collider');
                console.log(otherObject.collider);
            }*/

            var correction = origCorrection.clone();
            correction.multiply(normal);

            for (var axis in this.constraints) {

                if (correction[axis] != 0) {

                    var corrSign = Math.abs(correction[axis]) / correction[axis],
                        cSign = -corrSign;

                    if (this.constraints[axis][cSign] != 0 || this.constraints[axis][corrSign] != 0) {

                        if (this.constraints[axis][cSign] > priority[axis][corrSign] || ultimate[axis]) {

                            this.lastCorrection[axis] += correction[axis];
                        } else if (this.constraints[axis][cSign] < priority[axis][corrSign]) {
                            pushBack[axis] = correction[axis];
                        } else if (this.constraints[axis][cSign] == priority[axis][corrSign]) {
                            // get share of correction this object is responsible
                            if (Math.abs(otherObject.vel[axis] + otherObject.lastCorrection[axis]) + Math.abs(this.vel[axis] + this.lastCorrection[axis]) > 0) {
                                var objectShare = Math.abs(this.vel[axis] + this.lastCorrection[axis]) / (Math.abs(otherObject.vel[axis] + otherObject.lastCorrection[axis]) + Math.abs(this.vel[axis] + this.lastCorrection[axis]));

                                this.lastCorrection[axis] += correction[axis] * objectShare;
                                pushBack[axis] = correction[axis] * (1 - objectShare);

                                ultimatePushBack[axis] = true;
                            } else {
                                this.lastCorrection[axis] += correction[axis];
                            }
                        }
                    } else {
                        var currentVel = new Phaser.Math.Vector2();
                        currentVel.add(this.vel);
                        currentVel.add(this.lastCorrection);

                        /*if (this.wallNumber === '21')
                        {
                            console.log('for free door');
                            console.log(currentVel);
                            console.log(currentVel.dot(correction));
                        }*/

                        if (Math.abs(currentVel.dot(correction)) < 0.001 && currentVel.length() > 0.001) {
                            /*if (this.wallNumber === '21')
                            {
                                console.log('alt normal from free door');
                            }*/
                            if (this.wallNumber === '1') {
                                console.log('___________alt normal from box __________');
                                console.log('current Vel');
                                console.log(currentVel);
                                console.log(this.lastCorrection);

                                console.log(this);
                                console.log(this.constraints);
                                console.log(correction);
                                console.log(otherObject);
                                console.log(otherObject.constraints);
                            }

                            var altNormal = new Phaser.Math.Vector2(1, 1);
                            altNormal.subtract(normal);

                            this.velCorrection(origCorrection, point, altNormal, otherObject, pair, ultimate);
                        } else {
                            pushBack[axis] = correction[axis];
                        }
                    }

                    this.constraints[axis][corrSign] = Math.min(priority[axis][corrSign], this.constraints[axis][corrSign]);
                }
            }

            /*if (this.wallNumber === '15' && otherObject.wallNumber === '7')
            {
                console.log(this.constraints);
                console.log(this.lastCorrection);
                console.log(this.vel);
                console.log(pushBack);
            }*/

            return { vector: pushBack, ultimate: ultimatePushBack };
        }
    }, {
        key: 'updateVel',
        value: function updateVel() {
            /*if (this.reporting) {
                if (this.wallNumber === '4')
                {
                    console.log('update vel box');                
                    console.log(this.lastCorrection);
                    console.log(this.vel);
                }
                if (this.wallNumber === '6')
                {
                    console.log('update vel door');
                    console.log(this.lastCorrection);
                    console.log(this.vel);
                }
                
            }*/
            this.vel.add(this.lastCorrection);
        }
    }, {
        key: 'update',
        value: function update(time, delta) {

            //console.log(this.wallNumber);
            this.vel = new Phaser.Math.Vector2();
            this.velCorrected = false;
            this.lastCorrection = new Phaser.Math.Vector2();
            this.constraints = { x: { '1': this.movability, '-1': this.movability }, y: { '1': this.movability, '-1': this.movability } };
            this.lastCorrPriority = this.movability;
            this.resolvedPairs = [];
            this.unresolvedPairs = [];
        }
    }]);

    return Wall;
}(Phaser.GameObjects.Sprite);

module.exports = Wall;

/***/ })

},[529]);